/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "CDirDirectory.h"
   #include "CDirDirectory.h"
   #include "CDirectoryTree.h"
   
   #include<assert.h>
   
   #include "CDirFile.h"

                  
              
	          
                  
                  
              CDirDirectory::CDirDirectory(CDirectoryTree* pt, CDirDirectory* pn)  : CDirectoryItem(pt, pn) 
   {
  
	          
                  
                  
              
   };
   CDirDirectory::~CDirDirectory()
   {
      
          clearChildren();
      
	          
                  
                  
              
   };
   CDirFile* CDirDirectory::getFile(const CUtiString& path, bool create)
	   {
           
		    CDirectoryItem* item = getNodeByPath(path, 0, create);
		    if (!item) return NULL;
		    if (!dynamic_cast<CDirFile*>(item)) return NULL;
		    return (CDirFile*)item;
		 
	   };
           CDirDirectory* CDirDirectory::getDirectory(const CUtiString& path, bool create)
	   {
           
		    CDirectoryItem* item = getNodeByPath(path, 0, create);
		    if (!item) return NULL;
		    if (!dynamic_cast<CDirDirectory*>(item)) return NULL;
		    return (CDirDirectory*)item;
		 
	   };
           CDirectoryItem* CDirDirectory::getNodeByPath(const CUtiString& path, int startpos, bool create)
	   {
           
		    CUtiString currentname;
		    int nextslash = path.NextDelimiter(startpos, UTEXT("/\\"));
		    if (nextslash == -1) {
		       if (startpos >= path.size()) {
		           return NULL;
		       };
		       path.Copy(currentname, startpos, path.size()-startpos);
		       
		    } else {
		       path.Copy(currentname, startpos, nextslash-startpos);
		    };
		    CDirectoryItem* newitem = getChildren_Name_index(currentname);
		    if (newitem == NULL) {
		       if (!create) return NULL;
		       if (nextslash == -1) {
		          CDirFile* f = addChildren_CDirFile(currentname);
			  return f;
		       } else {
		          CDirDirectory* f = addChildren_CDirDirectory(currentname);
			  return f->getNodeByPath(path, nextslash+1, create);
		       };
		    } else {
		       if (nextslash == -1) {
		          //CDirFile* f = dynamic_cast<CDirFile*>(newitem);
			  //errorassert(f != NULL, "Could not access directory as file");
			  return newitem;
		       } else {
		          CDirDirectory* f = dynamic_cast<CDirDirectory*>(newitem);
			  //errorassert(f != NULL, "Could not access file as directory");
			  if (f == NULL) return NULL;
			  return f->getNodeByPath(path, nextslash+1, create);
		       };
		    };
		     
		 
		 
	   };
           
	     void CDirDirectory::insertItem_Children(CDirectoryItem* item)
	     {
	         Children_Name_index1.insert(std::make_pair(item->getName(), item));
	             Children_Name_index2.insert(std::make_pair(item, item->getName()));
	         
	     
	     };
	     void CDirDirectory::removeItem_Children(CDirectoryItem* item)
	     {
	         Children_Name_index1.erase(item->getName());
	             Children_Name_index2.erase(item);
	         
	     
	     };
	     void CDirDirectory::clearItem_Children()
	     {
	         Children_Name_index1.clear();
	             Children_Name_index2.clear();
	         
	     }
	 CDirectoryItem*CDirDirectory::getChildren_Name_index(const CUtiString &value) const
	     {
	        std::map<CUtiString, CDirectoryItem*>::const_iterator it = Children_Name_index1.find(value);
		if (it == Children_Name_index1.end()) {
		    return NULL;
		} else {
		    return it->second;
		};
	     }
	     
	     void CDirDirectory::changeChildren_Name_index(CDirectoryItem* v)
	     {
	        std::map<CDirectoryItem*, CUtiString>::iterator it2 = Children_Name_index2.find(v);
		utiassert(it2 != Children_Name_index2.end());
		
		CUtiString t = v->getName();
		if (it2->second == t) return;
		
	        std::map<CUtiString, CDirectoryItem*>::iterator it1 = Children_Name_index1.find(it2->second);
		utiassert(it1->second == it2->first);
		it2->second = t;
		Children_Name_index1.erase(it1);
		Children_Name_index1.insert(std::make_pair(t, v));
	     }
	 
         void CDirDirectory::addChildren(CDirectoryItem* arg0)
	 {
	    Children_array.push_back(arg0);
	     
	         insertItem_Children(arg0);
	     
	 }
	 void CDirDirectory::insertChildren(int i, CDirectoryItem* arg0)
	 {
	    utiassert(i >= 0);
	    utiassert(i <= Children_array.size());
	    Children_array.insert(Children_array.begin()+i, arg0);
	    
	         insertItem_Children(arg0);
	     
	 }
	 void CDirDirectory::deleteChildren(int i)
	 {
	    utiassert(i >= 0);
	    utiassert(i < Children_array.size());
	    CDirectoryItem* arg0 = Children_array.at(i);
	      
	     
	    std::swap(*(Children_array.begin() + i), *(Children_array.begin()+(Children_array.size()-1)));
	    Children_array.pop_back();
	    
	   
	         removeItem_Children(arg0);
	     
	    
	 }
	 void CDirDirectory::removeChildren(CDirectoryItem* arg0)
	 {
	    int i = indexOfChildren(arg0);
	    utiassert(i != -1);
	    deleteChildren(i);
	 }
	 
	 int CDirDirectory::indexOfChildren(CDirectoryItem* arg0)
	 {
	    for (int i = 0; i < Children_array.size(); i++) {
	       if (Children_array.at(i) == arg0) return i;
	    };
	    return -1;
	 }
	 
	 void CDirDirectory::clearChildren()
	 {
	    Children_array.clear();
	    clearItem_Children();
	    
	 }
	 int CDirDirectory::getChildrenCount()
	 {
	    return Children_array.size();
	 }
	 CDirectoryItem*CDirDirectory::getChildren(int i)
	 {
	    utiassert(i >= 0);
	    utiassert(i < Children_array.size());
	    return Children_array.at(i);
	 }
	 void CDirDirectory::setChildren(int i, CDirectoryItem* arg0)
	 {
	    utiassert(i >= 0);
	    utiassert(i < Children_array.size());
	    
	         if (Children_array.at(i) == arg0) {
		    return;
		 };
		 removeItem_Children(Children_array.at(i));
	    Children_array.at(i) = arg0;
	    
	         if (Children_array.at(i) == arg0) {
		    return;
		 };
		 insertItem_Children(Children_array.at(i));
	    
	 }
      CDirFile* CDirDirectory::addChildren_CDirFile(const CUtiString & Name)
	 {
	     CDirFile* n = getParentTree()->create_DT_CDirFile(getParentTree(), this);
	  n->setName(Name);
               
               
	     addChildren(n);
	     return n;
	    
	 };
      CDirDirectory* CDirDirectory::addChildren_CDirDirectory(const CUtiString & Name)
	 {
	     CDirDirectory* n = getParentTree()->create_DT_CDirDirectory(getParentTree(), this);
	  n->setName(Name);
               
               
	     addChildren(n);
	     return n;
	    
	 };
      
