/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef WIN32
#define WIN32THREAD

#endif

#define _WIN32_WINNT 0x0400
#ifdef WIN32THREAD
#include <objbase.h>
#include <process.h>
//#include <winbase.h>
#else

//#if defined(__GNUC__) && defined(WIN32)
//#define BOOST_THREAD_PLATFORM_PTHREAD
//#include <boost/thread/thread.hpp>
//#else
//#ifdef WIN32
//#include "winpthreads.h"
//#else
#include <pthread.h>
//#endif
//#endif
#endif

#ifdef _MSC_VER
#include <windows.h>
#endif

#include "Uti3DCore.h"
#include "Uti3DMath.h"
#include "UtiString.h"
#include "UtiArchiv.h"
#include "UtiType.h"
#include <assert.h>


#include <cmath>

#include <cstdio>

#include <fstream>
#include <sstream>
#include <set>
#include <typeinfo>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <deque>
#include <locale>
#include "utisystem.h"


#ifdef _WIN32
#define swprintf _snwprintf
#else
#include <sys/stat.h>
#endif

#define USETHREADS

using namespace std;

using namespace UtiFramework;

ostringstream dout;
const float NAlpha = 0.001f;

#ifdef _DEBUG
//
#endif
/*
class CSetLocal
{
public:
    CSetLocal()
    {
      setlocale(LC_ALL, "C");
    }
    ~CSetLocal()
    {

    }
};
CSetLocal setlocal;
*/

#ifdef USEJAVA
std::deque<ReferenceADR*> ReferenceUtiOB_AsynchronDefRef_DeleteList;


ReferenceADR_GarbageCollectionControl* ReferenceADR_GarbageCollectionControl::m_controller = NULL;

ReferenceADR_GarbageCollectionControl::ReferenceADR_GarbageCollectionControl()
{

}
#endif

void ReferenceADR::asyn_decRef()
{
    m_javarefcount--;
    #ifdef USEJAVA
    ReferenceUtiOB_AsynchronDefRef_DeleteList.push_back(this);
#endif

}


void ReferenceADR::asyn_addRef()
{
    addRef();

    m_javarefcount++;
    assert(this->m_references == m_javarefcount + m_cpprefcount);

}


void ReferenceADR::cpp_decRef()
{
    int oldvalue = m_cpprefcount;
    m_cpprefcount--;
    if (oldvalue != 0 && m_cpprefcount == 0) {
        #ifdef USEJAVA
        if (ReferenceADR_GarbageCollectionControl::m_controller != NULL) {
            ReferenceADR_GarbageCollectionControl::m_controller->setForeignGarbageCollection(this, true);
        }
#endif
    }
    decRef();
}

void ReferenceADR::cpp_addRef()
{

    int oldvalue = m_cpprefcount;
   m_cpprefcount++;
   if (oldvalue == 0 && m_cpprefcount != 0) {
       #ifdef USEJAVA
       if (ReferenceADR_GarbageCollectionControl::m_controller != NULL) {
           ReferenceADR_GarbageCollectionControl::m_controller->setForeignGarbageCollection(this, false);
       }
#endif
   }
   addRef();
}


ReferenceADR::~ReferenceADR()
{
#ifdef USEJAVA

   // for (auto el: ReferenceUtiOB_AsynchronDefRef_DeleteList){
   //     assert(el != this);
   // }
#endif
}

void ReferenceADR::gc()
{
    #ifdef USEJAVA
    for (std::deque<ReferenceADR*>::iterator it = ReferenceUtiOB_AsynchronDefRef_DeleteList.begin(); it != ReferenceUtiOB_AsynchronDefRef_DeleteList.end(); it++)
    {

        ReferenceADR* r = *it;
        CHECKEXISTANCEOF(r);
        r->decRef();

        assert(r->m_references == r->m_javarefcount + r->m_cpprefcount);
    }
    ReferenceUtiOB_AsynchronDefRef_DeleteList.clear();
    auto i = 5;
#endif
}

bool m_hasmeminit = false;

class CMemCheckClass {
public:
    CSpinLock m_checkmemaccess;
    CMemCheckClass()
    {

    }

    ~CMemCheckClass()
    {
        m_hasmeminit = false;
    }


};

CMemCheckClass m_checkclass;


#ifdef USEMEMDUMP
set <const CUtiOB*>* UtiOBInstanceObj=NULL;





void memcheck_init()
{
 m_hasmeminit = true;
};

void utiexit(int i)
{
  memcheck_disable();
  exit(i);
};

void memcheck_disable()
{
   m_hasmeminit = false;
};

#define MEMCHECK_LOAD if (UtiOBInstanceObj == NULL) UtiOBInstanceObj = new set <const CUtiOB*>();

void memcheck_addToMemory(CUtiOB* obj)
{
  if (m_hasmeminit) {
	  CCSControlSpin lock(m_checkclass.m_checkmemaccess);
  MEMCHECK_LOAD
  set <const CUtiOB*>::iterator it = UtiOBInstanceObj->find(obj);
  if (it != UtiOBInstanceObj->end()) {
    wcout << "Detected Double Memory Reserve: " << endl;
    wcout << "Datatype:" << typeid(**it).name() << endl;

    return;
   utiassert(UtiOBInstanceObj->find(obj) == UtiOBInstanceObj->end());
  }
    UtiOBInstanceObj->insert(obj);
  } else {
MEMCHECK_LOAD
   utiassert(UtiOBInstanceObj->find(obj) == UtiOBInstanceObj->end());
    UtiOBInstanceObj->insert(obj);
  };
}

void memcheck_removeFromMemory(CUtiOB* obj)
{
  if (m_hasmeminit) {
	  CCSControlSpin lock(m_checkclass.m_checkmemaccess);
  MEMCHECK_LOAD
          assert(UtiOBInstanceObj->find(obj) != UtiOBInstanceObj->end());
   utiassert(UtiOBInstanceObj->find(obj) != UtiOBInstanceObj->end());
    UtiOBInstanceObj->erase(obj);
     } else {
       MEMCHECK_LOAD
       utiassert(UtiOBInstanceObj->find(obj) != UtiOBInstanceObj->end());
    UtiOBInstanceObj->erase(obj);
     };
}
bool memcheck_existsInMemory(const CUtiOB* obj)
{
  if (obj == NULL) return false;
   if (m_hasmeminit) {

	   CCSControlSpin lock(m_checkclass.m_checkmemaccess);
  MEMCHECK_LOAD
  return UtiOBInstanceObj->find(obj) != UtiOBInstanceObj->end();
   } else {
      return UtiOBInstanceObj->find(obj) != UtiOBInstanceObj->end();
   };
}


#else
void utiexit(int i)
{

  exit(i);
};
#endif

void CSyncCheck::Enter()
{
#ifndef NDEBUG
     CCSControlSpin lock(m_checkclass.m_checkmemaccess);
#endif

    if (m_currentthread == NULL) {
        m_currentthread = CThread::getCurrentThreadID();
        assert(m_currentthread != NULL);
        assert(m_index == 0);
        m_index++;
    } else {
        assert(CThread::getCurrentThreadID() == m_currentthread);
        m_index++;
    }

}
void CSyncCheck::Exit()
{
#ifndef NDEBUG
     CCSControlSpin lock(m_checkclass.m_checkmemaccess);
#endif
    assert(m_currentthread != NULL);
    m_index--;
    assert(m_index >= 0);
    if (m_index == 0) {

        m_currentthread=NULL;
    }
}

void CheckFileName(const U_CHAR* c)
{

    if (!FileExists(c))
    {
//        wcout << "Die Datei " << c << " konnte nicht gefunden werden"  << endl;

    }
    /*if (FileExists(c)) {
       CUtiString g;
       g = UTEXT("C:\\Michael\\SpaceRelease\\");
       g += c;
    CUtiString kl;
    kl = g;
    kl.ExtractFilePath();
    ForceDir(kl.getString());
       if (!FileExists(g.getString())) {
          UtiCopyFile(c, g.getString(), false);
       };

    };*/

}
;

void UtiLog(int level, const CUtiString& errortext)
{
/*#ifdef _WIN32
	MessageBox(0, errortext.c_str(), L"UtiLog", 0);
#else
   wcout << errortext<<endl;
#endif*/
    CUtiGeneralGUI::getInstance()->m_gui->log(level, errortext);
}

void UtiError(int id, const CUtiString& errortext)
{
	/*#ifdef _WIN32
    MessageBox(0, errortext.c_str(), L"UtiError", 0);
#else
   wcout << errortext<<endl;
   Rufe wx Window auf
#endif*/
  CUtiGeneralGUI::getInstance()->m_gui->error(id, errortext);
};


bool compareAngles(float a1, float a2, float d)
{
  a1 = fmod(a1+3600, 360);
  a2 = fmod(a2+3600, 360);
#ifndef NDEBUG
  std::wcout << "a1 = " << a1 << std::endl;
  std::wcout << "a2 = " << a2 << std::endl;
#endif
 return (absf(a1-a2) < d) || (absf(a1-a2-360) < d) || (absf(a1-a2+360) < d); 
}


CUtiGeneralGUIInterface::CUtiGeneralGUIInterface()
{

}

void CUtiGeneralGUIInterface::error(int id, const CUtiString& errortext)
{
 messageBox(UTISTR("Error"), errortext);
}

void CUtiGeneralGUIInterface::log(int level, const CUtiString& errortext)
{
messageBox(UTISTR("Log"), errortext);
}

MAKE_SINGLETON_IMPL(CUtiGeneralGUI)


CUtiGeneralGUI::CUtiGeneralGUI()
{
m_gui = new CUtiGeneralGUIInterface();
}

CUtiGeneralGUI::~CUtiGeneralGUI()
{

}


void CUtiGeneralGUIInterface::messageBox(const CUtiString& caption, const CUtiString& text)
{
   wcout << caption << UTISTR(":") << text<<endl;
}


void UtiMessageBox(const CUtiString& caption, const CUtiString& text)
{
 CUtiGeneralGUI::getInstance()->m_gui->messageBox(caption, text);
}


float intern_inoise(int x)
{

   x = (x<<13) ^ x;
   return (1.0 - ((x*(x* x * 15731 + 789221) + 1376312589) & 0x7fffffff) / 1073741824.0);
}

inline float intern_smooth(float a, float b, float v)
{
    //return a+(b-a)*v;
   return a+(b-a)*((-cos(v*PI)+1.0f)*0.5f);
}

float intern_noise(float x)
{
   float frac;
   int ix = (int)x;
   float fx = modff(x, &frac);
   //int ix = frac;
   return intern_smooth(intern_inoise(ix), intern_inoise(ix+1), fx);
};


void ShowMessage(const wchar_t* text)
{
#ifdef WIN32
MessageBox(NULL, text, L"Error", MB_OK);
#endif
    wcout << text << endl;

}

void zeromem(LPVOID l, int count)
{
    memset(l, '\0', count);
}


int urandom(int max)
{
    return(rand() % max);
}

float urandom()
{
    return((float)rand() / RAND_MAX);
}

int ToPower2(int i)
{
//    int r= i;
#define powm(a) if (i <= a) return(a);

    powm(1);
    powm(2);
    powm(4);
    powm(8);
    powm(16);
    powm(32);
    powm(64);
    powm(128);
    powm(256);
    powm(512);
    powm(1024);
    powm(2048);
    powm(4096);
    powm(4096*2);
    powm(4096*4);
    powm(4096*8);
    powm(4096*9);
#undef powm

    return(256);
}

bool Writefunc(NODE_PTR node, void* data)
{
    CStream * strm = (CStream*)data;
    node->data->Write(*strm, 0, 0);
    return true;
}

bool WritefuncCache(CUtiOB* ob, void* data)
{
    CStream * strm = (CStream*)data;
    ob->Write(*strm, 0, 0);
    return true;
}

bool compareCode(SCode c1, SCode c2)
{
    // return((c1 == c2));
    return(IsEqualGUID(c1, c2));
}

const SCode createCode()
{
    SCode result;
    // CoCreateGUID(result);
/*#ifdef WIN32

    UuidCreate(&result);
#else*/
static unsigned int counter =urandom(65536)*256*128;
    result.Data1 = counter++;;
    ;
    result.Data2 = urandom(65535);
    result.Data3 = urandom(65535);
    result.Data4[0] = urandom(255);
    result.Data4[1] = urandom(255);
    result.Data4[2] = urandom(255);
    result.Data4[3] = urandom(255);
    result.Data4[4] = urandom(255);
    result.Data4[5] = urandom(255);
    result.Data4[6] = urandom(255);
    result.Data4[7] = urandom(255);
//#endif

    return result;
}



const SCode IntToCode(int i)
{
    SCode result = NULLCODE;
    result.Data1 = i;
    return result;
}

const int CodeToInt(const SCode i)
{
    int result = i.Data1;
    if (result < 0)
        result = 1000000000;
    return result;
}

CNotifyEvent::CNotifyEvent()
{

}

bool PtInRectE(float x, float y, float x1, float y1, float x2, float y2)
{
    return(x > x1 && x < x2 && y < y1  && y > y2);
};


SVector4 setVector4(float x, float y, float z, float w)
{
    SVector4 res;
    res.x = x;
    res.y = y;
    res.z = z;
    res.a = w;
    return(res);
}

void NormRect(UTIRECT &r)
{
    int i;
    if (r.top > r.bottom)
    {
        i = r.top;
        r.top = r.bottom;
        r.bottom = i;
    };
    if (r.left > r.right)
    {
        i = r.left;
        r.left = r.right;
        r.right = i;
    };
}

void ForceDir(const CUtiString& path)
{
    CUtiString P(path);
    P.ExtractFilePath();
    if (P.size() == 0) return;
    if (!FileExists(P.getString()))
    {
        ForceDir(P.getString());

    }
#ifdef WIN32
    CreateDirectory(path.c_str(), NULL);
#else
    string str = UtiFramework::converttomulti(P);
   //mkdir(str.c_str(), S_IRWXU | S_IRGRP | S_IWGRP);
    mode_t mask = umask(0);
    mkdir(str.c_str(), /*664*/0777);
    umask(mask);
#endif
}

void doutiassert(const U_CHAR* expression,const char* file, int line, const char* date)
{
    //U_CHAR c[256];
    CUtiString f;
    f.LoadAnsi(file);
    CUtiString d;
    d.LoadAnsi(date);
    std::wcout << expression << std::endl;
    std::wcout << file << std::endl;
    CUtiString output;
    output += UTEXT("UTIASSERT: ");
    output += expression;
    output += UTEXT(" \n\n Datei: ");
    output += f.c_str();
    output += UTEXT(" \n Zeile: ");
    output += line;
    output += UTEXT(" \n Datum der Compilierung: ");
    output += d;
  //  swprintf(c,256, UTEXT("UTIASSERT: %S \n\n Datei: %S \n Zeile: %i \n Datum der Kompilierung: %S"), expression, f.c_str(), line, d.c_str());
     ShowMessage(output.c_str());
     //int i;
   //  std::wcin >> i;
#ifdef _WIN32
        *((int*)0) = 42;
#else
     assert(false);
#endif

}

void utiprinterror(const U_CHAR* expression, const char* file, int line, const char* date, const CUtiString &str)
{
   //U_CHAR c[256];
    CUtiString f;
    f.LoadAnsi(file);
    CUtiString d;
    d.LoadAnsi(date);
     CUtiString result;
     std::wcout << "UTI_ASSERT" << expression << " in " << file << " on line " << line << " date " << date << std::endl;

     result = UTISTR("UTI_ASSERT")+expression+UTISTR("\n\n Datei: ") + f + UTISTR(" \n Zeile: ") + line + UTISTR(" \n Datum der Komplierung: ") + d + UTISTR("\n Message: ") + str;
   // swprintf(c,256, UTEXT("UTIASSERT: %s \n\n Datei: %s \n Zeile: %i \n Datum der Kompilierung: %s Message: %s"), expression, f.c_str(), line, d.c_str(), str.c_str());
     ShowMessage(result.c_str());
     assert(false);
};

void doutiassert2(const U_CHAR* expression, const U_CHAR* file, int line, const U_CHAR* date, const U_CHAR* info)
{
    U_CHAR c[256];
    swprintf(c, 256,UTEXT("UTIASSERT: %S \n\n Datei: %S \n Zeile: %i \n Datum der Kompilierung: %S\n\n%S"), expression, file, line, date, info);
    // MessageBox(0, c, UTEXT("Benutzerfehler"), 0);
     ShowMessage(c);
      assert(false);
}

MAKE_SINGLETON_IMPL(CEventManager)

typedef std::vector< uti_refptr<CNotifyEvent> > EVENT_NOTIFY_LIST;

typedef std::vector< EVENT_NOTIFY_LIST* > EVENT_MANAGER_LIST;

CEventManager::CEventManager()
{
   m_vectorlist = new EVENT_MANAGER_LIST();
}

CEventManager::~CEventManager()
{
  EVENT_MANAGER_LIST& l = *((EVENT_MANAGER_LIST*)m_vectorlist);
  for (int i = 0; i < l.size(); i++) {
    EVENT_NOTIFY_LIST* nlist = l.at(i);
    if (nlist) {
      delete nlist;
    };
  };

  delete ((EVENT_MANAGER_LIST*)m_vectorlist);
}


void CEventManager::registerEvent(int id, CNotifyEvent* event)
{
  utiassert(id >= 0 && id < 1000);
  EVENT_MANAGER_LIST& l = *((EVENT_MANAGER_LIST*)m_vectorlist);
  while (id >= l.size()) l.push_back(NULL);
  EVENT_NOTIFY_LIST* nlist = NULL;
  if (l.at(id) != NULL) {
    nlist = l.at(id);
  } else {
    nlist = new EVENT_NOTIFY_LIST();
    l.at(id) = nlist;
  };
  nlist->push_back(uti_refptr<CNotifyEvent>( event));
}

void CEventManager::fireEvent(int id, CUtiOB* ob, CUtiOB* data)
{
  utiassert(id >= 0 && id < 1000);
   EVENT_MANAGER_LIST& l = *((EVENT_MANAGER_LIST*)m_vectorlist);
   if (id >= l.size()) return;
   EVENT_NOTIFY_LIST* nlist = l.at(id);
   if (nlist == NULL) return;
   for (int i = 0; i < nlist->size(); i++) {
     nlist->at(i)->call(ob, data);
   };
}


CBaseObserver::CBaseObserver()
{

}

void CBaseObserver::notifyChange(CUtiOB* source, int id, CUtiOB* changedata)
{

}

const SCode CUtiOB::GetCode()
{
  SCode code = NULLCODE;
  UTI_INT64 value = (UTI_INT64) this;
  code.Data1 = value & 0xFFFFFFFF;
  code.Data2 = (value >> 32) & 0xFFFF;
  code.Data3 = (value >> (32+16)) & 0xFFFF;
        return code;
};


HResult CUtiOB::Write(CStream &Stream, int Flags, int version)
{
    return(UTI_OK);
}

HResult CUtiOB::Read(CStream &Stream, int Flags, int version)
{
    return(UTI_OK);
}

int CUtiOB::GetMessageUti(CUtiOB *Sender, int msg, int lParam, void* wParam, bool &handled)
{
    return(0);
}

void CUtiOB::xread(CXNode* n, CWriteReadInterface* wri)
{
  xreadUser(n, wri);
};


void CUtiOB::xwrite(CXNode* n, CWriteReadInterface* wri)
{
xwriteUser(n, wri);
};

void CUtiOB::xreadUser(CXNode* n, CWriteReadInterface* wri)
{

}

void CUtiOB::xwriteUser(CXNode* n, CWriteReadInterface* wri)
{

}


CUtiOB::~CUtiOB()
{
#ifdef EDITOR
    DeleteItem(v);
#endif
#ifdef USEMEMDUMP

   // utiassert(UtiOBInstanceObj.find(this) != UtiOBInstanceObj.end());
   //UtiOBInstanceObj.erase(this);
    memcheck_removeFromMemory(this);
#endif
}

void CUtiOB::edit(CGUICreator* guicreator, CUtiOB* info, int flags)
{

}



void CUtiOB::entityReflection(CUtiOB* datastore, CUtiOB* mode)
{

}

void CUtiOB::setCreateParent(CUtiOB* obj)
{

}

bool CUtiOB::deleteMeUser(CUtiOB* obj)
{
return false;
}

CUtiString CUtiOB::getClassName()
{
  return EMPTYSTRING;
}

void CUtiOB::deleteMe(CUtiOB* obj)
{
  if (dynamic_cast<CClassCollector*>(obj) != NULL) {
    CClassCollector* collector = (CClassCollector*)obj;
    collector->addObject(this);
    return;
  }
  if (deleteMeUser(obj)) return;
  if (obj == NULL) {
  CEventManager::getInstance()->fireEvent(UTI_EVENT_DELETE_ME, this, obj);
  }
}

HResult CUtiOB::Assign(CUtiOB*ob, int flags)
{
    /*HResult res;
       UINT a = (unsigned int)&ob;
    UINT b = (unsigned int)this;
    if (a == b) {
    	return(UTI_ERROR_SAME_CLASS);
    }
       CSharedFile memfile(GMEM_DDESHARE | GMEM_MOVEABLE, 4096);

    res = ob.Write(memfile, 0, 0);
    if (res != UTI_OK) return res;
    memfile.SeekToBegin();

    res = Read(memfile, 0, 0);
    if (res != UTI_OK) return res;
    return (UTI_OK);*/
    return(UTI_OK);
}

size_t CStream::WriteData(const void *data, size_t size)
{
	return 0;
}

size_t CStream::ReadData(void *data, size_t size)
{
	return 0;
}

void CStream::WriteInteger(int i)
{
    WriteData(&i, 4);

}

void CStream::ReadInteger(int &i)
{
  i = 0;
    ReadData(&i, 4);
}

void CStream::ReadBoolean(bool &b)
{
    ReadData(&b, 1);
}

void CStream::WriteBoolean(bool b)
{
    WriteData(&b, 1);
}


void CStream::ReadFloat(double &f)
{
    float f2;
    ReadData(&f2, sizeof f2);
    f = f2;
}

void CStream::WriteFloat(double f)
{
float f2 = f;
    WriteData(&f2, sizeof f2);
}

void CStream::WriteFloat(float f)
{
    WriteData(&f, sizeof f);
}

void CStream::ReadFloat(float &f)
{
    ReadData(&f, sizeof f);
}

void CStream::WriteDouble(double d)
{
    WriteData(&d, sizeof d);
}

void CStream::ReadDouble(double &d)
{
    ReadData(&d, sizeof d);
}

double CStream::getDouble()
{
   double d;
   ReadDouble(d);
   return d;
}

float CStream::getFloat()
{
   float d;
   ReadFloat(d);
   return d;
}

bool CStream::getBool()
{
   bool b;
   ReadBoolean(b);
   return b;
}

U_INT32 CStream::getInt32()
{
   U_INT32 i;
   ReadData(&i, sizeof(U_INT32));
   return i;
}

U_INT16 CStream::getInt16()
{
   U_INT16 i;
   ReadData(&i, sizeof(U_INT16));
   return i;
}

U_INT8 CStream::getInt8()
{
   U_INT8 i;
   ReadData(&i, sizeof (U_INT8));
   return i;
}


U_UINT32 CStream::getUInt32()
{
   U_UINT32 i;
   ReadData(&i, sizeof(U_UINT32));
   return i;
}

U_UINT16 CStream::getUInt16()
{
   U_UINT16 i;
   ReadData(&i, sizeof(U_UINT16));
   return i;
}

U_UINT8 CStream::getUInt8()
{
   U_UINT8 i;
   ReadData(&i, sizeof(U_UINT8));
   return i;
}


void CStream::writeInt32(U_INT32 i)
{
   WriteData(&i, 4);
}

void CStream::writeInt16(U_INT16 i)
{
   WriteData(&i, 2);
}

void CStream::writeInt8(U_INT8 i)
{
   WriteData(&i, 1);
}


void CStream::writeUInt32(U_UINT32 i)
{
   WriteData(&i, 4);
}

void CStream::writeUInt16(U_UINT16 i)
{
   WriteData(&i, 2);
}

void CStream::writeUInt8(U_UINT8 i)
{
   WriteData(&i, 1);
}

void CStream::writeString(const CUtiString& str)
{
  WriteStringWide(*this, str);
}

void CStream::readString(CUtiString& str)
{
   ReadStringWide(*this, str);
}


void CStream::writeString8(const std::string& str)
{
WriteStringMulti(*this, str);
}

void CStream::readString8(std::string& str)
{

    ReadStringMulti(*this, str);
}


void CStream::setPosition(off_t i, TPositionType postype)
{
    //nix
}

CStream::CStream()
{
  docount = false;
  count = 0;
}
/*
ReferenceUtiOB::ReferenceUtiOB()
{
   m_references = 0;
}*/

ReferenceUtiOB::~ReferenceUtiOB()
{
   utiassert(m_references <= 1);
}
/*
void ReferenceUtiOB::addRef()
{
 CHECKEXISTANCE;
   m_references++;
}

void ReferenceUtiOB::decRef()
{
  CHECKEXISTANCE;
   m_references--;
   utiassert(m_references >= 0);
   if (m_references <= 0) destroyReferenceObject();
}
*/
void ReferenceUtiOB::destroyReferenceObject()
{
   delete this;
}

/*
CUtiList::CUtiList()
{
    sorted = false;
    deleteItems = false;
    first = NULL;
    last = NULL;
    count = 0;
    MemController = NULL;
    //   typinfo = UTI_UTILIST;
    CheckArray(10);
}

void CUtiList::CheckArray(int count)
{

};

HResult CUtiList::Read(CStream & Stream, int Flags, int version, CUtiOB* (UTICDECL *enumfunc)(CUtiOB* parent, int type), CUtiOB* parent)
{
    Clear();
    Stream.ReadInteger(count);
    int type = 0;
    //CUtiOB* ob;
    for (int i = 0; i < count; i++)
    {
        Stream.WriteInteger(type);
        if (type == UTI_UTIOB)
            return(UTI_READERROR);
        CUtiOB* t = enumfunc(parent, type);
        if (t)
        {
            t->Read(Stream, Flags, version);
            Add(t, 0);
        };
    }
    return(UTI_OK);
}

HResult CUtiList::Write(CStream & Stream, int Flags, int version)
{
    Stream.WriteInteger(count);
    NODE_PTR node = GetFirstItem();
    CUtiOB *obj;
    do
    {
        obj = (CUtiOB*)node->data;
        if (version == 1)
        {
            // Stream.WriteInteger(obj->typinfo);
        };
        obj->Write(Stream, Flags, version);
    }
    while (GetNextPointer(node));
    return(UTI_OK);
}



CUtiList::~CUtiList()
{
    Clear();

}

NODE_PTR CUtiList::GetFirstItem()
{
    return(first);
}

bool CUtiList::GetNextPointer(NODE_PTR &node)
{
    node = node->next;
    return(node != NULL);
}

void CUtiList::Delete(CUtiOB *data)
{
    Delete(indexofNode(data));
}

void CUtiList::AddList(CUtiList *list)
{
    NODE_PTR node = list->GetFirstItem();
    while (node)
    {
        Add(node->data, node->value);
        list->GetNextPointer(node);
    };


};

NODE_PTR CUtiList::Add(CUtiOB *data, float value)
{
    NODE_PTR new_node = NULL;
    NODE_PTR search = NULL;
    new_node = new NODE;
    new_node->data = data;
    new_node->value = value;
    new_node->next = NULL;
    new_node->prev = NULL;
    count++;
    if (first == NULL)
    {
        first = last = new_node;
        return new_node;
    }
    else if ((first != NULL) && (first == last))
    {
        if ((sorted) && (new_node->value < first->value))
        {
            first = new_node;
            new_node->next = last;
            last->prev = new_node;
        }
        else
        {
            first->next = new_node;
            new_node->prev = first;
            last = new_node;
        }
        return new_node;
    }
    else
    {
        if (sorted)
        {
            search = first;
            while ((search != NULL) && (search->value < new_node->value))
            {
                search = search->next;
            }
            if (search == NULL)
            {
                last->next = new_node;
                new_node->prev = last;
                last = new_node;
                return(new_node);
            }
            if (search == first)
            {
                first->prev = new_node;
                new_node->next = first;
                first = new_node;
                return(new_node);
            }
            new_node->prev = search->prev;
            new_node->next = search;

            search->prev->next = new_node;
            search->prev = new_node;

        }
        else
        {
            last->next = new_node;
            new_node->prev = last;
            last = new_node;
        }
        return(new_node);
    }
}

void CUtiList::Delete(NODE_PTR node)
{
    if (!node)
        return;
    if (first == NULL)
        return;
    if (deleteItems)
    {
        if (node->data)
        {
            if (MemController)
            {
                MemController->FreeMemory(node->data);
            }
            else
            {
                delete node->data;
            };
        };
    }
    if (node == first)
    {
        first = first->next;
        if (first)
            first->prev = NULL;
        delete node;
        count--;
        return;
    }
    if (node == last)
    {
        last = last->prev;
        last->next = NULL;
        delete node;
        count--;
        return;
    }
    node->prev->next = node->next;
    node->next->prev = node->prev;
    delete node;
    count--;
    return;

}

void CUtiList::Clear()
{
    NODE_PTR node, n2;
	first = last = NULL;
    node = first;
    while (node != NULL)
    {
        n2 = node;
        node = node->next;
        if (deleteItems)
        {
			CUtiOB* sick = n2->data;
            n2->data = NULL;
            delete sick;

        }
        delete n2;
    }
    first = last = NULL;
    count = 0;
}
*/

void CCacheList::EnumItems(void *data, bool (UTICDECL *enumfunc)(CUtiOB*,void *))
{
    //bool ok = false;
    for (int i = 0; i < count; i++) {
        /*ok = */(*enumfunc)(pointers[i], data);
    };

}

/*void CUtiList::EnumItems(void *data, bool (UTICDECL *enumfunc)(NODE_PTR,void *))
{
    NODE_PTR node, nnext;
    node = first;
    bool ok;
    while (node != NULL)
    {
        nnext = node->next;
        ok = (*enumfunc)(node, data);
        if (!ok)
            return;
        node = nnext;
    }
}

int CUtiList::indexof(CUtiOB *obj)
{
    NODE_PTR node;
    node = first;
    int i = 0;
    while (node != NULL)
    {

        if (obj == node->data)
            return(i);
        node = node->next;
        i++;
    }
    return(-1);
}

NODE_PTR CUtiList::indexofNode(CUtiOB *obj)
{
    NODE_PTR node;
    node = first;

    while (node != NULL)
    {

        if (obj == node->data)
            return(node);
        node = node->next;
    }
    return(NULL);
}

CUtiOB* CUtiList::getItem(int i)
{
    NODE_PTR node;
    node = first;
    int index = 0;
    while (node != NULL)
    {

        if (index == i)
            return(node->data);
        node = node->next;
        index++;
    }
    return (NULL);
}

NODE_PTR CUtiList::getNode(int i)
{
    NODE_PTR node;
    node = first;
    int index = 0;
    while (node != NULL)
    {

        if (index == i)
            return(node);
        node = node->next;
        index++;
    }
    return (NULL);
}

void CUtiList::sortItems()
{
}

void CUtiList::Swapitems(NODE_PTR f1, NODE_PTR f2)
{
    NODE_PTR dummy;

    dummy = f1->next;
    f1->next = f2->next;
    f2->next = dummy;

    dummy = f1->prev;
    f1->prev = f2->prev;
    f2->prev = dummy;

    if (f1->prev == NULL)
        first = f1;
    if (f1->next == NULL)
        last = f1;

    if (f2->prev == NULL)
        first = f2;
    if (f2->next == NULL)
        last = f2;
}

void Fehler(U_CHAR* s)
{
    //   cout << s;
}

void CUtiList::GetObjects(float value, CUtiOB *&First, CUtiOB *&Next)
{

    NODE_PTR node;
    node = first;
    First = NULL;
    Next = NULL;
    while (node != NULL)
    {

        if (node->value >= value)
        {
            if (node->prev)
            {
                First = node->prev->data;
                Next = node->data;
            }
            else
            {
                First = node->data;
                Next = node->next->data;
            };

            return;
        }
        node = node->next;
    }
    return;
}

void CUtiList::GetObjectByValue(float value, CUtiOB *&obj)
{
    NODE_PTR node;
    node = first;
    obj = NULL;
    while (node != NULL)
    {

        if ((node->value > (value-EPSILON))&&(node->value < (value+EPSILON)))
        {
            obj = node->data;
            return;
        }
        node = node->next;
    }
    return;
}
*/

#ifdef EDITOR
void CUtiOB::DeleteItem(void* view)
{
   /* CUtiTreeView *tree = (CUtiTreeView*) view;
    if (TreeItem != 0)
    {
        tree->DeleteItem(TreeItem);
    }*/
   CHECKEXISTANCE
}

void CUtiOB::AddTreeItem(void* view, UINT parent, U_CHAR *c)
{
    //v = view;
};
#endif


int compare(float a, float b)  //wenn a > b dann result = 1;
{
    float c = a-b;
    if ((c < NAlpha) && (c > -NAlpha))
    {
        return(0);
    }
    if (c < 0)
        return(-1);
    if (c > 0)
        return(1);
    return(0);
}

bool FileExists(const CUtiString& name)
{
    /*ifstream s(name);

    if (s.fail() || s.eof()) return(false); else return(true);*/
   /* Dir_FileInfo d;
    CUtiString n(name);
    CUtiString path;

    path=n;
    path.ExtractFilePath();
    n.ExtractFileName();
    if (!UtiFramework::FindFirst(path, &d))
        return 0;
    if (d.name == n)
        return true;

    while (UtiFramework::FindNext(&d))
    {

        if (d.name == n)
            return true;
    }

    UtiFramework::FindClose(&d);

    return(false);*/
    if ( UtiFramework::getFileSize(name) == -1){
    return false;}
    return true;

}

UTI_INT64 FileSize(const CUtiString &name)
{


   /* Dir_FileInfo d;
    CUtiString n(name);
    CUtiString path;

    path=n;
    path.ExtractFilePath();
    n.ExtractFileName();
    UtiFramework::FindFirst(path, &d);
    if (d.name == n)
        return d.size;
    while (UtiFramework::FindNext(&d))
    {
        if (d.name == n)
            return d.size;
    }

    UtiFramework::FindClose(&d);*/

    return UtiFramework::getFileSize(name);

}

CMemManager::CMemManager() :CUtiOB()
{
    data = NULL;
    datasize = 0;
    locked = true;
    fileindex = 0;
}

void CMemManager::GetFilename(U_CHAR* c)
{
    swprintf(c,256, UTEXT("Memory%x.tmp"), fileindex);
};

CMemManager::CMemManager(int datasize):CUtiOB()
{
    data = NULL;
    datasize = 0;
    locked = true;
    fileindex = 0;
    Init(datasize);
}

void CMemManager::Init(int datasize)
{
    Free();
    data = new U_SCHAR[datasize];
    this->datasize = datasize;
    fileindex = (UINT)urandom(0xffff)*urandom(0xffff);
    locked = true;
}

void CMemManager::Free()
{
    if (!fileindex)
        return;
    if (data)
        delete [] (U_SCHAR*)data;
    data = NULL;
    datasize = 0;
    locked = true;

    U_CHAR c[256];
    GetFilename(c);
    if (FileExists(c))
    {
        //  wremove(c);
    };

};

CMemManager::~CMemManager()
{
    Free();

}

void CMemManager::Lock()
{

    if (locked)
        return;
    if (!fileindex)
        return;
    U_CHAR c[256];
    GetFilename(c);

    locked = true;
    data = new U_SCHAR[datasize];

    CFileStream* s = new CFileStream(c,S_READ);
    if (s->fail())
    {
        memset(data, 0, datasize);
    }
    else
    {
        s->ReadData(data, datasize);

    };
    delete s;
    //   _wremove(c);
}

void CMemManager::Unlock()
{
    return;

    if (!locked)
        return;
    if (!fileindex)
        return;
    U_CHAR c[256];
    GetFilename(c);
    locked = false;
    CFileStream* s = new CFileStream(c,S_WRITE);
    s->WriteData(data, datasize);
    delete s;
    delete (U_SCHAR*)data;
    data = NULL;

}

size_t CStream::getDataSize()
{
  utiassert(false);
  return 0;
};

void copyStreamTo(CStream& dest, CStream&source, off_t count)
{

  char c[COPY_BUFFER_SIZE];
  if (count == -1) {
    while(!source.eof()) {
      size_t read = source.ReadData(c, COPY_BUFFER_SIZE);
      dest.WriteData(c, read);
    };
  } else {
    while (count > 0) {
       size_t copycount = umin((int)count, (int)COPY_BUFFER_SIZE);
       size_t read = source.ReadData(c, copycount);
       dest.WriteData(c, read);
       utiassert(count >= copycount);
       count -= copycount;
    };
  }
}

void CCacheList::ValidNewSize(int newcount)
{
	utiassert(newcount >= 0);
    bool changed = false;

    if (newcount > capacity)
    {  //grow
        while (newcount > capacity)
        {
            capacity*=2;
            capacity+=1;//+= inc;
        };
        changed = true;
    }
    else if (newcount < capacity/2-10)
    {
         while (newcount < capacity/2-10) {
        capacity = capacity/2;
         }
        if (capacity < inc)
            capacity = inc;
        changed = true;
    };
    assert(newcount <= capacity);

    int size = count;
    if (newcount < size)
    {
        size = newcount;
       // changed = true;
    }
    if (changed)
    {
        CUtiOB** ptr = ReserveMem(capacity);
		if (size > 0)
        memcpy(ptr, pointers, sizeof(CUtiOB*)*size);
        FreeMem( pointers);
        pointers = ptr;
    }
    count = newcount;
}

CUtiOB** CCacheList::ReserveMem(int count)
{
    return new CUtiOB*[count];
}

void CCacheList::FreeMem(CUtiOB** vd)
{
    delete [] vd;
}

CCacheList::CCacheList() : CUtiOB()
{
    count = 0;
    inc = 20;
    capacity = inc;
    pointers = ReserveMem(capacity);
 //   pointers[0] = NULL;
    deleteItems = false;
    MemController = NULL;
}

void CCacheList::SetNewSize(int size)
{
    utiassert(size < 0);
    ValidNewSize(size);
}



void CCacheList::Insert(CUtiOB* item, int index)
{
    ValidNewSize(count+1);
    for (int i = count-1; i > index; i--)
    {
        pointers[i] = pointers[i-1];
    };
    pointers[index] = item;

}

CCacheList::~CCacheList()
{
    //Clear();
    if (deleteItems)
    {
        for (int i= 0; i < count; i++)
        {
            //FreeItem(&pointers[i]);
            delete pointers[i];
        };
    };
    count = 0;
    if (pointers)
    {
        FreeMem(pointers);
        pointers = NULL;

    }
};

/*int PolyCompare(const void *p1, const void * p2)
{
	TPoly* poly1 = (TPoly*)*(UINT*)p1;
	TPoly* poly2 = (TPoly*)*(UINT*)p2;
	if (poly1->zaverage == poly2->zaverage) return(0);
	if (poly1->zaverage > poly2->zaverage) {
       return(-1);
	} else {
       return(1);
	};
}*/

void CCacheList::Sort(int (UTICDECL *compare )(const void *elem1, const void *elem2 ))
{
    if (count == 0)
        return;
    qsort(pointers, count, sizeof(void*), compare);
}

void CCacheList::FreeItem(CUtiOB** item)
{
    CUtiOB* ob = *item;
    *item = NULL;
    if (deleteItems)
    {
        if (MemController)
        {
            MemController->FreeMemory(ob);
        }
        else
        {
            delete ob;
        };
    }
    *item = NULL;
};


void CCacheList::Clear()
{
    if (count == 0)
        return;
    for (int i= 0; i < count; i++)
    {
        FreeItem(&pointers[i]);
    };
    ValidNewSize(0);
};

void CCacheList::Add(CUtiOB* item)
{
    ValidNewSize(count+1);
    pointers[count-1] = item;
};

void CCacheList::Remove(CUtiOB* item)
{
    int i = IndexOf(item);
    if (i != -1)
    {
        Delete(i);
    };
}

void CCacheList::Extract(CUtiOB* item)
{
    int i = IndexOf(item);
	if (i == -1) return;
	Extract(i);
}

void CCacheList::Extract(int index)
{
assert(index >= 0 && index < count);
    for (int i = index; i < count-1; i++)
    {
        pointers[i] = pointers[i+1];
    };
    ValidNewSize(count-1);
}

void CCacheList::RemoveExtract(CUtiOB* item)
{
    Extract(IndexOf(item));
}


void CCacheList::Delete(int index)
{
    //	memmove(ptr[index], ptr[index+1], (count-index)*sizeof(LPVOID));
    utiassert(index >= 0 && index < count);
    CUtiOB* t = pointers[index];
    Extract(index);
    FreeItem(&t);

};

int CCacheList::IndexOf(CUtiOB* item) const
{
    for (int i= 0; i < count; i++)
    {
        if (pointers[i] == item)
            return(i);
    };
    return(-1);
};

void CCacheList::Move(int source, int dest)
{
    utiassert(source >= 0 && dest < count);
    CUtiOB* temp;
    temp = pointers[source];
    pointers[source] = pointers[dest];
    pointers[dest] = temp;
}

void CCacheList::Pack()
{
    int newcount=inc;
    for (int i = 0; i < count; i++)
    {
        if (pointers[i] != NULL)
            newcount++;
    };
    CUtiOB** ptr = ReserveMem(newcount);//new LPVOID[newcount];
    capacity = newcount;
    newcount=0;
    for (int i = 0; i < count; i++)
    {
        if (pointers[i] != NULL)
        {
            ptr[newcount]	= pointers[i];
            newcount++;
        }
    };
    count = newcount;
    // delete [] pointers;
    FreeMem(pointers);
    pointers = ptr;
}

void CCacheList::AddList(CCacheList* list)
{
    int oldcount = count;
    ValidNewSize(count+list->count);
    memcpy(&pointers[oldcount], list->pointers, list->count*sizeof(CUtiOB*));
};

/*void CCacheList::AddList(CUtiList *list)
{
    NODE_PTR node = list->GetFirstItem();
    while (node)
    {
        Add(node->data);
        list->GetNextPointer(node);
    };


};*/



HResult CCacheList::ReadList(CStream & Stream, int Flags, int version, CUtiOB* (UTICDECL *enumfunc)(CUtiOB* parent, int type), CUtiOB* parent)
{
    Clear();
    Stream.ReadInteger(count);
    int type = 0;
    //CUtiOB* ob;
    for (int i = 0; i < count; i++)
    {

        Stream.ReadInteger(type);
        if (type == UTI_UTIOB)
            return(UTI_READERROR);
        CUtiOB* t = enumfunc(parent, type);
        if (t)
        {
            t->Read(Stream, Flags, version);
            Add(t);
        };
    }
    return(UTI_OK);
}

HResult CCacheList::Write(CStream & Stream, int Flags, int version)
{

    Stream.WriteInteger(count);
    CUtiOB *obj;
    for (int i=0; i< count; i++)
    {
        obj = (CUtiOB*)pointers[i];
        if (version == 1)
        {
            //	    Stream.WriteInteger(obj->typinfo);
        };
        obj->Write(Stream, Flags, version);
    };
    return(UTI_OK);
}

/*void CReferenceList::FreeItem(CUtiOB** item)
{
   CUtiOB* ob = *item;
    *item = NULL;
	if (deleteItems) {
	   utiassert(dynamic_cast<ReferenceUtiOB*>(ob) != NULL);
	   static_cast<ReferenceUtiOB*>(ob)->decRef();
	};
}


CReferenceList::CReferenceList()
{

}

CReferenceList::~CReferenceList()
{

}*/


int CHeapList::getParent(int k)
{
    if (k == 0)
        return -1;
    if (k && 1 == 0)
    {
        return (k-2) >> 1;
    }
    else
    {
        return (k-1) >> 1;
    };
    return -1;

}

void CHeapList::Add(CUtiOB* item)
{
    CCacheList::Add(item);
    upheap(count-1);
}

int CHeapList::GetItemWeighti(int i)
{

    return ((CUtiOB*)pointers[i])->getWeighti();
};

void CHeapList::downheap(int item)
{
    int itemweight = GetItemWeighti(item);
    int childleft;
    int childright;
    int chwl, chwr;
    while (true)
    {
        childleft = item*2+1;
        childright = item*2+2;
        if (childleft >= count)
            return;
        if (childright >= count)
        {
            chwl = GetItemWeighti(childleft);
            if (chwl > itemweight)
            {
                Move(childleft, item);
                return;
            };
            return;
        };
        chwl = GetItemWeighti(childleft);
        chwr = GetItemWeighti(childright);
        if (chwl <= itemweight && chwr <= itemweight)
            return;
        if (chwl > itemweight || chwr > itemweight)
        {
            if (chwl > chwr)
            {
                Move(childleft, item);
                item = childleft;

            }
            else
            {
                Move(childright, item);
                item = childright;
            };

        };
    };
}

void CHeapList::upheap(int item)
{
    int parent = getParent(item);
    int itemweight = GetItemWeighti(item);
    while (parent != -1)
    {
        int pw =GetItemWeighti(parent);
        if (pw < itemweight)
        {
            //Move(parent, item);
            CUtiOB* temp;
            temp = pointers[parent];
            pointers[parent] = pointers[item];
            pointers[item] = temp;

            //Move
            item = parent;
            parent = getParent(item);
        }
        else
        {
            //Ok
            return;
        };
    };
}

void CHeapList::Delete(int index)
{    utiassert(index == 0);
    if (index != 0)
        return;
    if (count == 1)
    {
        CCacheList::Delete(0);
        return;
    }
    CUtiOB* t = pointers[0];
    pointers[0] = pointers[count-1];


    ValidNewSize(count-1);
    FreeItem(&t);

    downheap(0);
};


/*CPersistentMem::CPersistentMem() : CUtiOB()
{
}

HResult CPersistentMem::Read(CStream & Stream, int Flags, int version)
{
    Stream.ReadData(data, datasize);
    return 0;
}

HResult CPersistentMem::Write(CStream & Stream, int Flags, int version)
{
    Stream.WriteData(data, datasize);
    return 0;
}

CPersistent::CPersistent()
{
    list.deleteItems = true;
}

void CPersistent::AddMem(LPVOID data, int datasize)
{
    CPersistentMem* mem = new CPersistentMem();
    mem->data = data;
    mem->datasize = datasize;
    list.Add(mem);

}
HResult CPersistent::Read(CStream & Stream, int Flags, int version)
{
    for (int i = 0; i < list.count; i++)
    {
        CUtiOB* o = (CUtiOB*)list[i];
        o->Read(Stream, Flags, version);
    };
    return 0;
}

HResult CPersistent::Write(CStream & Stream, int Flags, int version)
{
    for (int i = 0; i < list.count; i++)
    {
        CUtiOB* o = (CUtiOB*)list[i];
        o->Write(Stream, Flags, version);
    };
    return 0;
}

void CPersistent::SaveToFile(U_CHAR* filename)
{
    CFileStream strm(filename, S_WRITE);
    Write(strm, 0, 1);
}

void CPersistent::LoadFromFile(U_CHAR* filename)
{
    CFileStream strm(filename, S_READ);
    Read(strm, 0, 1);

}

*/

void* CThread::Execute()
{
    return NULL;
}



void CThread::Terminate()
{
    ToTerminate = true;
}

void _MichiThreadProc(void* pParam)
{
#ifdef WIN32THREAD
	((CThread*)pParam)->threadid = GetCurrentThreadId();
#endif
    ((CThread*)pParam)->Execute();
};
#ifndef WIN32THREAD
void* _MichiThreadProc_POSIX(void* pParam)
{
   void* d =((CThread*)pParam)->Execute();
	pthread_exit(NULL);
	return d;
};
#endif

struct SThreadCollection {
    MAKE_SINGLETON(SThreadCollection)
	CCriticalSection m_threadaccess;
	std::set<CThread*> m_uti_all_running_threads;
};

MAKE_SINGLETON_IMPL(SThreadCollection);



CThread::CThread() : ReferenceUtiOB()
{
    ToTerminate = false;
    init = false;
	thread = NULL;
	threadid = 0;
	/*
#ifdef WIN32

	thread = (HANDLE)_beginthread(_MichiThreadProc, 0, this);
	#else
	pthread_t * newthread = new pthread_t;
	int rc = pthread_create(newthread, NULL, _MichiThreadProc_POSIX, this);
	thread = newthread;
	#endif*/
	
}

#ifdef WIN32THREAD
DWORD s_mainthread;
#else
pthread_t s_mainthread;
#endif

void CThread::Run()
{
   utiassert(thread == NULL);
 
#ifdef WIN32THREAD

   {
       CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
       assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(this) == SThreadCollection::getInstance()->m_uti_all_running_threads.end());
       SThreadCollection::getInstance()->m_uti_all_running_threads.insert(this);
      
   }
   thread = (HANDLE)_beginthread(_MichiThreadProc, 0, this);
   
#else
#ifdef USETHREADS
   pthread_t * newthread = new pthread_t;
   thread = newthread;
   {
       CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
       assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(this) == SThreadCollection::getInstance()->m_uti_all_running_threads.end());
       SThreadCollection::getInstance()->m_uti_all_running_threads.insert(this);
       assert(thread != 0);
   }
   int rc = pthread_create(newthread, NULL, _MichiThreadProc_POSIX, this);
   assert(rc == 0);

#endif
#endif

}

CThread::~CThread()
{
	{
        CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
		 assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(this) == SThreadCollection::getInstance()->m_uti_all_running_threads.end() || thread != NULL);
        SThreadCollection::getInstance()->m_uti_all_running_threads.erase(this);
	}
   if (thread != NULL) {
    //Terminate();
    //WaitFor();
#ifdef WIN32THREAD

#else
#ifdef USETHREADS
    //Terminate();
    //WaitFor();
      pthread_t* th = (pthread_t*)thread;
	  if (pthread_equal(s_mainthread, *th) == 0) {
          //void*res=NULL;
          int rc =/* pthread_join(*th, &res); */ pthread_detach(*th);
		  assert(rc == 0);
	  };
      delete th;
      thread = NULL;
#endif
#endif
   }
}

bool CThread::s_hasMainThreadID = false;
CThread* CThread::s_dummymainthread = NULL;


#ifdef WIN32THREAD
CThread* CThread::getCurrentThreadID()
{
	CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
	//GetCurrentThread();


	DWORD currentthread = GetCurrentThreadId();
	for (std::set<CThread*>::iterator it = SThreadCollection::getInstance()->m_uti_all_running_threads.begin(); it != SThreadCollection::getInstance()->m_uti_all_running_threads.end(); it++){
		CThread* th = *it;
		if (th->threadid == 0) continue;
		assert(th->threadid != 0);
		if (th->threadid == currentthread) {
			return th;
		}
	}
	assert(false);
	return NULL;
}
void CThread::readMainThreadID()
{
	if (s_hasMainThreadID == false) {
		s_mainthread = GetCurrentThreadId();
		assert(s_dummymainthread == NULL);
		s_dummymainthread = new CThread();
		{
			CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
			assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(s_dummymainthread) == SThreadCollection::getInstance()->m_uti_all_running_threads.end());
			SThreadCollection::getInstance()->m_uti_all_running_threads.insert(s_dummymainthread);
		//	pthread_t* th = new pthread_t;
			s_dummymainthread->thread = NULL;// s_mainthread;
			s_dummymainthread->threadid = s_mainthread;
			//*th = s_mainthread;

		}
		s_hasMainThreadID = true;
	}
}

bool CThread::isMainThread()
{
	utiassert(s_hasMainThreadID == true);
	DWORD id = GetCurrentThreadId();
	if (s_mainthread == id) {
		return true;
	} else {
		return false;
	};
	return true;
}
#else


CThread* CThread::getCurrentThreadID()
{
    CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
	pthread_t currentthread = pthread_self();
    for (std::set<CThread*>::iterator it = SThreadCollection::getInstance()->m_uti_all_running_threads.begin(); it != SThreadCollection::getInstance()->m_uti_all_running_threads.end(); it++){
		CThread* th = *it;
		if (th->thread == NULL) continue;
		assert(th->thread != NULL);
		if (pthread_equal(*((pthread_t*)th->thread), currentthread) != 0) {
			return th;
		}
	}
	assert(false);
	return NULL;
}
void CThread::readMainThreadID()
{
	if (s_hasMainThreadID == false) {
   //       ptw32_processInitialize();
		s_mainthread = pthread_self();
		assert(s_dummymainthread == NULL);
		s_dummymainthread = new CThread();
		{
            CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
            assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(s_dummymainthread) == SThreadCollection::getInstance()->m_uti_all_running_threads.end());
            SThreadCollection::getInstance()->m_uti_all_running_threads.insert(s_dummymainthread);
			pthread_t* th = new pthread_t;
			s_dummymainthread->thread = th;
			*th = s_mainthread;

		}
		s_hasMainThreadID = true;
	}
}

bool CThread::isMainThread()
{
  utiassert(s_hasMainThreadID == true);
  if (pthread_equal(s_mainthread, pthread_self()) != 0) {
    return true;
  } else {
    return false;
  };
  return true;
}

#endif

int CThread::getProcessorThreadCount()
{
#ifdef WIN32
    SYSTEM_INFO sysinfo;
    GetSystemInfo(&sysinfo);
    return sysinfo.dwNumberOfProcessors;
#else
    return sysconf(_SC_NPROCESSORS_ONLN);
#endif

}


void CThread::IsReady()
{
    init = true;
}

void* CThread::WaitFor()
{
#ifdef WIN32THREAD
   WaitForSingleObject(thread, INFINITE );
   return NULL;
#else
    assert(isMainThread());
   void* value=NULL;
   if (thread == NULL) {
       return 0;
   }
   int r = pthread_join((*(pthread_t *)thread), &value);
   assert(r == 0);

   {
	   CCSControl cs(SThreadCollection::getInstance()->m_threadaccess);
	   assert(SThreadCollection::getInstance()->m_uti_all_running_threads.find(this) != SThreadCollection::getInstance()->m_uti_all_running_threads.end());
	   SThreadCollection::getInstance()->m_uti_all_running_threads.erase(this);
   }

   pthread_t* th = (pthread_t*)thread;


   delete th;
   thread = NULL;
   return value;
#endif

   return 0;
}


int CThread::KillThread()
{
#ifdef WIN32THREAD
    _endthread();
#else
   pthread_exit(NULL);

#endif

    return 0;
}

CSpinLock::CSpinLock()
{
   exclusion = 0;
}

CSpinLock::~CSpinLock()
{

}
void CSpinLock::Enter()
{
#ifdef _MSC_VER
	while (InterlockedCompareExchange(&exclusion, 1, 0)) {
		while (exclusion) {};
	}
#else
    while (__sync_lock_test_and_set(&exclusion, 1)) {
        while (exclusion) {};
    }
#endif
}
void CSpinLock::Leave()
{
#ifdef _MSC_VER

#else
    __sync_synchronize();
#endif
    exclusion = 0;
}
bool CSpinLock::tryEnter()
{
#ifdef _MSC_VER
	return InterlockedCompareExchange(&exclusion, 1, 0) == 0;
#else
    return !__sync_lock_test_and_set(&exclusion, 1);
#endif
}

CCriticalSection::CCriticalSection() : CUtiOB()
{

#ifdef WIN32THREAD
    cs = new CRITICAL_SECTION;
    InitializeCriticalSection((CRITICAL_SECTION*)cs);
#else
    pthread_mutex_t* mymutex = new pthread_mutex_t;
    int r = pthread_mutex_init(mymutex, NULL);
    assert(r == 0);
	cs = mymutex;
#endif
}
CCriticalSection::~CCriticalSection()
{
#ifdef WIN32THREAD
    DeleteCriticalSection((CRITICAL_SECTION*)cs);
    delete (CRITICAL_SECTION*)cs;
#else
    int r = pthread_mutex_destroy((pthread_mutex_t*) cs);
    assert(r == 0);
	delete (pthread_mutex_t*) cs;
#endif

}

bool CCriticalSection::tryEnter()
{
#ifdef WIN32THREAD
    return TryEnterCriticalSection((CRITICAL_SECTION*)cs);
#else
 //   Datentyp testen
	return pthread_mutex_trylock((pthread_mutex_t*) cs);

#endif
}

void CCriticalSection::Enter()
{
#ifdef WIN32THREAD
    EnterCriticalSection((CRITICAL_SECTION*)cs);
#else
    int res = pthread_mutex_lock((pthread_mutex_t*) cs);
    assert(res == 0);
#endif
}
void CCriticalSection::Leave()
{
#ifdef WIN32THREAD
    LeaveCriticalSection((CRITICAL_SECTION*)cs);
#else
   int res = pthread_mutex_unlock((pthread_mutex_t*) cs);
   assert(res == 0);
#endif
}
#ifdef WIN32THREAD
class CSignalInternWin32 : public ReferenceUtiOB
{
public:
	int waiters_count;
	// Count of the number of waiters.

	CCriticalSection waiters_count_lock;
	// Serialize access to <waiters_count_>.

	int release_count;
	// Number of threads to release via a <pthread_cond_broadcast> or a
	// <pthread_cond_signal>. 

	int wait_generation_count;
	// Keeps track of the current "generation" so that we don't allow
	// one thread to steal all the "releases" from the broadcast.
	HANDLE Event;
};
#endif


CUtiSignal::CUtiSignal()
{
    //	this->Name = Name;
#ifdef WIN32THREAD

	CSignalInternWin32* cv = new CSignalInternWin32();
	cv->waiters_count = 0;
	cv->wait_generation_count = 0;
	cv->release_count = 0;

	// Create a manual-reset event.
	cv->Event = CreateEvent(NULL,  // no security
		TRUE,  // manual-reset
		FALSE, // non-signaled initially
		NULL); // unnamed
	m_internalstorage = cv;
#else
    pthread_cond_t* cond = new pthread_cond_t;
    Event = cond;
    int r=pthread_cond_init((pthread_cond_t*)Event, NULL);
    assert(r == 0);
#endif
}

CUtiSignal::~CUtiSignal()
{
#ifdef WIN32THREAD
	CHECKEXISTANCE
	CSignalInternWin32* cv = check_cast<CSignalInternWin32*>(m_internalstorage.get());
	CHECKEXISTANCEOF(cv);
    CloseHandle(cv->Event);
#else
    int r = pthread_cond_destroy((pthread_cond_t*)Event);
assert(r == 0);
    delete (pthread_cond_t*)Event;
#endif
}

void CUtiSignal::WaitFor(CCriticalSection* external_mutex)
{
	CHECKEXISTANCE;
#ifdef WIN32THREAD
	CSignalInternWin32* cv = check_cast<CSignalInternWin32*>(m_internalstorage.get());
	CHECKEXISTANCEOF(cv);
	// Avoid race conditions.
	//EnterCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Enter();

	// Increment count of waiters.
	cv->waiters_count++;

	// Store current generation in our activation record.
	int my_generation = cv->wait_generation_count;

	//LeaveCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Leave();
	//LeaveCriticalSection(external_mutex);
	external_mutex->Leave();

	for (;;) {
		// Wait until the event is signaled.
		WaitForSingleObject(cv->Event, INFINITE);

		//EnterCriticalSection(&cv->waiters_count_lock);
		cv->waiters_count_lock.Enter();
		// Exit the loop when the <cv->event_> is signaled and
		// there are still waiting threads from this <wait_generation>
		// that haven't been released from this wait yet.
		int wait_done = cv->release_count > 0
			&& cv->wait_generation_count != my_generation;
		//LeaveCriticalSection(&cv->waiters_count_lock);
		cv->waiters_count_lock.Leave();

		if (wait_done)
			break;
	}

	//EnterCriticalSection(external_mutex);
	external_mutex->Enter();
	//EnterCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Enter();
	cv->waiters_count--;
	cv->release_count--;
	int last_waiter = cv->release_count == 0;
	//LeaveCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Leave();

	if (last_waiter)
		// We're the last waiter to be notified, so reset the manual event.
		ResetEvent(cv->Event);
#else
int r = pthread_cond_wait((pthread_cond_t*)Event, (pthread_mutex_t*) external_mutex->cs);
assert(r == 0);
#endif
}

void CUtiSignal::Signal()
{
#ifdef WIN32THREAD
	CHECKEXISTANCE
		CSignalInternWin32* cv = check_cast<CSignalInternWin32*>(m_internalstorage.get());
	CHECKEXISTANCEOF(cv);
	//EnterCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Enter();
	if (cv->waiters_count > cv->release_count) {
		SetEvent(cv->Event); // Signal the manual-reset event.
		cv->release_count++;
		cv->wait_generation_count++;
	}
//	LeaveCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Leave();
#else
    int r = pthread_cond_signal((pthread_cond_t*)Event);
assert(r == 0);
#endif
}

void CUtiSignal::Broadcast()
{
#ifdef WIN32THREAD
	CHECKEXISTANCE
		CSignalInternWin32* cv = check_cast<CSignalInternWin32*>(m_internalstorage.get());
	CHECKEXISTANCEOF(cv);
	//EnterCriticalSection(&cv->waiters_count_lock);
	cv->waiters_count_lock.Enter();
  if (cv->waiters_count > 0) {  
	  SetEvent(cv->Event);
    // Release all the threads in this generation.
    cv->release_count = cv->waiters_count;

    // Start a new generation.
    cv->wait_generation_count++;
  }
 // LeaveCriticalSection(&cv->waiters_count_lock);
  cv->waiters_count_lock.Leave();
#else
    int r = pthread_cond_broadcast((pthread_cond_t*)Event);
assert(r == 0);
#endif

}

 int CUtiSignal::WaitFor(CCriticalSection* mutex, int timeout)
{
#ifdef WIN32THREAD
	CHECKEXISTANCE
		CSignalInternWin32* cv = check_cast<CSignalInternWin32*>(m_internalstorage.get());
	CHECKEXISTANCEOF(cv);
	assert(false);
    //return WaitForSingleObject(Event, timeout);
	return 0;
#else
	wcout << L"Braucht man hier Mutexe?";
	//pthread_cond_wait
	utiassert(false);
    return 0;
#endif
    //WAIT_OBJECT_0
    //WAIT_TIMEOUT
    //WAIT_FAILED

}

void CMemController::FreeMemory(CUtiOB* ob)
{
    delete ob;
}


CUtiOB* CMemoryManager::GetObjectUti()
{
    for (int i = 0; i < UTI_MEM_SIZE; i++)
    {
        if (Buffer[i])
        {
            CUtiOB* bf = Buffer[i];
            Buffer[i] = NULL;
            DoInit(bf);
            return bf;
        };
    };
    return CreateObject();
}

void CMemoryManager::FreeObject(CUtiOB* ob)
{
    Put(ob);
}

void CMemoryManager::Put(CUtiOB* ob)
{

    for (int i = 0; i < UTI_MEM_SIZE; i++)
    {
        if (!Buffer[i])
        {
            Buffer[i] = ob;
            DoFree(ob);
            return;
        };
    };
    delete ob;
}

CMemoryManager::CMemoryManager() : CUtiOB()
{
    zeromem(Buffer, sizeof(LPVOID)*UTI_MEM_SIZE);

}

CMemoryManager::~CMemoryManager()
{
    for (int i = 0; i < UTI_MEM_SIZE; i++)
    {
        if (Buffer[i])
        {
            delete Buffer[i];
            return;
        };
    };
}
void WriteCode(CStream &Stream, SCode code, int version)
{
    if (version >= 11)
    {
        Stream.WriteData(&code, sizeof(code));
    }
    else
    {

        Stream.WriteData(&code, 8);

    };
};
void ReadCode(CStream &Stream, SCode &code, int version)
{
    if (version >= 11)
    {
        Stream.ReadData(&code, sizeof(code));
    }
    else
    {
        code = NULLCODE;
        Stream.ReadData(&code, 8);

    };
};

//CBaseObject
//    CUtiOB* FParent;
/*void CBaseObject::GetTypeInfo(LPVOID P, TBaseObjOperation Operation, int readFlags, int version)
{
}

void CBaseObject::RString(LPVOID P, LPVOID str, U_CHAR* std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    CUtiString* st = (CUtiString*)str;
    switch (op->Operation)
    {
    case opCreate:
        {
            *st =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            st->Read(*op1->Stream, op1->Flags, op1->version);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            st->Write(*op1->Stream, op1->Flags, op1->version);
        }
        ;
        break;
    };
}

void CBaseObject::RInt(LPVOID P, int* value, int std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            *value =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->ReadInteger(*value);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->WriteInteger(*value);
        }
        ;
        break;
    };
}

void CBaseObject::RFloat(LPVOID P, float* value, float std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            *value =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->ReadFloat(*value);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->WriteFloat(*value);
        }
        ;
        break;
    };
}

void CBaseObject::RDouble(LPVOID P, double* value, double std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            *value =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->ReadDouble(*value);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->WriteDouble(*value);
        }
        ;
        break;
    };
}

void CBaseObject::RVector(LPVOID P, LPVOID vector, float stdx, float stdy, float stdz, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    CVector* v = (CVector*)vector;
    switch (op->Operation)
    {
    case opCreate:
        {
            v->setVector(stdx, stdy, stdz);
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            //op1->Stream->ReadDouble(*value);
            v->Read(*op1->Stream);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            v->Write(*op1->Stream);
        }
        ;
        break;
    };
}

void CBaseObject::RVectorList(LPVOID P, CCacheList *vlist, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            vlist->deleteItems = true;
        }
        ;
        break;
    case opDestroy:
        {
            vlist->Clear();
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            //op1->Stream->ReadDouble(*value);
            //v->Read(op1->Stream);
            vlist->Clear();
            int count;
            op1->Stream->ReadInteger(count);
            CVector* k;
            for (int i = 0; i < count; i++)
            {
                k = new CVector();
                k->Read(*op1->Stream);
                vlist->Add(k);
            };
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            int c = vlist->count;
            op1->Stream->WriteInteger(c);
            for (int i = 0; i < c; i++)
            {
                CVector* k = (CVector*)vlist->pointers[i];
                k->Write(*op1->Stream);
            };
        }
        ;
        break;
    };
}

void CBaseObject::RClassList(LPVOID P, CCacheList *classlist, int fl,CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent), U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            classlist->deleteItems = true;
        }
        ;
        break;
    case opDestroy:
        {
            classlist->Clear();
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            //op1->Stream->ReadDouble(*value);
            //v->Read(op1->Stream);
            classlist->Clear();
            int count;
            op1->Stream->ReadInteger(count);
            CUtiOB* k;
            for (int i = 0; i < count; i++)
            {
                k = createfunc(this);
                k->Read(*op1->Stream, op1->Flags, op1->version);
                classlist->Add(k);
            };
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            int c = classlist->count;
            op1->Stream->WriteInteger(c);
            for (int i = 0; i < c; i++)
            {
                CUtiOB* k = (CUtiOB*)classlist->pointers[i];
                k->Write(*op1->Stream, op1->Flags, op1->version);
            };
        }
        ;
        break;
    };

}

void CBaseObject::RMultiClassList(LPVOID P, CCacheList *classlist, int fl,CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent, UINT type), U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            classlist->deleteItems = true;
        }
        ;
        break;
    case opDestroy:
        {
            classlist->Clear();
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            //op1->Stream->ReadDouble(*value);
            //v->Read(op1->Stream);
            classlist->Clear();
            int count;
            op1->Stream->ReadInteger(count);
            CUtiOB* k;
            int kp;
            for (int i = 0; i < count; i++)
            {
                op1->Stream->ReadInteger(kp);
                k = createfunc(this, kp);
                k->Read(*op1->Stream, op1->Flags, op1->version);
                classlist->Add(k);
            };
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            int c = classlist->count;
            op1->Stream->WriteInteger(c);
            for (int i = 0; i < c; i++)
            {
                CUtiOB* k = (CUtiOB*)classlist->pointers[i];
                //  op1->Stream->WriteInteger(k->typinfo);
                k->Write(*op1->Stream, op1->Flags, op1->version);
            };
        }
        ;
        break;
    };
}

void CBaseObject::RClass(LPVOID P, CUtiOB** ob, int fl, CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent),U_CHAR* name)
{

    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            if (createfunc)
                *ob = createfunc(this);
        }
        ;
        break;
    case opDestroy:
        {
            if (createfunc)
                delete *ob;
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            (*ob)->Read(*op1->Stream, op1->Flags, op1->version);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            (*ob)->Write(*op1->Stream, op1->Flags, op1->version);
        }
        ;
        break;
    };
}

void CBaseObject::RCode(LPVOID P, SCode * code, bool zero, int fl, U_CHAR* name)
{

    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            if (zero)
            {
                *code =NULLCODE;
            }
            else
            {
                *code = createCode();
            };
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            // op1->Stream->ReadData(code, sizeof(SCode));
            ReadCode(*op1->Stream, Code, op1->version);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            // op1->Stream->WriteData(code, sizeof(SCode));
            WriteCode(*op1->Stream, Code, op1->version);
        }
        ;
        break;
    };
}

void CBaseObject::RDate(LPVOID P, double * code, double std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            *code =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->ReadData(code, sizeof(double));
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->WriteData(code, sizeof(double));
        }
        ;
        break;
    };
}

void CBaseObject::RBool(LPVOID P, bool* bvar, bool std, int fl, U_CHAR* name)
{
    TBaseOperation* op = (TBaseOperation*)P;
    switch (op->Operation)
    {
    case opCreate:
        {
            *bvar =std;
        }
        ;
        break;
    case opDestroy:
        {
        }
        ;
        break;
    case opRead:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->ReadBoolean(*bvar);
        }
        ;
        break;
    case opWrite:
        {
            TBaseSaveInfo *op1 = (TBaseSaveInfo*)P;
            op1->Stream->WriteBoolean(*bvar);
        }
        ;
        break;
    };
}


//	SCode Code;
//	UINT Flags;
CBaseObject::CBaseObject(CUtiOB* parent) : CUtiOB()
{
    FParent = parent;
    Flags = 0;
    Code = createCode();
    TBaseOperation op;
    op.Operation = opCreate;
    GetTypeInfo(&op, opCreate, 0, 0);
}

CBaseObject::~CBaseObject()
{

    TBaseOperation op;
    op.Operation = opDestroy;
    GetTypeInfo(&op, opDestroy, 0, 0);
}

HResult CBaseObject::Read(CStream & Stream, int Flags, int version)
{
    Stream.ReadInteger(this->Flags);
    //Stream.ReadData(&Code, sizeof(Code));
    ReadCode(Stream, Code, version);
    TBaseSaveInfo op;
    op.Operation = opRead;
    op.Stream = &Stream;
    op.Flags = Flags;
    op.version = version;
    GetTypeInfo(&op, opRead, Flags, version);
    return 0;
}
HResult CBaseObject::Write(CStream & Stream, int Flags, int version)
{
    Stream.WriteInteger(this->Flags);
    Stream.WriteData(&Code, sizeof(Code));
    TBaseSaveInfo op;
    op.Operation = opWrite;
    op.Stream = &Stream;
    op.Flags = Flags;
    op.version = version;
    GetTypeInfo(&op, opWrite, Flags, version);
    return 0;
}

CUtiOB* CBaseObject::GetParent()
{
    return FParent;
}
CUtiOB* CBaseObject::SearchObj(SCode code)
{
    return NULL;

}*/

typedef set
    <const CUtiOB*>::iterator iter;

void DumpMemory()
{
#ifdef USEMEMDUMP
   /* ofstream printout("memdump.txt");
    for (iter i = UtiOBInstanceObj.begin(); i != UtiOBInstanceObj.end(); i++)
    {
        const CUtiOB* ob = *i;
        printout << typeid(*ob).name() << "\n";
    }*/
#endif
}


/*
Object::~Object()
{

}*/

int CUtiOB::hashCode() const
{
   return (UTI_INT64)this;
}

bool CUtiOB::equals(CUtiOB* other)
{
   return this == other;
}

CUtiString CUtiOB::toString()
{
   CUtiString str;
   str.IntToStr(hashCode());
   return str;
}

Exception::Exception()
{

}

Exception::~Exception()
{

};


bool compareFileName(const CUtiString& name1, const CUtiString& name2)
{
    #ifdef WIN32
    return name1.LowerCase() == name2.LowerCase();
    #else
    return name1 == name2;

    #endif
}

/*Exception::Exception(const CUtiString& ex)
{
	str = new CUtiString();
   *str = ex;
}*/

