#pragma once
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//Uti3DCore
//Definition der Basisklassen
#ifndef __UTI3DCORE__
#define __UTI3DCORE__

#include "utibuild.h"
#define NOMINMAX
#ifndef UNSTABLE
//#define UNSTABLE
#endif

#ifndef NDEBUG
//#define NDEBUG

#endif
#ifdef NDEBUG
//#define NDEBUG
#define NDEBUGSYNC
#endif
#ifndef NDEBUGSYNC
//#define NDEBUGSYNC
#endif
#define UTI_VERSION03
#ifndef UTI_DEMO
//#define UTI_DEMO
#endif

#ifndef _MSC_VER
#ifndef __APPLE__
#ifndef UTI_RELEASE
#define HAVE_BOOST
#endif
#endif
#endif

//#define UTI_ANDROID
//#define USEJAVA
//#define USE_OGG
//#define USE_SIGCPP
//#define USE_FREEIMAGE


//#define UTI_APEGAME

#define USING_EASY_PROFILER
#define BUILD_WITH_EASY_PROFILER

#ifndef WIN32
#ifndef __APPLE__
//#define HAVE_BOOST_LOCALE
#endif
#endif
//#define HAVE_ZZIP
#define HAVE_FREETYPE
#ifdef WIN32
#define WIN32THREAD

#endif
#ifndef NDEBUG
#ifndef _MSC_VER
//#define USEMEMDUMP
#endif
#define UTIDEBUG

#else
//#define NDEBUG
#endif
//#define USEMEMDUMP
#include "gdef.h"
/*#ifdef __APPLE__
 * Nur bei cpp paramter:  -stdlib=libc++
#define HAVE_TYPE_TRAITS
#endif*/

#include <assert.h>

#ifndef _MSC_VER
#include <unistd.h>
#define utiisnan(a) std::isnan(a)
#define utiisnormal(a) std::isnormal(a)
#define utiisfinite(a) std::isfinite(a)
#else
//typedef int off_t;

#include <stddef.h>
#include <wchar.h>
#ifndef _MSC_VER
#define utiisnan(a) std::_isnan(a)
#define utiisnormal(a) std::isnormal(a)
#else
#define utiisnan(a) (a != a)
#define utiisnormal(a) (!(a != a))
//Correct?
#define utiisfinite(a) (!(a != a))
#endif
#endif

#if defined(_LP64) ||defined(__LP64__) || _WIN64
#define UTI_64BIT
#endif

#include "utichar.h"
#include "limits.h"
//#include <iostream>
#ifndef _UNICODE
#define _UNICODE
#endif

#ifdef _UNICODE
#ifndef UNICODE
#define UNICODE
#endif

#endif



#ifdef __GNUC__
#define THREADLOCAL   __thread
#else
#define THREADLOCAL __declspec(thread)
#endif

class Element;
class CUtiString;

const int UTI_ERROR_SERIOUS = 1;
const off_t UTI_INVALIDINDEX = -1;

typedef double utifloat;
#define USE_DOUBLE

void UtiLog(int level, const CUtiString& errortext);
void UtiError(int id, const CUtiString& errortext);
void UtiMessageBox(const CUtiString& caption, const CUtiString& text);

typedef long long UTI_INT64;
typedef unsigned long long UTI_UINT64;

inline int umin(int a, int b)
{
   return a < b ? a : b;
}

inline int umax(int a, int b)
{
   return a > b ? a : b;
}

inline UTI_INT64 umin(UTI_INT64 a, UTI_INT64 b)
{
   return a < b ? a : b;
}

inline UTI_INT64 umax(UTI_INT64 a, UTI_INT64 b)
{
   return a > b ? a : b;
}


inline float umin(float a, float b)
{
   return a < b ? a : b;
}
inline float umax(float a, float b)
{
   return a > b ? a : b;
}

inline double umin(double a, double b)
{
   return a < b ? a : b;
}
inline double umax(double a, double b)
{
   return a > b ? a : b;
}

const double UTI_PI = 3.14159265359;

const int UTI_OK = 0;
const int UTI_FILENOTFOUND = 1002;
const int UTI_CLASSNOTFOUND = 1003;
const int UTI_WRITEERROR = 1004;
const int UTI_WRONGFILEFORMAT = 1005;
const int UTI_FILEFORMATERROR = 1007;
const int UTI_READERROR = 1001;
const int UTI_ERROR_SAME_CLASS = 1000; //Wenn assign mit derselben Klasse aufgerufen wird

typedef unsigned int HResult;

typedef void *LPVOID;
typedef unsigned int UINT;
typedef unsigned short USHORT;

typedef int U_INT32;
typedef unsigned int U_UINT32;
typedef short int U_INT16;
typedef unsigned short int U_UINT16;
typedef char U_INT8;
typedef unsigned char U_UINT8;
typedef float U_SINGLE;
typedef double U_DOUBLE;
typedef wchar_t U_CHAR;
typedef char U_SCHAR;
typedef unsigned char UCHAR;

const int S_SHIFT = 16;
const float S_MULT = 65536.0f;

const int S_READ = 0;
const int S_WRITE = 1;
const float PI =3.1415926535897932384626433832795f;
#ifndef UTEXT
#define UTEXT(a) L##a
#endif
const int UTI_UTIOB = 0;

#include "definitions.h"
//#include <iterator>
#include <string>




//#ifdef true
#ifndef NDEBUG
#define utiassert(a) {if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);}; assert(a);}
#define utiassert2(a, b){ if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);};assert(a);}
#define uassert(a, b) {if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);}; assert(a);}
#define OnErrorReturn(a, b){if (!(a)) {utiprinterror(UTEXT(#a),  __FILE__, __LINE__, __DATE__, b); return;};}
#define OnErrorReturnNULL(a, b){if (!(a)) {utiprinterror(UTEXT(#a),  __FILE__, __LINE__, __DATE__, b); return NULL;};}
#define OnErrorDisplayMessage(a, b){if (!(a)) {utiprinterror(UTEXT(#a),  __FILE__, __LINE__, __DATE__, b);}; }
#else
#define utiassert(a)
#define utiassert2(a, b)
#define uassert(a, b)
#define OnErrorReturn(a, b)
#define OnErrorReturnNULL(a, b)
#define OnErrorDisplayMessage(a, b)
#endif

#define mem_utiassert(a) {if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);}; assert(a);}
#define mem_utiassert2(a, b){ if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);};assert(a);}
#define mem_uassert(a, b) {if (!(a)) {doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__);}; assert(a);}

#define MAKE_SINGLETON(a) protected: \
    static a* Instance;\
    public: \
    static a* getInstance();

#define MAKE_SINGLETON_IMPL(a) a* a::Instance = NULL; \
    a* a::getInstance() {\
    if (Instance == NULL) { \
       Instance = new a(); \
    };\
    return Instance;\
    };


#define MAKE_SINGLETON_FAST(a) public: \
    static a* Instance;\
    public: \
    inline static a* getInstance(){\
    if (Instance == NULL) { \
       Instance = new a(); \
    };\
    return Instance;\
    };

#define MAKE_SINGLETON_IMPL_FAST(a) a* a::Instance = NULL;

#define BEGIN_INTERFACE_IMPL(parentclass, interfaceclass, interfacename)\
class interfacename ## _class : public interfaceclass\
{\
protected:\
    parentclass* m_parent;\
public:\
    interfacename ## _class(parentclass*parent) \
    {\
        m_parent = parent;\
    }\
public:

#define END_INTERFACE_IMPL(parentclass, interfaceclass, interfacename)\
};\
protected:\
   uti_refptr<interfacename ## _class> m_ ## interfacename;\
public:\
   inline interfacename ## _class* get ## interfacename() {\
       if (m_ ## interfacename.get() == NULL) {\
           m_ ## interfacename = new interfacename ## _class(this);\
       }\
       return  m_ ## interfacename.get();\
   };

/*
#else


#ifdef _DEBUG
#define utiassert(a) if (!(a)) { doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__); };
#define utiassert2(a, b) if (!(a)) { doutiassert(UTEXT(#a), __FILE__, __LINE__, __DATE__); };
#else
#define utiassert(a) ;
#define utiassert2(a, b) ;
#endif
#endif*/
void doutiassert(const U_CHAR* expression, const char* file, int line, const char* date);
void utiprinterror(const U_CHAR* expression, const char* file, int line, const char* date, const CUtiString &str);


/*#ifndef NDEBUG
#define errorassert(A, B) utiassert(A)
#else*/
#define errorassert(A, B) if (!(A)) utiprinterror(UTEXT(#A), __FILE__, __LINE__, __DATE__, B);
/*#endif*/

class CUtiOB;
class CStream;
class CUtiString;

#ifdef __MINGW32__
#define UINT64VALUE(a) a ## ULL
#elif _WIN32
#define UINT64VALUE(a) a
//#define swprintf _snwprintf
#else
#define UINT64VALUE(a) a ## ULL
#endif

//#define GetAValue(a) (a >> 24)



typedef GUID SCode;
typedef SCode TCode;
// {28CB7626-DEE5-454a-9759-30908816E33D}
static const SCode NULLCODE =
    {
        0x00000000, 0x0000, 0x0000, { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
    };
static const SCode ONECODE =
    {
        0x00000001, 0x0000, 0x0000, { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
    };

// {28CB7626-DEE5-454a-9759-30908816E33D}
static const GUID STDMAT =
    {
        0x8BEF00B1, 0x836E, 0x4B89, { 0xB2, 0xD9, 0x88, 0x2F, 0xE4, 0xE9, 0x10, 0xE1 }
    };

/*__inline bool operator<(SCode guidOne, SCode guidOther)
{
   if (guidOne == guidOther) return false;
   if (guidOne.Data1 < guidOther.Data1) return true;
   if (guidOne.Data1 != guidOther.Data1) return false;
   if (guidOne.Data2 < guidOther.Data2) return true;
   if (guidOne.Data2 != guidOther.Data2)\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00\00ta3 < guidOther.Data3) return true;
   if (guidOne.Data3 != guidOther.Data3) return false;
   for (int i = 0; i < 8; i++)  {
      if (guidOne.Data4[i] < guidOther.Data4[i]) return true;
      if (guidOne.Data4[i] != guidOther.Data4[i]) return false;
};
   return false;
}*/

template<class T, class Old> inline T check_cast(Old element)
{
 utiassert(dynamic_cast<T>(element) != NULL);
 return static_cast<T>(element);
}

template<class T, class Old> inline T check_cast_dyn(Old element)
{
 utiassert(dynamic_cast<T>(element) != NULL);
 return dynamic_cast<T>(element);
}

template<class T, class Old> inline T check_cast_or_zero(Old element)
{
    if (element == NULL)return NULL;
 utiassert(dynamic_cast<T>(element) != NULL);
 return static_cast<T>(element);
}

template<class T> inline T checkNoneZero(T element)
{
 utiassert(element != NULL);
 return element;
}

void ForceDir(const CUtiString &path);
void zeromem(LPVOID l, int count);
void DumpMemory();
int urandom(int max);
float urandom();
const SCode createCode();
const SCode IntToCode(int i);
const int CodeToInt(const SCode i);
bool compareCode(SCode c1, SCode c2);
inline float sqr(float d)
{
    return d*d;
}

int compare(float a, float b);
bool PtInRectE(float x, float y, float x1, float y1, float x2, float y2);
bool FileExists(const CUtiString &name);
UTI_INT64 FileSize(const CUtiString &name);
inline int UtiGetRValue(int color){   return color & 0xFF;}
inline int UtiGetGValue(int color){   return (color >> 8) &0xFF;}
inline int UtiGetBValue(int color){  return (color >> 16) & 0xFF;}
inline int UtiGetAValue(int color){  return (color >> 24) & 0xFF;}

inline unsigned int UtiRGB(int r, int g, int b)
{
    return r | g << 8 | b << 16;
}

inline unsigned int UtiRGBA(unsigned int r, unsigned int g, unsigned int b, unsigned int a)
{
    return r | g << 8 | b << 16 | a << 24;
}


void ShowMessage(const wchar_t* text);
float intern_inoise(int x);
inline float intern_smooth(float a, float b, float v);
float intern_noise(float x);



#define SETRANGE(a, b, c) if (a < b) a = b; if (a > c) a = c;

typedef struct NODE_TYP
{
    CUtiOB * data;
    int value;
    NODE_TYP* next;
    NODE_TYP* prev;
}
NODE, *NODE_PTR;

typedef struct _RECT
{
    int left;
    int top;
    int right;
    int bottom;
    inline int width() const
    {
        return right-left;
    }
    inline int height() const
    {
        return bottom-top;
    }
}
UTIRECT, *PUTIRECT;


struct SVector4
{
    float x;
    float y;
    float z;
    float a;
};

struct SVector3
{
    float x;
    float y;
    float z;
};

SVector4 setVector4(float x, float y, float z, float w);
void NormRect(UTIRECT &r);
void CheckFileName(const U_CHAR* c);
int ToPower2(int i);
void Fehler(U_CHAR* s);

typedef void* UPVOID;

//typedef CUTILISTCALLBACK void (NODE_PTR, bool)
bool Writefunc(NODE_PTR node, void* data);
bool WritefuncCache(CUtiOB* ob, void* data);
typedef UINT SColor;


const size_t COPY_BUFFER_SIZE= 4096;
void copyStreamTo(CStream& dest, CStream&source, off_t count=-1);





class CUtiString;
/*
class Object {
protected:
   //virtual Object* clone();
public:
   virtual ~Object();
   virtual int hashCode();
   virtual bool equals(Object* other);
   virtual CUtiString toString();
};*/

class Exception
{
protected:
//	aptr<CUtiString> str;
public:
    Exception();
    virtual ~Exception();
//	Exception(const CUtiString& ex);

};

class CTypeInterface;
class CXNode;
class CWriteReadInterface;
class CGUICreator;
class CClassCollector;

const int UTI_EVENT_DELETE_ME = 1;


#ifdef USEMEMDUMP

void memcheck_addToMemory(CUtiOB* obj);
void memcheck_removeFromMemory(CUtiOB* obj);
bool memcheck_existsInMemory(const CUtiOB* obj);
void memcheck_init();

void memcheck_disable();

#define CHECKEXISTANCE mem_utiassert(memcheck_existsInMemory(this));
#define CHECKEXISTANCEOF(obj) mem_utiassert(memcheck_existsInMemory(obj));
#define DEBUG_EXISTS(obj) memcheck_existsInMemory(obj)

#ifdef USEMEMDUMP_HIGHSPEED
#define CHECKEXISTANCEHIGHSPEED mem_utiassert(memcheck_existsInMemory(this));
#define CHECKEXISTANCEHIGHSPEEDOF(obj) mem_sutiassert(memcheck_existsInMemory(obj));
#else

#define CHECKEXISTANCEHIGHSPEED
#define CHECKEXISTANCEHIGHSPEEDOF(obj)
#endif

#else
#define DEBUG_EXISTS(obj) true
#define CHECKEXISTANCE
#define CHECKEXISTANCEOF(obj)
#define CHECKEXISTANCEHIGHSPEED
#define CHECKEXISTANCEHIGHSPEEDOF(obj)
#endif
void utiexit(int i);
class CUtiOB //: public Object
{
public:
    virtual ~CUtiOB();
    //CUtiOB();
    inline CUtiOB()
    {
        //	typinfo = UTI_UTIOB;
    #ifdef EDITOR
        TreeItem = 0;
    #endif
    #ifdef USEMEMDUMP

         memcheck_addToMemory(this);
    #endif
    }

/*#ifdef EDITOR

    UINT TreeItem;
    void *v;
    virtual void AddTreeItem(void* view, UINT parent, U_CHAR *c);
    virtual void DeleteItem(void* view);
#endif*/

   // int typinfo;


    virtual int hashCode() const;
    virtual bool equals(CUtiOB *other);
    virtual CUtiString toString();

    HResult Assign(CUtiOB*ob, int flags);
    virtual CUtiOB* createCopy()const {return NULL;};
    virtual void copyTo(CUtiOB* obj) const {copyToUser(obj);};
    virtual void copyToUser(CUtiOB* obj) const {};
    //virtual bool isEqual(const CUtiOB* b) const {return this == b;};
    //virtual wchar_t* GetName(){return NULL;};
    virtual CUtiOB* GetParent() {return NULL;};
    virtual bool HasParent(CUtiOB* ob) {return false;};
    virtual int getWeighti()
    {
        return 0;
    };
    virtual void TypeInfo(CTypeInterface* type)
    {};
    virtual const SCode GetTypeCode()
    {
      utiassert(false);
        return NULLCODE;
    };
    virtual CUtiString getClassName();
    virtual void deleteMe(CUtiOB* obj);
    virtual bool deleteMeUser(CUtiOB* obj);
    virtual void setCreateParent(CUtiOB* obj);
    virtual void edit(CGUICreator* guicreator, CUtiOB* info, int flags);
    virtual void entityReflection(CUtiOB* datastore, CUtiOB* mode);
    virtual const SCode GetCode();
    virtual HResult Read(CStream & Stream, int Flags, int version);
    virtual HResult Write(CStream & Stream, int Flags, int version);
    void Read(CStream * Stream, int Flags, int version){Read(*Stream, Flags, version);};
    void Write(CStream * Stream, int Flags, int version){Write(*Stream, Flags, version);};
    virtual void xread(CXNode* n, CWriteReadInterface* wri);
    virtual void xwrite(CXNode* n, CWriteReadInterface* wri);
    virtual void xreadUser(CXNode* n, CWriteReadInterface* wri);
    virtual void xwriteUser(CXNode* n, CWriteReadInterface* wri);
    virtual int GetMessageUti(CUtiOB *Sender, int msg, int lParam, void* wParam, bool &handled);
};

template<class T> T* makeCopy(const T* obj)
{
     T* copy = (T*)obj->createCopy();
     return copy;
};

template <class T>
      class Array //: public CUtiOB
{
   protected:
      bool dynamic;
      bool m_stackvar;
   public:
      T* array;
      int array_size;
      void swap(Array<T>& a)
      {
    bool temp_dynamic = dynamic;
        bool temp_stackvar = m_stackvar;

        T* temp_array = array;
        int temp_array_size = array_size;
    dynamic = a.dynamic;
    m_stackvar = a.m_stackvar;
    array = a.array;
    array_size = a.array_size;
    a.dynamic = temp_dynamic;
    a.m_stackvar = temp_stackvar;
    a.array = temp_array;
    a.array_size = temp_array_size;

      }
      bool isDynamic() const
      {
         return dynamic;
      }
      inline int size() const
      {
         return array_size;
      }
      T* getCArray()
      {
          return array;
      };
      const T* getCArray() const
      {
          return array;
      };
      inline Array(int size)// : CUtiOB()
      {
         dynamic = true;
         array_size = size;
         array = new T[array_size];
      m_stackvar = false;
      }
      inline Array(T* ar, int size, bool stackvar=false)//: CUtiOB()
      {
         dynamic = false;
         m_stackvar = stackvar;
         array_size = size;
         array = ar;
      }
      inline Array(Array &narray, int newstart, int newsize) {
    dynamic = false;
         m_stackvar = false;
     utiassert(newstart >= 0);
     utiassert(newsize >= 0);
     utiassert(newstart+newsize <= narray.size());
         array_size = newsize;
         array = narray.array+newstart;
      };
      void setDataStack(T* ar, int w)
      {assert(array == NULL);
    dynamic = false;
         array_size = w;
     utiassert(ar != NULL);
     utiassert(w >= 0);
         array = ar;
      }
      inline Array()// : CUtiOB()
      {
         array_size = 0;
         array = NULL;
         dynamic = true;
      m_stackvar = false;
      };
      inline Array(const Array &narray)
      {
     m_stackvar = false;
    if (narray.dynamic) {
        dynamic = true;
   array_size = narray.size();
   array = new T[array_size];
   for (int i = 0; i < array_size; i++)
   {
      array[i] = narray[i];

   }

    } else {
        utiassert(narray.m_stackvar == false);

       dynamic = false;
       array_size = narray.array_size;
       array = narray.array;
    }
      }
      inline ~Array()
      {
         if (dynamic && array)
            delete [] array;

      }
      inline int indexOf(const T& el, int maxcount=-1) const
      {
          assert(maxcount <= array_size);
          if (maxcount == -1 || maxcount > array_size) {
              maxcount = array_size;
          }
          for (int i = 0; i < maxcount; i++) {
              if (operator[](i) == el) return i;
          }

          return -1;
      }



      inline T* begin()
      {
          return array;
      }

      inline  T* end()
      {
          return array + array_size;
      }
      inline const T* begin()const
      {
          return array;
      }

      inline const T* end()const
      {
          return array + array_size;
      }
      inline  T* end(int index)
      {
          assert(index >= 0 && index <= array_size);
          return array + index;
      }
      inline const T* end(int index)const
      {
          assert(index >= 0 && index <= array_size);
          return array + index;
      }


      void init(T* ar, int size, bool stackvar=false)
      {
          if (dynamic && array)
            delete [] array;
        array = NULL;
          dynamic = false;
         m_stackvar = stackvar;
         array_size = size;
         array = ar;
      }
      Array & operator=(const Array &narray)
      {
    if (narray.dynamic || narray.m_stackvar ) {
   dynamic = true;
   array_size = narray.size();
   array = new T[array_size];
   for (int i = 0; i < array_size; i++)
   {
      array[i] = narray[i];

   }
    } else {
        utiassert(narray.m_stackvar == false);

       dynamic = false;
       array_size = narray.array_size;
       array = narray.array;
    }
    return *this;
      }
      bool operator==(const Array& narray)
      {
          if (narray.size() != size()) return false;

          for (int i = 0; i < array_size; i++) {
              if (!(array[i] == narray.array[i])) {
                  return false;
              }
          }
          return true;
      }

      void writeTo(T* ar, int size) const
      {
          int v = size;
          if (v > array_size) v = array_size;
          for (int i = 0; i < v; i++)
          {
              ar[i] = array[i];

          }

      }
      void setSize(int size) {
         //utiassert(array == NULL || dynamic == true);
          if (size == array_size)return;
          assert(size >= 0);
          //CHECKEXISTANCE;
         if (dynamic && array) delete [] array;
       dynamic = true;
         array_size = size;
     if (array_size == 0) {
       array = NULL;
     } else {
         array = new T[array_size];
    // dynamic = true;
     };
      };
      void setSizeCopy(int size) {
         //utiassert(array == NULL || dynamic == true);
          if (size == array_size)return;
          assert(size >= 0);
          //CHECKEXISTANCE;
         T* newarray = new T[size];

         if (array) {
            int mins = umin(array_size, size);
            for (int i = 0; i < mins; i++) {
               newarray[i] = array[i];
            };

            if (dynamic) delete [] array;
         };
         dynamic = true;
         array_size = size;
         array = newarray;
      };
      void setSizeCopyHighSpeed(int size) {
         //utiassert(array == NULL || dynamic == true);
          if (size == array_size)return;
          //CHECKEXISTANCE;
         T* newarray = new T[size];

         if (array) {
            int mins = umin(array_size, size);
            memcpy((void*)newarray, (void*)array, mins*sizeof(T));
/*#ifndef NDEBUG
            for (int i = 0; i < mins; i++) {
               assert(newarray[i] == array[i]);
            };
#endif*/

            if (dynamic) delete [] array;
         };
         dynamic = true;
         array_size = size;
         array = newarray;
      };
      void ReferenzTo(const Array &a)
      {
         dynamic = false;
         array_size = a.array_size;
         array = a.array;
      }
      void ReferenzTo(const Array &a, int start, int size)
      {
         dynamic = false;
         utiassert(start >= 0 && start+size <= a.size());
         utiassert(size >= 0);
         array_size = size;
         array = a.array + start;
      }
      inline T &operator[](unsigned int p)
      {
         utiassert((int)p >= 0 && (int)p < array_size);
         utiassert(array != NULL);
         return array[p];

      }
      inline const T &operator[](unsigned int p) const
      {
         utiassert((int)p >= 0 && (int)p < array_size);
         utiassert(array != NULL);
         return array[p];

      }
      inline const T &get(unsigned int p) const
      {
         utiassert((int)p >= 0 && (int)p < array_size);
         utiassert(array != NULL);
         return array[p];

      }
      inline void set(unsigned int p, const T& v) const
      {
         utiassert((int)p >= 0 && (int)p < array_size);
         utiassert(array != NULL);
         array[p] = v;

      }
      template<class T2> inline void writeDataType(int position, const T2& data) {
          utiassert(position >= 0 && position +sizeof(data) <= array_size);
          *((T2*)(&array[position])) = data;
      }
      template<class T2> inline void readDataType(int position, T2& data) const {
          utiassert(position >= 0 && position +sizeof(data) <= array_size);
          data = *((T2*)(&array[position]));
      }

      void fill(const T& value)
      {
     //CHECKEXISTANCE;
          for (int i = 0; i < array_size; i++) array[i] = value;
       }
     void copyToArray(int start, int count, Array& target, int targetstart) const
     {
         //CHECKEXISTANCE;
         utiassert(start >= 0);
         utiassert(start+count <= array_size);
     utiassert(targetstart >= 0);
     utiassert(targetstart+count <= target.size());
     if (count == 0) return;
     for (int i = 0; i < count; i++) {
         target.array[targetstart+i] = array[start+i];
     };
     }
     inline void copyToArrayHighSpeed(int start, int count, Array& target, int targetstart) const
     {
         //CHECKEXISTANCE;
         utiassert(start >= 0);
         utiassert(start+count <= array_size);
     utiassert(targetstart >= 0);
     utiassert(targetstart+count <= target.size());
     if (count == 0) return;
     memcpy(&target.array[targetstart], &array[start], count*sizeof(T));
     /*for (int i = 0; i < count; i++) {
         target.array[targetstart+i] = array[start+i];
     };*/
     }
     void deleteItems(int start, int end)
     {
         utiassert(start <= end);
         utiassert(start >= 0);
         utiassert(end <= array_size);
         for (int i = end; i < array_size; i++) {
             array[i-end+start] = array[i];
         }
         setSizeCopy(array_size-(end-start));

     }
     void insert(int index, const T& value)
     {
         int a = array_size;
         setSizeCopy(array_size+1);
         for (int i = a-1; i >= index; i--) {
             array[i+1] = array[i];
         }
         operator[](index) = value;
     }

    // Array& operator=(const Array & str);


};

//#define REFERENCEDEBUGVIRTUAL

class ReferenceUtiOB : public CUtiOB
{
   protected:
      int m_references;
      virtual void destroyReferenceObject();
   public:
      inline explicit ReferenceUtiOB()
      {
         m_references = 0;
      }
      ~ReferenceUtiOB();
#ifdef REFERENCEDEBUGVIRTUAL
      virtual void addRef()
#else
      inline void addRef()
#endif
      {
    CHECKEXISTANCEHIGHSPEED;
          m_references++;
      }
#ifdef REFERENCEDEBUGVIRTUAL
      virtual void decRef()
#else
     inline void decRef()
#endif
      {
    CHECKEXISTANCEHIGHSPEED;
       m_references--;
       utiassert(m_references >= 0);
       if (m_references <= 0) destroyReferenceObject();
      }
      //void addRef();
      //void decRef();
      inline int getReferenceCount() {return m_references;};
      inline void setReferenceCount(int c) {m_references = c;};
};

#define U_ADDREF(a) if (a) a->addRef();
#define U_DECREF(a) if (a) a->decRef();
#define U_SETVAR(a, v) U_DECREF(a); a = v; U_ADDREF(a);

class TypedReferenceUtiOB : public ReferenceUtiOB
{
public:
    inline explicit TypedReferenceUtiOB()
    {
    }
    virtual void xread(CXNode* n, CWriteReadInterface* wri);
    virtual void xwrite(CXNode* n, CWriteReadInterface* wri);
};

class ReferenceADR : public ReferenceUtiOB
{
protected:

    int m_javarefcount;
    int m_cpprefcount;
public:
    inline explicit ReferenceADR()
    {

        m_javarefcount = 0;
        m_cpprefcount = 0;
    }
    ~ReferenceADR();
    virtual void asyn_decRef();

    virtual void asyn_addRef();
    virtual void cpp_decRef();

    virtual void cpp_addRef();
    static void gc();
};

#ifdef USEJAVA
class ReferenceADR_GarbageCollectionControl
{
public:
    static ReferenceADR_GarbageCollectionControl* m_controller;
    ReferenceADR_GarbageCollectionControl();
    virtual void setForeignGarbageCollection(ReferenceADR* obj, bool b)=0;
};
#endif

template<class X> class uti_refptr {
public:
    typedef X element_type;
    inline uti_refptr(X* p = NULL, bool increment=true) throw() : ptr(p) { if (increment && ptr) ptr->addRef();};
    template<class Y> inline uti_refptr(const uti_refptr<Y>& a) throw() : ptr(a.get())  { if(ptr) ptr->addRef();};
    inline uti_refptr(const uti_refptr& a) throw() : ptr(a.ptr)  { if(ptr) ptr->addRef();};
    inline ~uti_refptr() throw() {/*if (ptr) ptr->decRef();*/reset(NULL);};
    template<class Y> inline uti_refptr& operator=(const uti_refptr<Y>& a) throw()
    {
        reset(a.get());
        return *this;
    };
    inline bool operator==(const X* other) const throw()
    {
       return ptr == other;
    }
    inline uti_refptr& operator=(const uti_refptr& a) throw()
    {
        reset(a.get());
        return *this;
    };
    inline bool operator==(const uti_refptr<X>& other) const throw()
    {
       return ptr == other.get();
    }
    /*inline uti_refptr<X>& operator=(const uti_refptr<X>& a) throw()
    {
        reset(a.get());
        return *this;
    }*/
    inline uti_refptr& operator=(X* a) throw()
    {
        reset(a);
        return *this;
    };
    inline bool operator<(const uti_refptr& a) const throw()
    {
      return (ptr-a.ptr) < 0;
    }
    inline bool operator>(const uti_refptr& a)const throw()
    {
      return (ptr-a.ptr) > 0;
    }
    inline X& operator*() const throw() {return *get();};
    inline X* operator->() const throw() {return get();};
    inline X* get() const throw() {return ptr;};
    inline X* getAndResetCounterToZero() throw()
    {
      if (ptr == NULL) return NULL;
      assert(ptr->getReferenceCount() == 1);
      ptr->addRef();
      X* res = ptr;
      reset();
      res->setReferenceCount(0);
      return res;
    };
    inline void reset(X* p = NULL) throw()
    {
        if (get() != p)
        {
#ifdef USEMEMDUMP
            if (p != NULL) {
                CHECKEXISTANCEOF(p)
            }
#endif
            X* a = ptr; ptr = p;
            if (a) a->decRef();
            if (ptr) ptr->addRef();
        };
    };
    inline void resetBeforeClearingThePointer(X* p = NULL) throw() {if (get() != p) { X* a = ptr;if (a) a->decRef();  if (ptr) ptr->addRef();}; ptr = p; };

    template<class Y> operator uti_refptr<Y>() throw()
    { return uti_refptr<Y>(get());};
    private:
        X* ptr;
};

template<class X> class uti_refadrptr {
public:
    typedef X element_type;
    inline uti_refadrptr(X* p = NULL, bool increment=true) throw() : ptr(p) { if (increment && ptr) ptr->cpp_addRef();};
    template<class Y> inline uti_refadrptr(const uti_refadrptr<Y>& a) throw() : ptr(a.get())  { if(ptr) ptr->cpp_addRef();};
    inline uti_refadrptr(const uti_refadrptr& a) throw() : ptr(a.ptr)  { if(ptr) ptr->cpp_addRef();};
    inline ~uti_refadrptr() throw() {/*if (ptr) ptr->decRef();*/reset(NULL);};
    template<class Y> inline uti_refadrptr& operator=(const uti_refadrptr<Y>& a) throw()
    {
        reset(a.get());
        return *this;
    };
    inline bool operator==(const X* other) const throw()
    {
       return ptr == other;
    }
    inline uti_refadrptr& operator=(const uti_refadrptr& a) throw()
    {
        reset(a.get());
        return *this;
    };
    inline bool operator==(const uti_refadrptr<X>& other) const throw()
    {
       return ptr == other.get();
    }
    /*inline uti_refptr<X>& operator=(const uti_refptr<X>& a) throw()
    {
        reset(a.get());
        return *this;
    }*/
    inline uti_refadrptr& operator=(X* a) throw()
    {
        reset(a);
        return *this;
    };
    inline bool operator<(const uti_refadrptr& a) const throw()
    {
      return (ptr-a.ptr) < 0;
    }
    inline bool operator>(const uti_refadrptr& a)const throw()
    {
      return (ptr-a.ptr) > 0;
    }
    inline X& operator*() const throw() {return *get();};
    inline X* operator->() const throw() {return get();};
    inline X* get() const throw() {return ptr;};
    inline X* getAndResetCounterToZero() throw()
    {
      if (ptr == NULL) return NULL;
      assert(ptr->getReferenceCount() == 1);
      ptr->cpp_addRef();
      X* res = ptr;
      reset();
      res->setReferenceCount(0);
      return res;
    };
    inline void reset(X* p = NULL) throw()
    {
        if (get() != p)
        {
#ifdef USEMEMDUMP
            if (p != NULL) {
                CHECKEXISTANCEOF(p)
            }
#endif
            X* a = ptr; ptr = p;
            if (a) a->cpp_decRef();
            if (ptr) ptr->cpp_addRef();
        };
    };
    inline void resetBeforeClearingThePointer(X* p = NULL) throw() {if (get() != p) { X* a = ptr;if (a) a->cpp_decRef();  if (ptr) ptr->cpp_addRef();}; ptr = p; };

    template<class Y> operator uti_refadrptr<Y>() throw()
    { return uti_refadrptr<Y>(get());};
    private:
        X* ptr;
};


class CStream : public ReferenceUtiOB
{
public:
    int count;
    bool docount;
    enum TPositionType {START, CURRENT,END};
    explicit CStream();
    void BeginCount()
    {
        docount = true;
        count = 0;
    };
    void EndCount()
    {
        docount = false;
    };
    virtual void setPosition(off_t i, TPositionType postype);
    virtual size_t getPosition(){return getReadPosition();};
    virtual size_t getReadPosition()
    {
        return(0);
    };
    virtual size_t getWritePosition()
    {
        return(0);
    };
    virtual bool eof()
    {
        return(true);
    };
    virtual bool fail()
    {
        return(false);
    };
    virtual size_t getDataSize();
    void ReadDouble(double &d);
    void WriteDouble(double d);
    void ReadFloat(float &f);
    void WriteFloat(float f);
    void ReadFloat(double &f);
    void WriteFloat(double f);
    void ReadInteger(int &i);
    void WriteInteger(int i);
    void ReadBoolean(bool &b);
    void WriteBoolean(bool b);
    virtual size_t ReadData(void* data, size_t size);
    virtual size_t WriteData(const void* data, size_t size);
double getDouble();
    float getFloat();
    bool getBool();
    U_INT32 getInt32();
    U_INT16 getInt16();
    U_INT8 getInt8();

    U_UINT32 getUInt32();
    U_UINT16 getUInt16();
    U_UINT8 getUInt8();

    void writeInt32(U_INT32 i);
    void writeInt16(U_INT16 i);
    void writeInt8(U_INT8 i);

    void writeUInt32(U_UINT32 i);
    void writeUInt16(U_UINT16 i);
    void writeUInt8(U_UINT8 i);
    void writeString(const CUtiString& str);
    void readString(CUtiString& str);
    void writeString8(const std::string& str);
    void readString8(std::string& str);

    //inline size_t Read(void* data, size_t size) {
     //   return ReadData(data, size);};
   // inline size_t Write(void* data, size_t size) {
    //    return WriteData(data, size);};
  virtual ~CStream(){};
};

class CMemoryStream;
class CFileStream;


class CNotifyEvent : public ReferenceUtiOB
{
   protected:
   public:
      CNotifyEvent();
      virtual void call(CUtiOB* ob, CUtiOB* data)=0;
};

class CEventManager : public CUtiOB
{
  MAKE_SINGLETON(CEventManager);
  protected:
    void* m_vectorlist;
  public:
    CEventManager();
    ~CEventManager();
    void registerEvent(int id, CNotifyEvent* event);
    void fireEvent(int id, CUtiOB* ob, CUtiOB* data);
};

class CMemManager : public CUtiOB
{
public:
    bool locked;
    void* data;
    int datasize;
    int fileindex;
    explicit CMemManager();
    explicit CMemManager(int datasize);
    ~CMemManager();
    void Init(int datasize);
    void Lock();
    void Unlock();
    void Free();
    void GetFilename(U_CHAR* c);
};

class CMemController : public CUtiOB
{
public:
    CMemController(): CUtiOB()
    {}
    ;
    ~CMemController()
    {}
    ;
    virtual void FreeMemory(CUtiOB* ob);
};
/*class CUtiList : public CUtiOB
{
public:
    CMemController* MemController;
    void CheckArray(int count);
    void GetObjectByValue(float value, CUtiOB* &obj);
    void GetObjects(float value, CUtiOB* &First, CUtiOB* &Next);
    void Swapitems(NODE_PTR f1, NODE_PTR f2);
    void sortItems();
    CUtiOB* getItem(int i);
    NODE_PTR getNode(int i);
    int indexof(CUtiOB* obj);
    void EnumItems(void *data, bool (*enumfunc) (NODE_PTR, void*));
    NODE_PTR indexofNode(CUtiOB *obj);
    void Clear();
    void Delete(NODE_PTR node);
    void Delete(CUtiOB *data);
    NODE_PTR Add(CUtiOB *data, float value);
    void AddList(CUtiList *list);
    bool sorted;
    bool deleteItems;
    int count;
    NODE_PTR GetFirstItem();
    bool GetNextPointer(NODE_PTR &node);
    NODE_PTR first;
    NODE_PTR last;
    CUtiList();
    ~CUtiList();
    HResult Read(CStream & Stream, int Flags, int version, CUtiOB* ( *enumfunc)(CUtiOB* parent, int type), CUtiOB* parent);
    HResult Write(CStream & Stream, int Flags, int version);
protected:

};
*/






const int UTI_MEM_SIZE =256;

class CMemoryManager : public CUtiOB
{
public:
    virtual CUtiOB* CreateObject()
    {
        return(NULL);
    };
    CUtiOB* Buffer[UTI_MEM_SIZE];
    CUtiOB* GetObjectUti();
    void FreeObject(CUtiOB* ob);
    void Put(CUtiOB* ob);
    virtual void DoFree(CUtiOB* ob)
    {}
    ;
    virtual void DoInit(CUtiOB* ob)
    {}
    ;
    CMemoryManager();
    ~CMemoryManager();
};

class CThread : public ReferenceUtiOB
{
protected:
    LPVOID thread;
    bool init;
    int KillThread(); // Eigentlich nicht noig, da return in Execute dasselbe bewirkt
    static bool s_hasMainThreadID;
    static CThread* s_dummymainthread;
public:
    unsigned long threadid;
    void IsReady();
    bool ToTerminate;
    virtual void* Execute();
    void Run();
    void Terminate();
    explicit CThread();
    ~CThread();
    void* WaitFor();
    static void readMainThreadID();
    static bool isMainThread();
    static CThread* getCurrentThreadID();
    static int getProcessorThreadCount();


};

class CSyncCheck : public CUtiOB
{
public:
    CThread* m_currentthread;
    int m_index;
    inline CSyncCheck()
    {
        m_currentthread = NULL;
        m_index= 0;
    }
    void Enter();
    void Exit();
    struct SLock
    {
        CSyncCheck& m_check;
        inline SLock(CSyncCheck& check) :m_check (check)
        {
            m_check.Enter();
        }
        inline ~SLock()
        {
            m_check.Exit();
        }
    };
};

#ifndef NDEBUG
#ifndef NDEBUGSYNC
#define NDEBUGSYNC
#endif
#endif

#ifndef NDEBUGSYNC
#define UTI_SYNC_DATA public: CSyncCheck m_uti_intern_syn_check;
#define UTI_SYNC_CALL CSyncCheck::SLock m_uti_syn_lock(m_uti_intern_syn_check);
#define UTI_SYNC_CALL_ON(obj) CSyncCheck::SLock m_uti_syn_lock(obj->m_uti_intern_syn_check);
#else
#define UTI_SYNC_DATA
#define UTI_SYNC_CALL
#define UTI_SYNC_CALL_ON(obj)

#endif



class CCriticalSection : public CUtiOB
{
  friend class CUtiSignal;
protected:
    //CRITICAL_SECTION cs;
    LPVOID cs;
public:
    explicit CCriticalSection();
    ~CCriticalSection();
    void Enter();
    void Leave();
    bool tryEnter();
};

class CSpinLock : public CUtiOB
{
protected:
#ifdef _MSC_VER
    volatile long exclusion;

#else
    volatile int exclusion;
#endif
public:
    explicit CSpinLock();
    ~CSpinLock();
    void Enter();
    void Leave();
    bool tryEnter();
};

class CCSControl
{
  protected:
    CCriticalSection& m_section;
  public:
    inline CCSControl(CCriticalSection& section) : m_section(section)
    {
      m_section.Enter();
    }
    inline ~CCSControl()
    {
      m_section.Leave();
    }
};


class CCSControlSpin
{
  protected:
    CSpinLock& m_section;
  public:
    inline CCSControlSpin(CSpinLock& section) : m_section(section)
    {
      m_section.Enter();
    }
    inline ~CCSControlSpin()
    {
      m_section.Leave();
    }
};

class CUtiSignal : public CUtiOB
{
protected:
#ifdef WIN32THREAD

    uti_refptr<ReferenceUtiOB> m_internalstorage;
#else
LPVOID Event;
#endif

public:

    explicit CUtiSignal();
    ~CUtiSignal();
    void WaitFor(CCriticalSection* external_mutex);
    //Works in Thread
    void Signal();
     void Broadcast();
    int WaitFor(CCriticalSection* mutex, int timeout);
};

class CBaseObserver : public ReferenceUtiOB
{
   protected:
   public:
      CBaseObserver();
      virtual void notifyChange(CUtiOB* source, int id, CUtiOB* changedata);
};

/*
class CPersistentMem : public CUtiOB
{
public:
    LPVOID data;
    int datasize;
    CPersistentMem();
    HResult Read(CStream & Stream, int Flags, int version);
    HResult Write(CStream & Stream, int Flags, int version);
};

class CPersistent : public CUtiOB
{
public:
    CCacheList list;
    CPersistent();
    void AddMem(LPVOID data, int datasize);
    HResult Read(CStream & Stream, int Flags, int version);
    HResult Write(CStream & Stream, int Flags, int version);
    void SaveToFile(U_CHAR* filename);
    void LoadFromFile(U_CHAR* filename);
};
*/
void WriteCode(CStream &Stream, SCode code, int version);
void ReadCode(CStream &Stream, SCode &code, int version);

#define utiproperty_rw(type, name) \
   protected: type m_ ## name; \
   public: type get ## name() const { return m_ ## name; }; \
   public: void set ## name(const type& arg0) { m_ ## name = arg0; };

#define utiproperty_rw_ptr(type, name) \
   protected: type m_ ## name; \
   public: type get ## name() const { return m_ ## name; }; \
   public: void set ## name(type& arg0) { m_ ## name = arg0; };

#define utiproperty_r(type, name) \
   protected: type m_ ## name; \
   public: type get ## name() const { return m_ ## name; };

#define utiproperty_rw_command(type, name, command) \
   protected: type m_ ## name; \
   public: type get ## name() const { return m_ ## name; }; \
   public: void set ## name(const type& arg0) { m_ ## name = arg0;command };


#define utiproperty_rw_array(type, name, size) \
   protected: type m_ ## name[size]; \
   public: type get ## name(int arg0) const { utiassert(arg0 >= 0 && arg0 < size); return m_ ## name[arg0]; }; \
   public: Array< type > get ## name ## AsArray() { return Array< type >(m_ ## name, size); };\
   public: void set ## name ## AsArray(const Array< type > &arg0) {arg0.writeTo(m_ ## name, size);};\
   public: void set ## name(int arg0, type arg1) { utiassert(arg0 >= 0 && arg0 < size); m_ ## name[arg0] = arg1;};

#define utiproperty_r_array(type, name, size) \
   protected: type m_ ## name[size]; \
   public: type get ## name(int arg0) const { utiassert(arg0 >= 0 && arg0 < size); return m_ ## name[arg0]; }; \
   public: const Array< type > get ## name ## AsArray() const { return Array< type >((type*)m_ ## name, size); };\


#define utiproperty_rw_array_command(type, name, size, command) \
   protected: type m_ ## name[size]; \
   public: type get ## name(int arg0) const { utiassert(arg0 >= 0 && arg0 < size); return m_ ## name[arg0]; }; \
   public: Array< type > get ## name ## AsArray() { return Array< type >(m_ ## name, size); };\
   public: void set ## name ## AsArray(const Array< type > &arg0) {arg0.writeTo(m_ ## name, size);command();};\
   public: void set ## name(int arg0, type arg1) { utiassert(arg0 >= 0 && arg0 < size); m_ ## name[arg0] = arg1; command();};


#define utiproperty_rw_array_command_index(type, name, p_size, command) \
   protected: type m_ ## name[p_size]; \
   public: type get ## name(int arg0) const { utiassert(arg0 >= 0 && arg0 < p_size); return m_ ## name[arg0]; }; \
   public: Array< type > get ## name ## AsArray() { return Array< type >(m_ ## name, p_size); };\
   public: void set ## name ## AsArray(const Array< type > &arg0) {arg0.writeTo(m_ ## name, p_size); int count = umin(arg0.size(), p_size); for (int i = 0; i < count; i++) command(i);};\
   public: void set ## name(int arg0,  type arg1) { utiassert(arg0 >= 0 && arg0 < p_size); m_ ## name[arg0] = arg1; command(arg0);};


#define utireference_rw(type, name) \
   protected: uti_refptr<type> m_ ## name; \
   public: type* get ## name() const {return m_ ## name.get();};\
   public: void set ## name(type* arg0) {m_ ## name = arg0;};

//public: const type* get ## name() const {return &m_ ## name.get();};


#define utireference_r(type, name) \
   protected: uti_refptr< type > m_ ## name; \
   public: type* get ## name() const {return m_ ## name.get();};


#define utiproperty_set(type, name) \
   protected: std::set< type > m_ ## name; \
   public: void register ## name (type arg0) {assert(m_ ## name.find(arg0) == m_ ## name.end()); m_ ## name.insert(arg0);}; \
   public: void unregister ## name(type arg0) {assert(m_ ## name.find(arg0) != m_ ## name.end()); m_ ## name.erase(arg0);};


template<class T> class UtiPointerClass : public ReferenceUtiOB
{
  public:
    T* m_class;
    UtiPointerClass(T* p_class)
    {
        m_class = p_class;
    };
};

template<class T> class UtiContainerClass : public ReferenceUtiOB
{
  public:
    T m_class;
    UtiContainerClass(const T &p_class)
    {
        m_class = p_class;
    };
};

bool compareFileName(const CUtiString& name1, const CUtiString& name2);
bool compareAngles(float a1, float a2, float d);


/*enum TBaseObjOperation  {opCreate, opDestroy, opRead, opWrite, opSearch};
struct TBaseOperation
{
    TBaseObjOperation Operation;
};
struct TBaseSaveInfo
{
    TBaseObjOperation Operation;
    CStream* Stream;
    int Flags;
    int version;

};

class CBaseObject : public CUtiOB
{
protected:
    CUtiOB* FParent;
    virtual void GetTypeInfo(LPVOID P, TBaseObjOperation Operation, int readFlags, int version);
    void RString(LPVOID P, LPVOID str, U_CHAR* std, int fl, U_CHAR* name);
    void RInt(LPVOID P, int* value, int std, int fl, U_CHAR* name);
    void RFloat(LPVOID P, float* value, float std, int fl, U_CHAR* name);
    void RDouble(LPVOID P, double* value, double std, int fl, U_CHAR* name);
    void RVector(LPVOID P, LPVOID vector, float stdx, float stdy, float stdz, int fl, U_CHAR* name);
    void RVectorList(LPVOID P, CCacheList *vlist, int fl, U_CHAR* name);
    void RClassList(LPVOID P, CCacheList *classlist, int fl,CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent), U_CHAR* name);
    void RMultiClassList(LPVOID P, CCacheList *classlist, int fl,CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent, UINT type), U_CHAR* name);
    void RClass(LPVOID P, CUtiOB** ob, int fl, CUtiOB* (UTICDECL *createfunc)(CUtiOB* parent),U_CHAR* name);
    void RCode(LPVOID P, SCode * code, bool zero, int fl, U_CHAR* name);
    void RDate(LPVOID P, double * code, double std, int fl, U_CHAR* name);
    void RBool(LPVOID P, bool* bvar, bool std, int fl, U_CHAR* name);
public:
    SCode Code;
    int Flags;
    CBaseObject(CUtiOB* parent);
    ~CBaseObject();
    HResult Read(CStream & Stream, int Flags, int version);
    HResult Write(CStream & Stream, int Flags, int version);
    virtual CUtiOB* GetParent();
    virtual CUtiOB* SearchObj(SCode code);

};
*/

#define U_ENGINEUNITS(a) (a/64.0f)

const float WORLD_SCAL = 1.0f;//64.0f;
const float WORLD_DIVSCAL = 1.0f;//1.0f/WORLD_SCAL;

const float U_METER = 1.0f;

class CUtiGeneralGUIInterface : public ReferenceUtiOB
{
public:
  CUtiGeneralGUIInterface();
  void messageBox(const CUtiString& caption, const CUtiString& text);
  void error(int id, const CUtiString& errortext);
  void log(int level, const CUtiString& errortext);
};

class CUtiGeneralGUI : public CUtiOB
{
  MAKE_SINGLETON(CUtiGeneralGUI);
public:
  uti_refptr<CUtiGeneralGUIInterface> m_gui;
    CUtiGeneralGUI();
    ~CUtiGeneralGUI();
};

template<int X, int P>struct intpower
{
    enum { m_value = X*intpower<X,P-1>::m_value };
};
template<int X>struct intpower<X,0>
{
    enum { m_value = 1 };
};
template<int X>struct intpower<X,1>
{
    enum { m_value = X };
};

#endif
