#pragma once
#ifndef __UTI3DTHREADS__
#define __UTI3DTHREADS__
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
///TODO: Generelle Jobqueue die die Last auf mehrere Knoten verteilt
///Bestimmte Objekte die permanent in anderen Threads arbeiten und über einen Befehlsbuffer angesprochen werden
///Rufe Methode in seperatem Thread auf!

/**Jedes Objekt soll einen Owner Thread bekommen:
  MAINTHREAD
  EVERYTHREAD
  NEXTTHREAD
  NOTHREAD
  Oder irgendein spezifischer Threads
  
  Methoden um Zugriff zu erhalten
  beginThreadUsage(CThread*)
  
  endThreadUsage(CThread*)
  
  So kann man auch in CUtiString kontrollieren, dass man den Speicher nicht überschreibt:
  
  prepareForOtherThread()
  
  Erzeugt neue Kopie mit NEXTTHREAD, falls es nicht ein read-only Objekte
  */
  

#include "Uti3DCore.h"
#include "Uti3DMath.h"
#include "UtiString.h"
#include "invalidcontrol.h"
#include "utilinkedlist.h"

typedef long WORKTIME;
/*
class CReferenceObjectAtomic : public CUtiOB
{
   protected:
      int m_references;
      virtual void destroyReferenceObject();
   public:
      inline explicit CReferenceObjectAtomic()
      {
         m_references = 0;
      }
      ~CReferenceObjectAtomic();
#ifdef REFERENCEDEBUGVIRTUAL
      virtual void addRef()
#else
      inline void addRef()
#endif
      {
    CHECKEXISTANCEHIGHSPEED;
    __sync_fetch_and_add(&m_references, 1);
     //     m_references++;
      }
#ifdef REFERENCEDEBUGVIRTUAL
      virtual void decRef()
#else
     inline void decRef()
#endif
      {
    CHECKEXISTANCEHIGHSPEED;

     //  m_references--;
    int res = __sync_add_and_fetch(&m_references, -1);
       utiassert(res >= 0);
       if (res <= 0) destroyReferenceObject();
      }

};*/

class CBaseJob : public ReferenceUtiOB
{
  public:
    CLinkedList_Controller clinkedlist_controller[1];
  protected:
    bool m_finished;
    int m_listcount;
  public:
    CBaseJob();
    ~CBaseJob();
    virtual void addList();
    virtual void removeList();
    virtual CInvalidObject* getInvalidObject();
    virtual WORKTIME getJobWorkTime();
    virtual int getJobCount();
    virtual bool satisfydepends();
    virtual void executeJob(int startjob, int endjob);
    virtual void finaliseMainThread();
    virtual bool isFinished();
    virtual void setFinished();
    virtual int getID();
    virtual bool deleteJob();
    virtual void waitForFinished();
};

#define BEGIN_JOB1(Name, ParamTyp1, ParamName1, ParamDefault1, deleteObject) \
   class CJobCall1_ ## Name : public CBaseJob \
   {\
     public:\
       ParamTyp1 ParamName1;\
     public:\
       CJobCall1_ ## Name() {ParamName1 = ParamDefault1;};\
       CJobCall1_ ## Name(ParamTyp1 p_ ## ParamName1) {ParamName1 = p_ ## ParamName1;};\
       void executeJob(int startjob, int endjob)\
       {\
	 execute();\
       }\
       void set ## ParamName1(ParamTyp1 p_ ## ParamName1) {\
          ParamName1 = p_ ## ParamName1;\
       }\
       ParamTyp1 get ## ParamName1() {\
          return ParamName1;\
       }\
       bool deleteJob() \
       {\
	   return deleteObject;\
       };\
       void execute() {

#define END_JOB1(Name, ParamTyp1, ParamName1, ParamDefault1, deleteObject) \
      };\
    };


#define BEGIN_JOB0(Name, deleteObject) \
   class CJobCall0_ ## Name : public CBaseJob \
   {\
     public:\
     public:\
       CJobCall0_ ## Name() {};\
       void executeJob(int startjob, int endjob)\
       {\
     execute();\
       }\
       bool deleteJob() \
       {\
       return deleteObject;\
       };\
       void execute() {

#define END_JOB0(Name, deleteObject) \
      };\
    };

class CBaseThreadObject : public ReferenceUtiOB
{
  public:
    CBaseThreadObject();
    virtual ~CBaseThreadObject();
    virtual WORKTIME getJobWorkTime();
    virtual TIME executeJob(int amount);
    virtual bool isFinished();
};

class CBaseJobQueue : public ReferenceUtiOB
{
  public:
    CBaseJobQueue();
    virtual ~CBaseJobQueue();
    virtual void addJob(CBaseJob* job);
    virtual int getJobCount()=0;
};



//CNormalLinkedList : public CLinkedList<T, c_index, CLinkedList_NoFree_MemoryController<T> > {};
//template<class T, int c_index> struct COwnLinkedList: public CLinkedList<T, c_index, CLinkedList_Free_MemoryController<T > > {};
//template<class T, int c_index> struct CReferenceLinkedList:

class CSimpleReferenceJobQueue : public CBaseJobQueue
{
  protected:
    CReferenceLinkedList<CBaseJob, 0> m_jobqueue;
  public:
    CSimpleReferenceJobQueue();
    virtual ~CSimpleReferenceJobQueue();
    void addJob(CBaseJob* job);
    int getJobCount() {return m_jobqueue.size();}
    void executeJobs();
    void executeJobs(int totalcount);
    void executeJobsFinished(int totalcount);
};

/*class CThread : public CUtiOB
{
protected:
    LPVOID thread;
    bool init;
    int KillThread(); // Eigentlich nicht noig, da return in Execute dasselbe bewirkt
public:
    void IsReady();
    bool ToTerminate;
    virtual void* Execute();
    void Run();
    void Terminate();
    explicit CThread();
    ~CThread();
    void* WaitFor();


};

class CCriticalSection : public CUtiOB
{*/

class CThreadNormalJobQueue;

class CQueueThread : public CThread
{
  protected:
    CThreadNormalJobQueue* m_queue;
  public:
    explicit CQueueThread(CThreadNormalJobQueue* queue);
    virtual void* Execute();
};

class CThreadNormalJobQueue : public CBaseJobQueue
{
  protected:
    CNormalLinkedList<CBaseJob, 0> m_jobqueue;
    CCriticalSection cs_accessjob;
    CUtiSignal m_signal;
    Array<CQueueThread*> m_threads;
    int m_currentactivejobs;
  public:
    CThreadNormalJobQueue(int count);
    virtual ~CThreadNormalJobQueue();
    void addJob(CBaseJob* job);
    int getJobCount();
    virtual void* Execute();
    virtual void removeDeleteMeObjects();
    void signal();
};

template<class Data, class Job> class CSingleThreadLock : public CUtiOB
{
protected:
    Job* m_lockedby;
    Data* m_data;
    CUtiString m_lockreason;
    CUtiString m_lockdesc;
public:
    inline CSingleThreadLock()
    {
        //assert(CThread::isMainThread());
        m_lockedby = NULL;
        m_data = NULL;

    }
    inline void setLockDescription(const CUtiString& str)
    {
        m_lockdesc = str;
    }
    inline void setLockParent(Data*d)
    {
        m_data = d;
    }

    inline bool isLocked()
    {
        return m_lockedby != NULL;
    }

    inline void lock(Job* job, const CUtiString& reason)
    {
        CHECKEXISTANCE;
        assert(isLocked() == false);
        m_lockedby = job;
        m_lockreason = reason;
        //std::wcout << m_lockdesc << L": Lock(" << reason << L")" << std::endl;
    }
    inline void unlock()
    {
        CHECKEXISTANCE;
        assert(isLocked() == true);
        assert(m_data != NULL);
        //std::wcout << m_lockdesc << L": Unlock(" << m_lockreason << L")" << std::endl;
        m_lockedby = NULL;
        m_lockreason = UTISTR("");

    }

    inline ~CSingleThreadLock()
    {
        //assert(CThread::isMainThread());
        assert(m_lockedby == NULL);
        assert(m_lockreason.size() == 0);
    }

};


class CWriteStreamJob : public CBaseJob
{
public:
  CUtiString m_filename;
  uti_refptr<CMemoryStream> m_memorystream;
  void executeJob(int startjob, int endjob);
  CWriteStreamJob(const CUtiString& f, CMemoryStream* mem);
  
};

class CReadStreamJob : public CBaseJob
{
public:
  CUtiString m_filename;
  uti_refptr<CMemoryStream> m_memorystream;
  void executeJob(int startjob, int endjob);
  CReadStreamJob(const CUtiString& f); //Liest keine Dateien aus Archiven
};


#endif
