/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "UtiTypeHandlers.h"

#include <assert.h>
#include "utimathbox.h"
#include "utiintvector.h"


CUtiOB* createObjectFromNode(CXNode* node, CWriteReadInterface* wri)
{
 /* CUtiOB* obj = XReadClass(node, wri, NULL);
 if (obj) {
 // obj->xread(node, wri);
  SCode code = node->getPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
  static_cast<CReadInfo*>(wri)->addObject(obj, code);
 };
  return obj;*/
  SCode code = node->getPropCode(UTISTR("utireserved_typecode"), NULLCODE);

    if (code == NULLCODE)
    {

         CUtiString classname_to_load = node->getPropString(UTISTR("uclassname"), EMPTYSTRING);
         if (classname_to_load.size() != 0) {

             code= CRTTIManager::getInstance()->classNameToCode(classname_to_load);
         }
    }

    if (code == NULLCODE){
      return NULL;
    }
    CUtiOB* obj = CRTTIManager::getInstance()->createClass(code, NULL);
    if (obj == NULL) {
     std::wcout << "Did not found the class code: " << CodeToString(code) << std::endl;
       return NULL;
    };
  if (obj) {
 // obj->xread(node, wri);
  SCode code = node->getPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
  static_cast<CReadInfo*>(wri)->addObject(obj, code);
 };
    obj->xread(node, (CWriteReadInterface*) wri);
   
    return obj;
}

void uti_readValue_ReferenceToNode(CBaseReferenceAdapter *obj, CXNode* newnode, CWriteReadInterface* wri)
{
  uti_refptr<CBaseReferenceAdapter> sickobj; sickobj = obj;
  SCode code = newnode->getPropCode(UTISTR("utireserved_objectcode"), NULLCODE);

  if (compareCode(code, NULLCODE))
  {

         CUtiString classname_to_load = newnode->getPropString(UTISTR("uclassname"), EMPTYSTRING);
         if (classname_to_load.size() != 0) {

             code= CRTTIManager::getInstance()->classNameToCode(classname_to_load);
         }
  }
   
    if (compareCode(code, NULLCODE))
    {
            obj->set(NULL);
    } else
    if (newnode->getPropBool(UTISTR("utireserved_isreference"), false)) {
      static_cast<CReadInfo*>(wri)->addLink(obj, code);
      return;

    } else {
      CUtiOB* pobj = createObjectFromNode(newnode, wri);
	utiassert(dynamic_cast<ReferenceUtiOB*>(pobj) != NULL);
           obj->set((ReferenceUtiOB*)pobj);

    };
    //delete obj;
}

void uti_readValue(CBaseReferenceAdapter *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, ReferenceUtiOB* init)
{

uti_refptr<CBaseReferenceAdapter> sickobj; sickobj = obj;
   CXNode* newnode = node->getNodeByName(name);
  if (newnode)
  {
    uti_readValue_ReferenceToNode(obj, newnode, wri);
  } else {
    obj->set(NULL); 
  //  delete obj;
  };
 
}

void uti_writeValue_ReferenceToNode(CUtiOB* refobj, CXNode* newnode, CWriteReadInterface* wri)
{
  CWriteInfo* info =  static_cast<CWriteInfo*>(wri);
  if (info->needToBeSaved(refobj)) {
    newnode->setPropBool(UTISTR("utireserved_isreference"), false);
    if (refobj == NULL) {
      newnode->setPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
    } else {
    info->addObject(refobj, refobj->GetCode());
    newnode->setPropCode(UTISTR("utireserved_objectcode"), refobj->GetCode());
    XWriteClass(newnode, wri, refobj);
    };
  } else {
    newnode->setPropBool(UTISTR("utireserved_isreference"), true);
    newnode->setPropCode(UTISTR("utireserved_objectcode"), info->getCode(refobj));
  };
}

void uti_writeValue(CBaseReferenceAdapter *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{

uti_refptr<CBaseReferenceAdapter> sickobj; sickobj = obj;
  //CWriteInfo* info =  static_cast<CWriteInfo*>(wri);
  CXNode* newnode = node->getNodeOrCreate(name);
  ReferenceUtiOB* refobj = obj->get();
  uti_writeValue_ReferenceToNode(refobj, newnode, wri);
  /*if (info->needToBeSaved(refobj)) {
    newnode->setPropBool(UTISTR("utireserved_isreference"), false);
    info->addObject(refobj, refobj->GetCode());
    newnode->setPropCode(UTISTR("utireserved_objectcode"), refobj->GetCode());
    XWriteClass(newnode, wri, refobj);
  } else {
    newnode->setPropBool(UTISTR("utireserved_isreference"), true);
    newnode->setPropCode(UTISTR("utireserved_objectcode"), info->getCode(refobj));
  };*/

 // delete obj;
}

void uti_readValue(CBaseListReferenceAdapter *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  obj->clear();
uti_refptr<CBaseListReferenceAdapter> sickobj; sickobj = obj;
        CXNode* newnode = node->getNodeByName(name);
        if (newnode)
        {
            int c = newnode->getPropInt(UTISTR("utireserved_count"), 0);
            for (int l = 0; l < c; l++)
            {
                CXNode* subnode = newnode->getChild(l);
		 SCode code = subnode->getPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
                if (compareCode(code, NULLCODE))
                {
		  obj->push_back(NULL);
		} else {
		   if (subnode->getPropBool(UTISTR("utireserved_isreference"), false)) {
                     static_cast<CReadInfo*>(wri)->addLink(obj, l, code);
		      obj->push_back(NULL);
                      continue;

                    } else {
		      CUtiOB* pobj = createObjectFromNode(subnode, wri);
		      if (pobj == NULL) {
                  assert(false);
			obj->push_back(NULL);
		      } else {
		      utiassert(dynamic_cast<ReferenceUtiOB*>(pobj) != NULL);
                       obj->push_back(static_cast<ReferenceUtiOB*>(pobj));
		      };
                     };
		};


            };
        };
}

void uti_writeValue(CBaseListReferenceAdapter *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  uti_refptr<CBaseListReferenceAdapter> sickobj; sickobj = obj;
 
  CXNode* newnode = node->getNodeOrCreate(name);
  int c = obj->size();
  newnode->setPropInt(UTISTR("utireserved_count"), c);
  for (int l = 0; l < c; l++)
  {
	 CXNode* subnode = newnode->addNode(UTISTR("child"));
	   CWriteInfo* info =  static_cast<CWriteInfo*>(wri);
          CUtiOB* pobj = obj->get(l);
          if (info->needToBeSaved(pobj)) {
              subnode->setPropBool(UTISTR("utireserved_isreference"), false);
               info->addObject(pobj, pobj->GetCode());
	      subnode->setPropCode(UTISTR("utireserved_objectcode"), pobj->GetCode());
              XWriteClass(subnode, wri, pobj);
           } else {
               subnode->setPropBool(UTISTR("utireserved_isreference"), true);
            subnode->setPropCode(UTISTR("utireserved_objectcode"), info->getCode(pobj));
         };

   };
}


bool uti_readValue(CUtiOB** obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, CUtiOB* init)
{
  CXNode* newnode = node->getNodeByName(name);
  utiassert(*obj == NULL);
 /* if (*obj != NULL) {
    delete *obj;
    *obj = NULL;
  };*/
  if (newnode)
  {
    SCode code = newnode->getPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
    if (compareCode(code, NULLCODE))
    {
            *obj = NULL;
	    return false;
    } else
    if (newnode->getPropBool(UTISTR("utireserved_isreference"), false)) {
      static_cast<CReadInfo*>(wri)->addLink(obj, code);
    } else {
           *obj = createObjectFromNode(newnode, wri);
    };
    return true;
  } else {
    *obj = NULL;
    return false;
  };


}

void uti_writeValue(CUtiOB* *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  CWriteInfo* info =  static_cast<CWriteInfo*>(wri);
  CXNode* newnode = node->getNodeOrCreate(name);

  if (info->needToBeSaved(*obj)) {
    newnode->setPropBool(UTISTR("utireserved_isreference"), false);
    if (*obj == NULL) {
      newnode->setPropCode(UTISTR("utireserved_objectcode"), NULLCODE);
    } else{
    info->addObject(*obj, (*obj)->GetCode());
    XWriteClass(newnode, wri, *obj);
    };
  } else {
    newnode->setPropBool(UTISTR("utireserved_isreference"), true);
    newnode->setPropCode(UTISTR("utireserved_objectcode"), info->getCode(*obj));
  };



}

void uti_readValue(CUtiOB *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  utiassert(false);
  /*CXNode* newnode = node->getNodeByName(name);
  if (newnode) {

  } else {
    newnode = node->addNode(name);
 
  };
  obj->xread(newnode, wri);*/
}

void uti_writeValue(CUtiOB *obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  utiassert(false);
  /*CXNode* newnode = node->addNode(name);
  obj->xwrite(newnode, wri);*/
}

void uti_readValue(CUtiString &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CUtiString& std)
{
  obj = node->getPropString(name, std);
}

void uti_writeValue(CUtiString &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropString(name, obj);
}

void uti_readValue(float &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, float std)
{
 obj = node->getPropFloat(name, std);

}

void uti_writeValue(float &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropFloat(name, obj);
}



void uti_readValue(double &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, double std)
{
 obj = node->getPropDouble(name, std);

}

void uti_writeValue(double &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropDouble(name, obj);
}



void uti_readValue(UTI_UINT64 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, UTI_UINT64 std)
{
   obj = ((UTI_UINT64)node->getPropInt(name+UTISTR("_A"), std)) | (((UTI_UINT64)node->getPropInt(name+UTISTR("_B"), std)) << 32);
}

void uti_writeValue(UTI_UINT64 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name+UTISTR("_A"), obj & 0xFFFFFFFF);
  node->setPropInt(name+UTISTR("_B"), (obj >> 32) & 0xFFFFFFFF);
}

void uti_readValue(int &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, int std)
{
   obj = node->getPropInt(name, std);
}

void uti_writeValue(int &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name, obj);
}

void uti_readValue(SCode &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const SCode& std)
{
  obj = node->getPropCode(name, std);
}

void uti_writeValue(SCode &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropCode(name, obj);
}


void uti_readValue(CVector2 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CVector2& std)
{
  CVector3 n = node->getPropVector(name, CVector3(std.x, std.y, 0));
  obj = CVector2(n.x, n.y);
}

void uti_writeValue(CVector2 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropVector(name, CVector3(obj.x, obj.y, 0));
}

void uti_readValue(CVector3 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CVector3& std)
{
   obj = node->getPropVector(name, std);
}

void uti_writeValue(CVector3 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropVector(name, obj);
}

void uti_readValue(CIVector3 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CIVector3& std)
{
   obj = CIVector3(node->getPropInt(name+UTISTR("_x"), std.x), node->getPropInt(name+UTISTR("_y"), std.y), node->getPropInt(name+UTISTR("_z"), std.z));
}

void uti_writeValue(CIVector3 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name+UTISTR("_x"), obj.x);
  node->setPropInt(name+UTISTR("_y"), obj.y);
  node->setPropInt(name+UTISTR("_z"), obj.z);
}

void uti_readValue(CIVector2 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CIVector2& std)
{
   obj = CIVector2(node->getPropInt(name+UTISTR("_x"), std.x), node->getPropInt(name+UTISTR("_y"), std.y));
}

void uti_writeValue(CIVector2 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name+UTISTR("_x"), obj.x);
  node->setPropInt(name+UTISTR("_y"), obj.y);
}

void uti_readValue(THotKey &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const THotKey& std)
{
   obj = THotKey(node->getPropInt(name+UTISTR("_key"), std.m_first_key), node->getPropInt(name+UTISTR("_alternate_key"), std.m_alternate_key));
}

void uti_writeValue(THotKey &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name+UTISTR("_key"), obj.m_first_key);
  node->setPropInt(name+UTISTR("_alternate_key"), obj.m_alternate_key);
}

void uti_readValue(CIntBox &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CIntBox& std)
{
   obj = CIntBox(node->getPropInt(name+UTISTR("_x1"), std.m_min.x),
                 node->getPropInt(name+UTISTR("_y1"), std.m_min.y),
                 node->getPropInt(name+UTISTR("_z1"), std.m_min.z),
                 node->getPropInt(name+UTISTR("_x2"), std.m_max.x),
                 node->getPropInt(name+UTISTR("_y2"), std.m_max.y),
                 node->getPropInt(name+UTISTR("_z2"), std.m_max.z));
}

void uti_writeValue(CIntBox &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropInt(name+UTISTR("_x1"), obj.m_min.x);
  node->setPropInt(name+UTISTR("_y1"), obj.m_min.y);
  node->setPropInt(name+UTISTR("_z1"), obj.m_min.z);
  node->setPropInt(name+UTISTR("_x2"), obj.m_max.x);
  node->setPropInt(name+UTISTR("_y2"), obj.m_max.y);
  node->setPropInt(name+UTISTR("_z2"), obj.m_max.z);
}

void uti_readValue(CVector4 &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CVector4& std)
{
   obj = node->getPropVector4(name, std);
}

void uti_writeValue(CVector4 &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropVector4(name, obj);
}

void uti_readValue(CBox &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CBox& std)
{
  obj.m_min = node->getPropVector(name+UTISTR("_min"), std.m_min);
  obj.m_max = node->getPropVector(name+UTISTR("_min"), std.m_max);
  
}

void uti_writeValue(CBox &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropVector(name+UTISTR("_min"), obj.m_min);
  node->setPropVector(name+UTISTR("_min"), obj.m_max);
}


void uti_readValue(CMatrix &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CMatrix& std)
{ //Could not change @ to _ because it is used in the Rapid Painter
  obj.setRow(0, node->getPropVector4(name+UTISTR("@row0"), std.getRow(0)));
  obj.setRow(1, node->getPropVector4(name+UTISTR("@row1"), std.getRow(1)));
  obj.setRow(2, node->getPropVector4(name+UTISTR("@row2"), std.getRow(2)));
  obj.setRow(3, node->getPropVector4(name+UTISTR("@row3"), std.getRow(3)));
}

void uti_writeValue(CMatrix &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{//Could not change @ to _ because it is used in the Rapid Painter
  node->setPropVector4(name+UTISTR("@row0"), obj.getRow(0));
  node->setPropVector4(name+UTISTR("@row1"), obj.getRow(1));
  node->setPropVector4(name+UTISTR("@row2"), obj.getRow(2));
  node->setPropVector4(name+UTISTR("@row3"), obj.getRow(3));
}


void uti_readValue(bool &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, bool std)
{
    obj = node->getPropBool(name, std);
}
void uti_writeValue(bool &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropBool(name, obj);
}

void uti_readValue(CRect &obj, CXNode* node, CWriteReadInterface* wri, const CUtiString& name, const CRect& std)
{
  CVector4 res = node->getPropVector4(name, CVector4(std.m_min.x, std.m_min.y, std.m_max.x, std.m_max.y));
  obj = CRect(res.x, res.y, res.z, res.w);
}

void uti_writeValue(CRect &obj,  CXNode* node, CWriteReadInterface* wri, const CUtiString& name)
{
  node->setPropVector4(name, CVector4(obj.m_min.x, obj.m_min.y, obj.m_max.x, obj.m_max.y));
}
