#ifndef CHRSYSTEM_H
#define CHRSYSTEM_H

#include "Uti3DCore.h"

#define DECLARE_BASE_CHR_CLASS(Name) \
class Name : public ReferenceUtiOB \
{\
public:\
    bool m_failed;\
    int m_failedbacktrackindex=-1;\
    Name() {m_failed = false;};\
    virtual int getBacktrackIndex() const =0;\
    virtual void constraintassert(bool b) {if (!b && m_failed == false) {m_failed = true;m_failedbacktrackindex=getBacktrackIndex();}};\
\
};

#define DECLARE_CHR_CLASS(Name, Type, isGround) \
\
class Name : public ReferenceUtiOB\
{\
public:\
    bool m_failed;\
    int m_failedbacktrackindex=-1;\
    Name() {m_failed = false;};\
    virtual int getBacktrackIndex() const =0;\
    virtual void constraintassert(bool b) {if (!b && m_failed == false) {m_failed = true;m_failedbacktrackindex=getBacktrackIndex();}};\
    virtual void makeEqual(const Type& target, const Type& newvalue)=0;\
    virtual bool equalCompareOrSet(const Type& v1, const Type& v2)\
    {\
        if (isGround(v1) && isGround(v2)) {\
            return v1 == v2;\
        } else if (!isGround(v1) && isGround(v2)) {\
            makeEqual(v1, v2);\
            return true;\
        } else if (isGround(v1) && !isGround(v2)) {\
            makeEqual(v2, v1);\
            return true;\
        } else {\
\
            makeEqual(v1, v2);\
            return true;\
\
        }\
    }\
};



#endif // CHRSYSTEM_H

