/***************************************************************************
 *   Copyright (C) 2008 by Staud   *
 *   staud@linux-yr92   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ctextstream.h"
#include "utiarray.h"
#include <stdio.h>
CTextStream_Return uret;

CTextStream::CTextStream()
 : CUtiOB()
{
   
}


CTextStream::~CTextStream()
{
}

void CTextStream::writeData(const U_CHAR* data, int length)
{
   
}
void CTextStream::print(const U_CHAR* data)
{
   writeData(data, utistrlen(data));
};
void CTextStream::print(const CUtiString & str)
{
   writeData(str.c_str(), str.size());
}
void CTextStream::print(int x)
{
    UTI_DECL_ARRAY(U_CHAR, buffer, 40);
    buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#else
   swprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#endif
   print(buffer.getCArray());

}

void CTextStream::print(unsigned int x)
{
    UTI_DECL_ARRAY(U_CHAR, buffer, 40);
    buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(),40, UTEXT("%u"), x);
#else
   swprintf(buffer.getCArray(),40, UTEXT("%u"), x);
#endif
   print(buffer.getCArray());

}

void CTextStream::print(long x)
{
    UTI_DECL_ARRAY(U_CHAR, buffer, 40);
    buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#else
   swprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#endif
   print(buffer.getCArray());

}

void CTextStream::print(unsigned long x)
{
    UTI_DECL_ARRAY(U_CHAR, buffer, 40);
    buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(),40, UTEXT("%lu"), x);
#else
   swprintf(buffer.getCArray(),40, UTEXT("%lu"), x);

#endif
   print(buffer.getCArray());

}
void CTextStream::print(int x, int width)
{
    UTI_DECL_ARRAY(U_CHAR, buffer, 40);
    buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#else
   swprintf(buffer.getCArray(),40, UTEXT("%i"), x);
#endif
   int l = width-utistrlen(buffer.getCArray());
   while (l >0 )
   {
      writeData(UTEXT(" "), 1);
   };
   print(buffer.getCArray());
}

void CTextStream::print(float x)
{
  // U_CHAR buffer[40];
   UTI_DECL_ARRAY(U_CHAR, buffer, 40);
   buffer.fill(0);
#ifdef WIN32
   _snwprintf(buffer.getCArray(), 40,UTEXT("%f"), x);
#else
   swprintf(buffer.getCArray(), 40,UTEXT("%f"), x);
#endif
   print(buffer.getCArray());
}

void CTextStream::print(bool b)
{
   if (b) {
      print(UTEXT("true"));
   } else {
      print(UTEXT("false"));
   };
}

void CTextStream::ret()
{
   U_CHAR ret = 10;
   writeData(&ret, 1);
}

CTextStream& CTextStream::operator<<(const wchar_t* c)
{
   print(c);
   return *this;
}

CTextStream& CTextStream::operator<<(bool b)
{
   print(b);
   return *this;
}
CTextStream& CTextStream::operator<<(short n)
{
   print((int)n);
   return *this;
}
CTextStream& CTextStream::operator<<(unsigned short n)
{
   print((int)n);
   return *this;
}
CTextStream& CTextStream::operator<<(int n)
{
   print((int)n);
   return *this;
}
CTextStream& CTextStream::operator<<(unsigned int n)
{
   print((unsigned int)n);
   return *this;
}
CTextStream& CTextStream::operator<<(long n)
{
   print((long)n);
   return *this;
}
CTextStream& CTextStream::operator<<(unsigned long b)
{
   print((unsigned long)b);
   return *this;
}
CTextStream& CTextStream::operator<<(float b)
{
   print((float)b);
   return *this;
}
CTextStream& CTextStream::operator<<(double b)
{
   print((float)b);
   return *this;
}
CTextStream& CTextStream::operator<<(long double b)
{
   print((float)b);
   return *this;
}

CTextStream& CTextStream::operator<<(const CTextStream_Return& r)
{
   ret();
   return *this;
}
