/***************************************************************************
 *   Copyright (C) 2008 by Staud   *
 *   staud@linux-yr92   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CTEXTSTREAM_H
#define CTEXTSTREAM_H

#include "Uti3DCore.h"
#include "UtiString.h"

struct CTextStream_Return {int x;};

extern CTextStream_Return uret;

/**
	@author Staud <staud@linux-yr92>
*/
class CTextStream : public CUtiOB
{
public:
    CTextStream();

    ~CTextStream();
    virtual void writeData(const U_CHAR* data, int length);
    virtual void print(const U_CHAR* data);
    virtual void print(const CUtiString & str);
    virtual void print(int x);
    virtual void print(unsigned int x);
    virtual void print(long x);
    virtual void print(unsigned long x);
    virtual void print(int x, int width);
    virtual void print(float x);
    virtual void print(bool b);
    virtual void ret();
    virtual CTextStream& operator<<(const wchar_t* c);
    virtual CTextStream& operator<<(bool b);
    virtual CTextStream& operator<<(short n);
    virtual CTextStream& operator<<(unsigned short n);
    virtual CTextStream& operator<<(int n);
    virtual CTextStream& operator<<(unsigned int n);
    virtual CTextStream& operator<<(long n);
    virtual CTextStream& operator<<(unsigned long b);
    virtual CTextStream& operator<<(float b);
    virtual CTextStream& operator<<(double b);
    virtual CTextStream& operator<<(long double b);
    virtual CTextStream& operator<<(const CTextStream_Return& r);
};

#endif
