/***************************************************************************
 *   Copyright (C) 2007 by Staud   *
 *   mstaud@linux-fd2d   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "graph.h"
#include "utimathbox.h"
#include <assert.h>

using namespace std;


Graph::Graph()
{
}


Graph::~Graph()
{
}

DefaultVolumeStructure::DefaultVolumeStructure()
{

}

DefaultVolumeStructure::~DefaultVolumeStructure()
{

}

void DefaultVolumeStructure::addObject(CUtiOB* ob, const CBox& bounds)
{
   utiassert(objects.find(ob) == objects.end());
   objects.insert(make_pair(ob, bounds));
}

void DefaultVolumeStructure::removeObject(CUtiOB* ob)
{
   utiassert(objects.find(ob) != objects.end());
   objects.erase(ob);
}

void DefaultVolumeStructure::getObjectsAtPosition(const CVector& p, CCacheList& list)
{
   map<CUtiOB*, CBox>::iterator it;
   for (it = objects.begin(); it != objects.end(); it++) {
      const CBox& b = it->second;
      if (PointInRect(&b, &p)) {
         list.Add(it->first);
      };
   };
}

void DefaultVolumeStructure::getObjectsInBox(const CBox& bounds, CCacheList& list)
{
   map<CUtiOB*, CBox>::iterator it;
   for (it = objects.begin(); it != objects.end(); it++) {
      const CBox& b = it->second;
      if (IntersectRect3D(&b, &bounds)) {
         list.Add(it->first);
      };
   };
}


