#include "languagesystem.h"
#include "utisystem.h"

MAKE_SINGLETON_IMPL(CLanguageSystem);

CLanguageSystem::CLanguageSystem()
{
  m_usegettext = false;
}

CLanguageSystem::~CLanguageSystem()
{
  
}


void CLanguageSystem::loadGetTextDir(const CUtiString& str)
{
    m_usegettext = true;
#ifdef HAVE_BOOST_LOCALE
    m_generator.add_messages_path(UtiFramework::converttomulti(str));
    //locale::global(m_generator(""))

    m_currentlocale = m_generator("");
#endif
}


void CLanguageSystem::loadDomain(const CUtiString& str)
{
    assert(m_usegettext == true);
#ifdef HAVE_BOOST_LOCALE
    m_generator.add_messages_domain(UtiFramework::converttomulti(str));
#endif
}

void CLanguageSystem::loadFromFile(const CUtiString& str)
{
    m_usegettext = false;
  CUtiString s;
  s.LoadFromFile(str);
  int c = s.getLineCount();
  CUtiString oldstr;
  CUtiString newstr;
  for (int i = 0; i < c; i++) {
    CUtiString line;
    s.getLine(i, line);
    int p = line.Pos(UTISTR("$"));
    if (p != -1) {
      line.Copy(oldstr, 0, p);
      line.Copy(newstr, p+1, line.size()-p);
      insert(oldstr, newstr);
    };
  };
}

void CLanguageSystem::insert(const CUtiString& oldstr, const CUtiString& newstr)
{
  m_oldtonew.insert(std::make_pair(oldstr, newstr));
}


void CLanguageSystem::setLocale(const std::string& l)
{
    m_currentlocale = std::locale(l.c_str());
}

CUtiString CLanguageSystem::translate(const CUtiString& str)
{
    return str;
    if (m_usegettext) {
      //  std::string ms = UtiFramework::converttomulti(str);
        CUtiString s;
        s = str;

#ifdef HAVE_BOOST_LOCALE
        s = boost::locale::gettext(str.c_str(), m_currentlocale).c_str();
#endif
        return s;
    } else {
  std::map<CUtiString, CUtiString>::iterator it = m_oldtonew.find(str);
  if (it == m_oldtonew.end()) {

#ifndef NDEBUG
    std::wcout << L"" << str << L"$" << str << L"" << std::endl;
#endif
    return str;
  };
  return it->second;
    }
    return EMPTYSTRING;
}
