/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __LANGUAGESYSTEM__
#define __LANGUAGESYSTEM__

#include "Uti3DCore.h"
#include "UtiString.h"
#ifdef HAVE_BOOST_LOCALE
#include <boost/locale.hpp>
#endif
#include <map>

class CLanguageSystem: public ReferenceUtiOB
{
protected:
   std::map<CUtiString, CUtiString> m_oldtonew;
   bool m_usegettext;
   std::locale m_currentlocale;
#ifdef HAVE_BOOST_LOCALE
   boost::locale::generator m_generator;
#endif
   MAKE_SINGLETON(CLanguageSystem);
public:
  
    explicit CLanguageSystem();
    virtual ~CLanguageSystem();
    void loadFromFile(const CUtiString& str);
    void loadGetTextDir(const CUtiString& str);
    void loadDomain(const CUtiString& str);
    void setLocale(const std::string &l);
    void insert(const CUtiString& oldstr, const CUtiString& newstr);
    CUtiString translate(const CUtiString& str);
};
#define UTITRANSLATE(a) (CLanguageSystem::getInstance()->translate( UTISTR(a)))



#endif
