/***************************************************************************
 *   Copyright (C) 2007 by Staud   *
 *   mstaud@linux-fd2d   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "objectfactory.h"

#include "UtiString.h"
#include <assert.h>

CObjectFactory::CObjectFactory()
{
}


CObjectFactory::~CObjectFactory()
{
   std::map<CUtiString, CClassCreator*>::iterator it;
   for (it = classes.begin(); it != classes.end(); it++) {
      delete it->second;
   };
}

void CObjectFactory::registerClass(const CUtiString&str, CClassCreator* creator)
{
   uassert( classes.find(str) == classes.end(), L"Try to register two classes with the same name");
   classes.insert(std::make_pair(str, creator));
}
CUtiOB* CObjectFactory::createObject(const CUtiString& str)
{
   std::map<CUtiString, CClassCreator*>::iterator it = classes.find(str);
   uassert(it != classes.end(), L"Try to create unknown object in factory");
   if (it == classes.end()) return NULL;
   return it->second->createObject();
}

CClassCreator::CClassCreator()
{

}

CUtiOB* CClassCreator::createObject()
{
   utiassert(false);
   return NULL;
}

