/***************************************************************************
 *   Copyright (C) 2007 by Staud   *
 *   mstaud@linux-fd2d   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OBJECTFACTORY_H
#define OBJECTFACTORY_H

#include "Uti3DCore.h"
#include "UtiString.h"
#include <map>

class CClassCreator : public CUtiOB
{
   public:
      CClassCreator();
      virtual CUtiOB* createObject();
};

template <class T> class CDefaultCreator : public CClassCreator
{
   public:
      CDefaultCreator()
      {

      };
      CUtiOB* createObject()
      {
         return new T();
      };
};

template <class RegisterClass, class NewClass> class CRegisterClassSystem
{
   public:

      CRegisterClassSystem(const CUtiString& name)
      {

         RegisterClass::getInstance()->registerClass(name, new CDefaultCreator<NewClass>());
      };
	  void doRegister()
	  {

	  }
};

/**
	@author Staud <mstaud@linux-fd2d>
*/
class CObjectFactory : public CUtiOB
{
protected:
   std::map<CUtiString, CClassCreator*> classes;
public:
    CObjectFactory();

    ~CObjectFactory();
    void registerClass(const CUtiString&str, CClassCreator* creator);
    CUtiOB* createObject(const CUtiString& str);

};

#endif
