/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __UNDOSYSTEMNOTIFY__
#define __UNDOSYSTEMNOTIFY__

#include "undosystem.h"
#ifdef USE_SIGCPP
#include <sigc++/sigc++.h>
#endif

/*
class CUndoListener : public ReferenceUtiOB
{
  public:
    CUndoListener(); 
    virtual void undo_delete(void* watchedvalue, ReferenceUtiOB* changedata)=0;
};

class CUndoChangeListener : public CUndoListener
{
public:
   CUndoChangeListener();
   virtual void undo_prechange(void* watchedvalue, ReferenceUtiOB* changedata)=0;
   virtual void undo_postchange(void* watchedvalue, ReferenceUtiOB* changedata)=0;
  
};

*/


class CUndoChangeEvents : public CUndoChangeListener
{
  public:
#ifdef USE_SIGCPP
    sigc::signal<void, CUtiOB*> ms_delete;
    sigc::signal<void, CUtiOB*> ms_prechange;
    sigc::signal<void, CUtiOB*> ms_postchange;
#endif
  public:
    CUndoChangeEvents();
    virtual void undo_delete(void* watchedvalue, ReferenceUtiOB* changedata);
    virtual void undo_prechange(void* watchedvalue, ReferenceUtiOB* changedata);
   virtual void undo_postchange(void* watchedvalue, ReferenceUtiOB* changedata);
};


class CEventRegisterUnregister : public ReferenceUtiOB
{
  protected:
    template<class T> class CUnRegister : public ReferenceUtiOB
    {
      public:
	T& m_class;
	uti_refptr<CUndoChangeListener> m_listener;
      public:
	CUnRegister(T& change, CUndoChangeListener* listener): m_class(change){
	  m_listener = listener;
	};
	~CUnRegister() {
	  m_class.removeChangeListener(m_listener.get(), NULL);
	};
    };
    CReferenceList<ReferenceUtiOB> m_list;
  public:
    CEventRegisterUnregister()
    {
      
    };
    void clear()
    {
      m_list.clear();
    };
    template<class T> void registerChange(T& change, CUndoChangeListener* listener, ReferenceUtiOB* obj)
    {
      change.addChangeListener(listener,obj);
      m_list.push_back(new CUnRegister<T>(change, listener));
    };
};

#define UTI_DECL_EVENTREGISTER CEventRegisterUnregister m_intern_event_register;


#ifdef USE_SIGCPP
#define UTI_REGISTEREVENT_VALUE_POST(value, method) {\
   CUndoChangeEvents* ude= new CUndoChangeEvents();\
   ude->ms_postchange.connect(sigc::mem_fun(*this, &method));\
   m_intern_event_register.registerChange(value, ude, NULL);\
};

#define UTI_REGISTEREVENT_VALUE_POSTDELETE(value, method, method2) {\
   CUndoChangeEvents* ude= new CUndoChangeEvents();\
   ude->ms_postchange.connect(sigc::mem_fun(*this, &method));\
    ude->ms_delete.connect(sigc::mem_fun(*this, &method2));\
   m_intern_event_register.registerChange(value, ude, NULL);\
};

#else
#define UTI_REGISTEREVENT_VALUE_POST(value, method)
#define UTI_REGISTEREVENT_VALUE_POSTDELETE(value, method, method2)

#endif

#endif
