#ifndef __UTI_UNITTEST__
#define __UTI_UNITTEST__

#include "Uti3DCore.h"
#include "Uti3DMath.h"
#include "UtiString.h"
#include <iostream>

class CUtiUnitTestBase : public CUtiOB
{
public:
    CUtiUnitTestBase();
    ~CUtiUnitTestBase();
    virtual CUtiString getName()=0;
    virtual void execute()=0;
};
/*
class CUtiUnitTestController : public CUtiOB
{
protected:
    std::vector<CUtiOB*> m_unittests;
public:
    CUtiUnitTestController()
    {

    }
    void addTest(CUtiOB* test)
    {
        m_unittests.push_back(test);
    }
};*/

template<class T> class CUtiUnitTestCaller : public CUtiOB
{
public:
    CUtiUnitTestCaller()
    {
        T* test = new T();
        test->execute();
        delete test;
    }
    void call()
    {
        std::wcout << "Called" << std::endl;
    }
};

#define UTI_BEGINSIMPLETEST(Name) \
    class CUtiUnitTest_ ## Name : public CUtiUnitTestBase \
    {\
        protected:\
        public:\
          CUtiString getName()\
          {\
              return UTISTR(#Name);\
          }\
\
          CUtiUnitTest_ ## Name()\
          {\
            \
          }\
          void execute() {






#define UTI_ENDSIMPLETEST(Name)  \
              };\
              };\
    CUtiUnitTestCaller<CUtiUnitTest_ ## Name> uti_unittest_caller_ ## Name;

#define UTI_BEGINTEST(Name) \
    class CUtiUnitTest_ ## Name : public CUtiUnitTestBase\
    {\
        protected:\
        public:\
          CUtiString getName()\
          {\
              return UTISTR(#Name);\
          }\
\
          CUtiUnitTest_ ## Name()\
          {\
            \
          }






#define UTI_ENDTEST(Name)  \
              };\
    CUtiUnitTestCaller<CUtiUnitTest_ ## Name> uti_unittest_caller_ ## Name;

#define UTIASSERT(Condition) utiassert(Condition)
#define UTIASSERT2(Condition, Name) utiassert(Condition)
#define UTIASSERTEQUALFLOAT(a,b,delta) utiassert(absf((a)-(b)) < delta)

#endif
