#ifndef CUTI64CODER_H
#define CUTI64CODER_H
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "UtiType.h"

const int BASE64_SIZELENGTH=8;

class CUti64Code : public CUtiException
{
protected:
   int m_position;
public:
  CUti64Code(int pos) {m_position = pos; m_n = UTEXT("Invalid Base64 Code detected");};

};

class CUti64CodeSize : public CUtiException
{
protected:

public:
  CUti64CodeSize() {m_n = UTEXT("Invalid Base64 data size detected");};

};

class CUti64Coder
{
    public:
        /** Default constructor */
        CUti64Coder();
        /** Default destructor */
        virtual ~CUti64Coder();
        static int getDataLength(int datasize);
        static int reconstructDataLength(int sourcesize);

        static int writeData(const void* data, int datasize, char* targetdata, int targetsize);
        static void readData(const char* sourcedata, int sourcesize, void* targetdata, int targetdatasize);
    protected:

};

#endif // CUTI64CODER_H
