#ifndef UTIDATAMANAGER_H
#define UTIDATAMANAGER_H
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Uti3DCore.h"
#include "utilinkedlist.h"

template <class T, class MemManager> class CDataManager: public ReferenceUtiOB
   {
   protected:
     int m_maxobject;
     int m_wishcount;
     int m_lastthinkwork;
     int m_maxwork;
     size_t m_maxmemory;
     MemManager m_manager;
     CNormalLinkedList<T, 0> m_allocatedelements;
   public:
     CDataManager(int mc, int wish, size_t maxmemory)
     {
        m_maxobject= mc;
    m_wishcount = wish;
    m_lastthinkwork = 0;
    m_maxwork = 1;
    m_maxmemory = maxmemory;
     }
     void addObject(T* compressed)
     {
       CHECKEXISTANCE;
      if (m_allocatedelements.size() >= m_maxobject) {
         typename CNormalLinkedList<T, 0>::iterator it1, it2;
         int size = m_allocatedelements.size()/2;
         it1 = m_allocatedelements.begin();
         while (it1 != m_allocatedelements.end() && m_allocatedelements.size() >= m_maxobject) {
            it2 = it1;
            it2++;

            if (it1->dd_canBeRemoved()) {
           it1->dd_remove();
           m_lastthinkwork++;
            };
          it1 = it2;
          size--;
          if (size <= 0) break;
         };

      }
//  utiassert(m_uncompressedelements.size() < m_maxuncompressednodes);
       m_lastthinkwork++;
        m_allocatedelements.push_back(compressed);
     }
     void useObject(T* compressed)
     {
         if (&m_allocatedelements.back() == compressed)return;
        m_allocatedelements.remove(compressed);
        m_allocatedelements.push_back(compressed);
     }
     void removeObject(T* com)
     {
       m_lastthinkwork++;
       m_allocatedelements.remove(com);
     }
     void think()
     {

       while (m_lastthinkwork < m_maxwork && (m_allocatedelements.size() > m_wishcount || m_manager.getMemoryCount() > m_maxmemory)) {
     T* f = &m_allocatedelements.front();
     if (f->dd_canBeRemoved()) {
       m_lastthinkwork++;
       f->dd_remove();
     } else {
       break;
     };
       };
       m_lastthinkwork  = 0;
     }
   };
#endif // UTIDATAMANAGER_H
