#ifndef __UTIDEFERREDCALLS__
#define __UTIDEFERREDCALLS__
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Uti3DCore.h"
#include "invalidcontrol.h"

// DEFCALL(mode, type, name, init)

class CBaseDeferredCommand : public ReferenceUtiOB
{
public:
  CBaseDeferredCommand(){};
  ~CBaseDeferredCommand(){};
  virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)=0;
};

#define DEFCALL0_normal_normal(classname, name) virtual void name();
#define DEFCALL1_normal_normal(classname, name, p1type, p1name) virtual void name(const p1type &p1name);
#define DEFCALL2_normal_normal(classname, name, p1type, p1name, p2type, p2name) virtual void name(const p1type &p1name, const p2type &p2name);
#define DEFCALL3_normal_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) virtual void name(const p1type &p1name, const p2type &p2name, const p3type &p3name);
#define DEFCALL4_normal_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) virtual void name(const p1type& p1name, const p2type& p2name, const p3type& p3name, const p4type &p4name);

#define DEFCALL0_normal_deferred(classname, name) virtual void name();
#define DEFCALL1_normal_deferred(classname, name, p1type, p1name) virtual void name(const p1type &p1name);
#define DEFCALL2_normal_deferred(classname, name, p1type, p1name, p2type, p2name) virtual void name(const p1type &p1name, const p2type &p2name);
#define DEFCALL3_normal_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) virtual void name(const p1type &p1name, p2type &p2name, p3type &p3name);
#define DEFCALL4_normal_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) virtual void name(const p1type &p1name, const p2type &p2name, const type &p3name, const p4type &p4name);


#define DEFCALL0_deferred_normal(classname, name)
#define DEFCALL1_deferred_normal(classname, name, p1type, p1name)
#define DEFCALL2_deferred_normal(classname, name, p1type, p1name, p2type, p2name)
#define DEFCALL3_deferred_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name)
#define DEFCALL4_deferred_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)

#define DEFCALL0_deferredimpl_normal(classname, name)
#define DEFCALL1_deferredimpl_normal(classname, name, p1type, p1name)
#define DEFCALL2_deferredimpl_normal(classname, name, p1type, p1name, p2type, p2name)
#define DEFCALL3_deferredimpl_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name)
#define DEFCALL4_deferredimpl_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)

#define DEFCALL0_deferred_deferred(classname, name) virtual void name();
#define DEFCALL1_deferred_deferred(classname, name, p1type, p1name) virtual void name(const p1type &p1name);
#define DEFCALL2_deferred_deferred(classname, name, p1type, p1name, p2type, p2name) virtual void name(const p1type &p1name, const p2type &p2name);
#define DEFCALL3_deferred_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) virtual void name(const p1type &p1name, const p2type &p2name, const p3type &p3name);
#define DEFCALL4_deferred_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) virtual void name(const p1type &p1name, const p2type &p2name, const p3type &p3name, const p4type &p4name);

#define DEFCALL0_command_normal(classname, name)
#define DEFCALL1_command_normal(classname, name, p1type, p1name)
#define DEFCALL2_command_normal(classname, name, p1type, p1name, p2type, p2name)
#define DEFCALL3_command_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name)
#define DEFCALL4_command_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)

#define DEFCOPY(target, source) target = source;

#define DEFCALL0_deferredimpl_deferred(classname, name) void classname ## _deferred::name()\
{\
      CDeferred_ ## classname ## _ ## name* command = new CDeferred_ ## classname ## _ ## name();\
      m_commands.push_back(command);\
};

#define DEFCALL1_deferredimpl_deferred(classname, name, p1type, p1name) void  classname ## _deferred::name(const p1type & p1name)\
{\
      CDeferred_ ## classname ## _ ## name* command = new CDeferred_ ## classname ## _ ## name();\
      DEFCOPY(command->p1name, p1name);\
      m_commands.push_back(command);\
};
#define DEFCALL2_deferredimpl_deferred(classname, name, p1type, p1name, p2type, p2name) void classname ## _deferred::name(const p1type &p1name, const p2type &p2name)\
{\
      CDeferred_ ## classname ## _ ## name* command = new CDeferred_ ## classname ## _ ## name();\
      DEFCOPY(command->p1name, p1name);\
      DEFCOPY(command->p2name, p2name);\
      m_commands.push_back(command);\
};
#define DEFCALL3_deferredimpl_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) void classname ## _deferred::name(const p1type &p1name, const p2type &p2name, const p3type &p3name)\
{\
      CDeferred_ ## classname ## _ ## name* command = new CDeferred_ ## classname ## _ ## name();\
      DEFCOPY(command->p1name, p1name);\
      DEFCOPY(command->p2name, p2name);\
      DEFCOPY(command->p3name, p3name);\
      m_commands.push_back(command);\
};
#define DEFCALL4_deferredimpl_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) void classname ## _deferred::name(const p1type& p1name, const p2type& p2name, const p3type& p3name, const p4type& p4name)\
{\
      CDeferred_ ## classname ## _ ## name* command = new CDeferred_ ## classname ## _ ## name();\
      DEFCOPY(command->p1name, p1name);\
      DEFCOPY(command->p2name, p2name);\
      DEFCOPY(command->p3name, p3name);\
      DEFCOPY(command->p4name, p4name);\
      m_commands.push_back(command);\
};


#define DEFCALL0_command_deferred(classname, name) class CDeferred_ ## classname ## _ ## name : public CBaseDeferredCommand {\
public:\
   virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)\
   {\
      classname* cl = (classname*)obj;\
      cl->name();\
   }\
};

#define DEFCALL1_command_deferred(classname, name, p1type, p1name) class CDeferred_ ## classname ## _ ## name : public CBaseDeferredCommand {\
public:\
   p1type p1name;\
   virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)\
   {\
      classname* cl = (classname*)obj;\
      cl->name(p1name);\
   }\
};

#define DEFCALL2_command_deferred(classname, name, p1type, p1name, p2type, p2name) class CDeferred_ ## classname ## _ ## name : public CBaseDeferredCommand {\
public:\
   p1type p1name;\
   p2type p2name;\
   virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)\
   {\
      classname* cl = (classname*)obj;\
      cl->name(p1name, p2name);\
   }\
};

#define DEFCALL3_command_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) class CDeferred_ ## classname ## _ ## name : public CBaseDeferredCommand {\
public:\
   p1type p1name;\
   p2type p2name;\
   p3type p3name;\
   virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)\
   {\
      classname* cl = (classname*)obj;\
      cl->name(p1name, p2name, p3name);\
   }\
};

#define DEFCALL4_command_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) class CDeferred_ ## classname ## _ ## name : public CBaseDeferredCommand {\
public:\
   p1type p1name;\
   p2type p2name;\
   p3type p3name;\
   p4type p4name;\
   virtual void execute(ReferenceUtiOB* obj, CInvalidObject* invalid)\
   {\
      classname* cl = (classname*)obj;\
      cl->name(p1name, p2name, p3name, p4name);\
   }\
};


#define DEFCALL0(mode, type, classname, name)\
    DEFCALL0_ ## mode ## _ ## type (classname, name)

#define DEFCALL1(mode,type,  classname, name, p1type, p1name)\
    DEFCALL1_ ## mode ## _ ## type (classname, name, p1type, p1name)

#define DEFCALL2(mode, type, classname, name, p1type, p1name, p2type, p2name)\
    DEFCALL2_ ## mode ## _ ## type (classname, name, p1type, p1name, p2type, p2name)

#define DEFCALL3(mode, type, classname, name, p1type, p1name, p2type, p2name, p3type, p3name)\
    DEFCALL3_ ## mode ## _ ## type (classname, name, p1type, p1name, p2type, p2name, p3type, p3name)

#define DEFCALL4(mode, type, classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)\
    DEFCALL4_ ## mode ## _ ## type (classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)

#define DECL_DEFERRED_CLASS(call, name, base, normaldata, deferreddata)\
   class name : public base\
   {\
   public:\
     normaldata m_normaldata;\
     name();\
     ~name();\
     call(normal, name)\
   };\
   \
   class name ## _deferred : public name\
   {\
   protected:\
     CReferenceList<CBaseDeferredCommand> m_commands;\
   public:\
     deferreddata m_deferreddata;\
     name ## _deferred();\
     ~name ## _deferred();\
     call(deferred, name);\
     virtual void execute(name* obj, CInvalidObject* invalid);\
   };\
   call(command, name);
   
#define IMPL_DEFERRED_CLASS(call, name, base)\
     call(deferredimpl, name);\
     void name ## _deferred::execute(name* obj, CInvalidObject* invalid)\
     {\
        for (int i = 0; i < m_commands.size(); i++) {\
	  m_commands[i].execute(obj, invalid);\
	}\
     }\
     

#define SAMPLECANVAS(mode, classname)\
     DEFCALL0(mode, deferred, classname, hello)\
     DEFCALL2(mode, deferred, classname, drawLine, CVector2, start, CVector2, ende)

//DECL_DEFERRED_CLASS(SAMPLECANVAS, CSampleClass, ReferenceUtiOB)

//IMPL_DEFERRED_CLASS(SAMPLECANVAS, CSampleClass, ReferenceUtiOB)

//Python
#define DEFTRANS(type)

#define DEFCALL0_normalpython_normal(classname, name) virtual void name();
#define DEFCALL1_normalpython_normal(classname, name, p1type, p1name) virtual void name(const DEFTRANS(p1type) &p1name);
#define DEFCALL2_normalpython_normal(classname, name, p1type, p1name, p2type, p2name) virtual void name(const DEFTRANS(p1type) &p1name, const DEFTRANS(p2type) &p2name);
#define DEFCALL3_normalpython_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) virtual void name(const DEFTRANS(p1type) &p1name, const DEFTRANS(p2type) &p2name, const DEFTRANS(p3type) &p3name);
#define DEFCALL4_normalpython_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) virtual void name(const DEFTRANS(p1type)& p1name, const DEFTRANS(p2type)& p2name, const DEFTRANS(p3type)& p3name, const DEFTRANS(p4type) &p4name);

#define DEFCALL0_normalpython_deferred(classname, name) DEFCALL0_normalpython_normal(classname, name)
#define DEFCALL1_normalpython_deferred(classname, name, p1type, p1name) DEFCALL0_normalpython_normal(classname, name, p1type, p1name)
#define DEFCALL2_normalpython_deferred(classname, name, p1type, p1name, p2type, p2name) DEFCALL0_normalpython_normal(classname, name, p1type, p1name, p2type, p2name)
#define DEFCALL3_normalpython_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name) DEFCALL0_normalpython_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3nam)
#define DEFCALL4_normalpython_deferred(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name) DEFCALL0_normalpython_normal(classname, name, p1type, p1name, p2type, p2name, p3type, p3name, p4type, p4name)


#define PYTHONDECL_DEFERRED_CLASS(call, name, base)\
     class name ## _Python : public ReferenceUtiOB\
   {\
   protected:\
     name* m_object;\
   public:\
     name ## _Python(name* object);\
     ~name ## _Python();\
     call(normalpython, name)\
   };

#endif
