#ifndef UTIINTERSECTIONS_H
#define UTIINTERSECTIONS_H
/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Uti3DMath.h"
#include "utiarray.h"

bool intersectPolygon(const Array<CVector2> &points, const CVector2 &point);
void clipPolygonNormal(const Array<CVector2> & inpoly, Array<CVector2> & outpoly, bool closed, const CVector2& normal, float d);
void clipPolygonLineSegment(const Array<CVector2> & inpoly, Array<CVector2> & outpoly, bool closed, const CVector2& p1, const CVector2& p2);
void clipPolygonConvexPolygon(const Array<CVector2> & inpoly, Array<CVector2> & outpoly, bool closed, const Array<CVector2>& convexmesh);
void clipPolygonRect(const Array<CVector2> & inpoly, Array<CVector2> & outpoly, bool closed, const CRect& rect);
bool intersectPolygonRect(const Array<CVector2> & inpoly, bool closed, const CRect& rect);
CVector2 rotateVector(const CVector2& p, float degree);
bool intersectLineRect(const CVector2& start, const CVector2& dir, const CRect& rect, float* pos);
bool intersectPolylineRect(const Array<CVector2> & inpoly, bool closed, const CRect& rect);

bool IntersectLinePlane(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneX(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneY(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneZ(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneNX(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneNY(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
bool IntersectLinePlaneNZ(S3DPoint *polypoint, CVector *v, S3DPoint *line, S3DPoint *result, float *dis);
#endif // UTIINTERSECTIONS_H
