/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DONOTDECLARE
#ifndef __UTIKEYCODES__
#define __UTIKEYCODES__

int UTI_KEY_stringToKey(const wchar_t* str);
const wchar_t* UTI_KEY_keyToString(int i);
void UTI_KEY_registerKey(const wchar_t* name, int keycode);


class RegisterKeyCode 
{
public:

   RegisterKeyCode(const wchar_t* name, int keycode)
   {
       UTI_KEY_registerKey(name, keycode);
   }; 
};

#define UTIKEYMAP(a, b) const int UTI_ ## a = b;
#endif

#ifdef UTIKEYMAP
UTIKEYMAP(Mouse1,0x0001)
UTIKEYMAP(Mouse2,0x0002)
UTIKEYMAP(Mouse3,0x0003)
UTIKEYMAP(Mouse3Up,0x0004)
UTIKEYMAP(Mouse3Down,0x0005)
UTIKEYMAP(Exclaim, 0x6000);
UTIKEYMAP(QuoteDbl, 0x6001);
UTIKEYMAP(Hash, 0x6002);
UTIKEYMAP(Dollar, 0x6003);
UTIKEYMAP(Ampersand, 0x6004);
UTIKEYMAP(Quote, 0x6005);
UTIKEYMAP(Leftparen, 0x6006);
UTIKEYMAP(Rightparen, 0x6007);
UTIKEYMAP(Asterisk, 0x6008);
UTIKEYMAP(Period, 0x6009);
UTIKEYMAP(Slash, 0x600A);
UTIKEYMAP(Less, 0x600B);
UTIKEYMAP(Greater, 0x600C);
UTIKEYMAP(Caret,0x600D)

      
UTIKEYMAP(BackSpace,0xFF08)
UTIKEYMAP(Tab,0xFF09)
UTIKEYMAP(Linefeed,0xFF0A)
UTIKEYMAP(Clear,0xFF0B)

UTIKEYMAP(Pause,0xFF13)
UTIKEYMAP(Scroll_Lock,0xFF14)
UTIKEYMAP(Escape,0xFF1B)
UTIKEYMAP(Delete,0xFFFF)

UTIKEYMAP(Space,0xFF80)
UTIKEYMAP(Return,0x1000)

//UTIKEYMAP(End,0x1001) Defined below
UTIKEYMAP(Home,0xFF95)
UTIKEYMAP(Left,0xFF96)
UTIKEYMAP(Up,0xFF97)
UTIKEYMAP(Right,0xFF98)
UTIKEYMAP(Down,0xFF99)
UTIKEYMAP(Prior,0xFF9A)
UTIKEYMAP(Page_Up,0xFF9A)
UTIKEYMAP(Next,0xFF9B)
UTIKEYMAP(Page_Down,0xFF9B)
UTIKEYMAP(End,0xFF9C)
//UTIKEYMAP(KP_Begin,0xFF9D)
UTIKEYMAP(Insert,0xFF9E)
UTIKEYMAP(Equal,0xFFBD)
UTIKEYMAP(Multiply,0xFFAA)
UTIKEYMAP(Plus,0xFFAB)
UTIKEYMAP(Separator,0xFFAC)
UTIKEYMAP(Minus,0xFFAD)
UTIKEYMAP(Decimal,0xFFAE)
UTIKEYMAP(Divide,0xFFAF)
      
UTIKEYMAP(Comma, 0x1002)

/*UTIKEYMAP(0,0xFFB0)
UTIKEYMAP(1,0xFFB1)
UTIKEYMAP(2,0xFFB2)
UTIKEYMAP(3,0xFFB3)
UTIKEYMAP(4,0xFFB4)
UTIKEYMAP(5,0xFFB5)
UTIKEYMAP(6,0xFFB6)
UTIKEYMAP(7,0xFFB7)
UTIKEYMAP(8,0xFFB8)
UTIKEYMAP(9,0xFFB9)*/

UTIKEYMAP(F1,0xFFBE)
UTIKEYMAP(F2,0xFFBF)
UTIKEYMAP(F3,0xFFC0)
UTIKEYMAP(F4,0xFFC1)
UTIKEYMAP(F5,0xFFC2)
UTIKEYMAP(F6,0xFFC3)
UTIKEYMAP(F7,0xFFC4)
UTIKEYMAP(F8,0xFFC5)
UTIKEYMAP(F9,0xFFC6)
UTIKEYMAP(F10,0xFFC7)
UTIKEYMAP(F11,0xFFC8)
UTIKEYMAP(F12,0xFFC9)


UTIKEYMAP(A,0x041)
UTIKEYMAP(B,0x042)
UTIKEYMAP(C,0x043)
UTIKEYMAP(D,0x044)
UTIKEYMAP(E,0x045)
UTIKEYMAP(F,0x046)
UTIKEYMAP(G,0x047)
UTIKEYMAP(H,0x048)
UTIKEYMAP(I,0x049)
UTIKEYMAP(J,0x04a)
UTIKEYMAP(K,0x04b)
UTIKEYMAP(L,0x04c)
UTIKEYMAP(M,0x04d)
UTIKEYMAP(N,0x04e)
UTIKEYMAP(O,0x04f)
UTIKEYMAP(P,0x050)
UTIKEYMAP(Q,0x051)
UTIKEYMAP(R,0x052)
UTIKEYMAP(S,0x053)
UTIKEYMAP(T,0x054)
UTIKEYMAP(U,0x055)
UTIKEYMAP(V,0x056)
UTIKEYMAP(W,0x057)
UTIKEYMAP(X,0x058)
UTIKEYMAP(Y,0x059)
UTIKEYMAP(Z,0x05a)
UTIKEYMAP(bracketleft,0x05b)
UTIKEYMAP(backslash,0x05c)
UTIKEYMAP(bracketright,0x05d)
//UTIKEYMAP(asciicircum,0x05e)
UTIKEYMAP(underscore,0x05f)
//UTIKEYMAP(grave,0x060)
/*UTIKEYMAP(a,0x061)
UTIKEYMAP(c, 0x063)
UTIKEYMAP(d,0x064)
UTIKEYMAP(e,0x065)
UTIKEYMAP(f,0x066)
UTIKEYMAP(g,0x067)
UTIKEYMAP(h,0x068)
UTIKEYMAP(i,0x069)
UTIKEYMAP(j,0x06a)
UTIKEYMAP(k,0x06b)
UTIKEYMAP(l,0x06c)
UTIKEYMAP(m,0x06d)
UTIKEYMAP(n,0x06e)
UTIKEYMAP(o,0x06f)
UTIKEYMAP(p,0x070)
UTIKEYMAP(q,0x071)
UTIKEYMAP(r,0x072)
UTIKEYMAP(s,0x073)
UTIKEYMAP(t,0x074)
UTIKEYMAP(u,0x075)
UTIKEYMAP(v,0x076)
UTIKEYMAP(w,0x077)
UTIKEYMAP(x,0x078)
UTIKEYMAP(y,0x079)
UTIKEYMAP(z,0x07aE)
*/

const int UTI_GAMECONTROLLER_UP = 3001;
const int UTI_GAMECONTROLLER_DOWN = 3002;
const int UTI_GAMECONTROLLER_LEFT = 3003;
const int UTI_GAMECONTROLLER_RIGHT = 3004;
const int UTI_GAMECONTROLLER_START = 3005;
const int UTI_GAMECONTROLLER_BACK = 3006;
const int UTI_GAMECONTROLLER_LEFTSHOULDER = 3007;
const int UTI_GAMECONTROLLER_RIGHTSHOULDER = 3008;
const int UTI_GAMECONTROLLER_ABUTTON = 3009;
const int UTI_GAMECONTROLLER_BBUTTON = 3010;
const int UTI_GAMECONTROLLER_XBUTTON = 3011;
const int UTI_GAMECONTROLLER_YBUTTON = 3012;
const int UTI_GAMECONTROLLER_LEFTSTICK = 3016;
const int UTI_GAMECONTROLLER_RIGHTSTICK = 3017;
const int UTI_GAMECONTROLLER_MODE = 3018;


const int UTI_GAMECONTROLLER_LEFTAXISUP_VIRTUALBUTTON = 3019;
const int UTI_GAMECONTROLLER_LEFTAXISDOWN_VIRTUALBUTTON = 3020;
const int UTI_GAMECONTROLLER_LEFTAXISLEFT_VIRTUALBUTTON = 3021;
const int UTI_GAMECONTROLLER_LEFTAXISRIGHT_VIRTUALBUTTON = 3022;



const int UTI_GAMECONTROLLER_RIGHTAXISUP_VIRTUALBUTTON = 3023;
const int UTI_GAMECONTROLLER_RIGHTAXISDOWN_VIRTUALBUTTON = 3024;
const int UTI_GAMECONTROLLER_RIGHTAXISLEFT_VIRTUALBUTTON = 3025;
const int UTI_GAMECONTROLLER_RIGHTAXISRIGHT_VIRTUALBUTTON = 3026;


const int UTI_GAMECONTROLLER_AXISLEFT = 3013;
const int UTI_GAMECONTROLLER_AXISRIGHT = 3014;
const int UTI_GAMECONTROLLER_TRIGGER = 3015;

UTIKEYMAP(Shift_L,0xFFE1)
UTIKEYMAP(Shift_R,0xFFE2)
UTIKEYMAP(Control_L,0xFFE3)
UTIKEYMAP(Control_R,0xFFE4)
UTIKEYMAP(Caps_Lock,0xFFE5)
UTIKEYMAP(Shift_Lock,0xFFE6)

UTIKEYMAP(Alt_L,0xFFE9)
UTIKEYMAP(Alt_R,0xFFEA)

UTIKEYMAP(Super_L, 0x4000);
UTIKEYMAP(Super_R, 0x4001)
UTIKEYMAP(Mode, 0x4002)
UTIKEYMAP(Compose, 0x4003)
      UTIKEYMAP(Meta_L, 0x4004)
      UTIKEYMAP(Meta_R, 0x4005)
      UTIKEYMAP(Num_Lock,0x4006)
      
      UTIKEYMAP(Help, 0x4007)
      UTIKEYMAP(Print, 0x4008)
      UTIKEYMAP(Sysreq, 0x4009)
      UTIKEYMAP(Break, 0x400A)
      UTIKEYMAP(Menu, 0x400B)
      UTIKEYMAP(Power, 0x400C)
      UTIKEYMAP(Euro, 0x400D)
      UTIKEYMAP(Undo, 0x400E)
/*UTIKEYMAP(space,0x020)
UTIKEYMAP(exclam,0x0219)
UTIKEYMAP(quotedbl,0x022)
UTIKEYMAP(numbersign,0x023)
UTIKEYMAP(dollar,0x024)
UTIKEYMAP(percent, 0x025)
UTIKEYMAP(ampersand ,0x026)
UTIKEYMAP(apostrophe,0x027)
UTIKEYMAP(parenleft,0x028)
UTIKEYMAP(parenright,0x029)
UTIKEYMAP(asterisk,0x02a)
UTIKEYMAP(plus,0x02b)
UTIKEYMAP(comma,0x02c)
UTIKEYMAP(minus,0x02d)
UTIKEYMAP(period,0x02e)
UTIKEYMAP(slash,0x02f)*/
UTIKEYMAP(0,0x030)
UTIKEYMAP(1,0x031)
UTIKEYMAP(2,0x032)
UTIKEYMAP(3,0x033)
UTIKEYMAP(4,0x034)
UTIKEYMAP(5,0x035)
UTIKEYMAP(6,0x036)
UTIKEYMAP(7,0x037)
UTIKEYMAP(8,0x038)
UTIKEYMAP(9,0x039)
      
      UTIKEYMAP(KP_0,0x230)
      UTIKEYMAP(KP_1,0x231)
      UTIKEYMAP(KP_2,0x232)
      UTIKEYMAP(KP_3,0x233)
      UTIKEYMAP(KP_4,0x234)
      UTIKEYMAP(KP_5,0x235)
      UTIKEYMAP(KP_6,0x236)
      UTIKEYMAP(KP_7,0x237)
      UTIKEYMAP(KP_8,0x238)
      UTIKEYMAP(KP_9,0x239)
      
      UTIKEYMAP(KP_PERIOD, 0x200);
      UTIKEYMAP(KP_DIVIDE, 0x201);
      UTIKEYMAP(KP_MULTIPLY, 0x202);
      UTIKEYMAP(KP_MINUS, 0x203);
      UTIKEYMAP(KP_PLUS, 0x204);
      UTIKEYMAP(KP_EQUALS, 0x205);
      UTIKEYMAP(KP_Enter,0x206)
/*UTIKEYMAP(colon,0x03a)
UTIKEYMAP(semicolon,0x03b)
UTIKEYMAP(less,0x03c)
UTIKEYMAP(equal,0x03d)
UTIKEYMAP(greater,0x03e)
UTIKEYMAP(question,0x03f)*/
#endif


#ifndef DONOTDECLARE
#undef UTIKEYMAP

#endif

#endif
