/***************************************************************************
 *   Copyright (C) 2006 by Michael Staud   *
 *   michael.staud@uni-ulm.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef _WIN32
#define WINNT 0x501
#define _WIN32_WINNT 0x501
#include <windows.h>
#include <shlobj.h>
#include <wchar.h>
//#include <iostream>
#include <stdexcept>
#include <tchar.h>
#include <direct.h>
 #include "psapi.h"
#include <malloc.h>
#elif __APPLE__

#include <mach/mach.h>
#include <mach/task.h>
#include <mach/mach_init.h>
#include <mach/clock.h>
#include <mach/mach_time.h>
#include <sys/sysctl.h>
#include <unistd.h>
#include <dirent.h>
#include <wchar.h>
#include <stdlib.h>
#include "sys/types.h"

#include <pwd.h>

#include <stdio.h>

#include <sys/stat.h>
#include <dlfcn.h>

#include <CoreFoundation/CFBundle.h>
#include <CoreFoundation/CFURL.h>
//#include <LaunchServices/LSOpen.h>
#else

  #include "sys/sysinfo.h"
#include <sys/timex.h>
 #include <unistd.h>
 #include <dirent.h>
 #include <wchar.h>
#include <stdlib.h>
#include <sys/types.h>
#include <pwd.h>

//#include <dlfcn.h>
#include <stdio.h>

 #include <sys/stat.h>
 #include <dlfcn.h>
#include <malloc.h>
 #endif
#include "utisystem.h"

 #include <iostream>
#include <sstream>
//#include <malloc.h>

#ifdef _MSC_VER
#define snprintf _snprintf
#endif
#ifdef _WIN32
void f_close(UtiFramework::Dir_FileInfo*fi);

void f_close1(HANDLE h);
#include <stdint.h>
#ifdef _MSC_VER
typedef uint32_t u_int32_t;
#else

typedef uint32_t u_int32_t;

#endif
#endif


#include <stdarg.h>

//utf8



/* is c the start of a utf8 sequence? */
#define isutf(c) (((c)&0xC0)!=0x80)

/* convert UTF-8 data to wide character */
int u8_toucs(u_int32_t *dest, int sz, char *src, int srcsz);

/* the opposite conversion */
int u8_toutf8(char *dest, int sz, u_int32_t *src, int srcsz);

/* single character to UTF-8 */
int u8_wc_toutf8(char *dest, u_int32_t ch);

/* character number to byte offset */
int u8_offset(char *str, int charnum);

/* byte offset to character number */
int u8_charnum(char *s, int offset);

/* return next character, updating an index variable */
u_int32_t u8_nextchar(char *s, int *i);

/* move to next character */
void u8_inc(char *s, int *i);

/* move to previous character */
void u8_dec(char *s, int *i);

/* returns length of next utf-8 sequence */
int u8_seqlen(char *s);

/* assuming src points to the character after a backslash, read an
   escape sequence, storing the result in dest and returning the number of
   input characters processed */
int u8_read_escape_sequence(char *src, u_int32_t *dest);

/* given a wide character, convert it to an ASCII escape sequence stored in
   buf, where buf is "sz" bytes. returns the number of characters output. */
int u8_escape_wchar(char *buf, int sz, u_int32_t ch);

/* convert a string "src" containing escape sequences to UTF-8 */
int u8_unescape(char *buf, int sz, char *src);

/* convert UTF-8 "src" to ASCII with escape sequences.
   if escape_quotes is nonzero, quote characters will be preceded by
   backslashes as well. */
int u8_escape(char *buf, int sz, char *src, int escape_quotes);

/* utility predicates used by the above */
int octal_digit(char c);
int hex_digit(char c);

/* return a pointer to the first occurrence of ch in s, or NULL if not
   found. character index of found character returned in *charn. */
char *u8_strchr(char *s, u_int32_t ch, int *charn);

/* same as the above, but searches a buffer of a given size instead of
   a NUL-terminated string. */
char *u8_memchr(char *s, u_int32_t ch, size_t sz, int *charn);

/* count the number of characters in a UTF-8 string */
int u8_strlen(char *s);

int u8_is_locale_utf8(char *locale);

/* printf where the format string and arguments may be in UTF-8.
   you can avoid this function and just use ordinary printf() if the current
   locale is UTF-8. */
int u8_vprintf(char *fmt, va_list ap);
int u8_printf(char *fmt, ...);

/*
  Basic UTF-8 manipulation routines
  by Jeff Bezanson
  placed in the public domain Fall 2005

  This code is designed to provide the utilities you need to manipulate
  UTF-8 as an internal string encoding. These functions do not perform the
  error checking normally needed when handling UTF-8 data, so if you happen
  to be from the Unicode Consortium you will want to flay me alive.
  I do this because error checking can be performed at the boundaries (I/O),
  with these routines reserved for higher performance on data known to be
  valid.
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#ifdef WIN32
#include <malloc.h>
#else
#include <alloca.h>
#endif
static const u_int32_t offsetsFromUTF8[6] = {
    0x00000000UL, 0x00003080UL, 0x000E2080UL,
    0x03C82080UL, 0xFA082080UL, 0x82082080UL
};

static const char trailingBytesForUTF8[256] = {
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, 3,3,3,3,3,3,3,3,4,4,4,4,5,5,5,5
};

/* returns length of next utf-8 sequence */
int u8_seqlen(char *s)
{
    return trailingBytesForUTF8[(unsigned int)(unsigned char)s[0]] + 1;
}

/* conversions without error checking
   only works for valid UTF-8, i.e. no 5- or 6-byte sequences
   srcsz = source size in bytes, or -1 if 0-terminated
   sz = dest size in # of wide characters

   returns # characters converted
   dest will always be L'\0'-terminated, even if there isn't enough room
   for all the characters.
   if sz = srcsz+1 (i.e. 4*srcsz+4 bytes), there will always be enough space.
*/
int u8_toucs(u_int32_t *dest, int sz, char *src, int srcsz)
{
    u_int32_t ch;
    char *src_end = src + srcsz;
    int nb;
    int i=0;

    while (i < sz-1) {
        nb = trailingBytesForUTF8[(unsigned char)*src];
        if (srcsz == -1) {
            if (*src == 0)
                goto done_toucs;
        }
        else {
            if (src + nb >= src_end)
                goto done_toucs;
        }
        ch = 0;
        switch (nb) {
            /* these fall through deliberately */
        case 3: ch += (unsigned char)*src++; ch <<= 6;
        case 2: ch += (unsigned char)*src++; ch <<= 6;
        case 1: ch += (unsigned char)*src++; ch <<= 6;
        case 0: ch += (unsigned char)*src++;
        }
        ch -= offsetsFromUTF8[nb];
        dest[i++] = ch;
    }
 done_toucs:
    dest[i] = 0;
    return i;
}

/* srcsz = number of source characters, or -1 if 0-terminated
   sz = size of dest buffer in bytes

   returns # characters converted
   dest will only be '\0'-terminated if there is enough space. this is
   for consistency; imagine there are 2 bytes of space left, but the next
   character requires 3 bytes. in this case we could NUL-terminate, but in
   general we can't when there's insufficient space. therefore this function
   only NUL-terminates if all the characters fit, and there's space for
   the NUL as well.
   the destination string will never be bigger than the source string.
*/
int u8_toutf8(char *dest, int sz, u_int32_t *src, int srcsz)
{
    u_int32_t ch;
    int i = 0;
    char *dest_end = dest + sz;

    while (srcsz<0 ? src[i]!=0 : i < srcsz) {
        ch = src[i];
        if (ch < 0x80) {
            if (dest >= dest_end)
                return i;
            *dest++ = (char)ch;
        }
        else if (ch < 0x800) {
            if (dest >= dest_end-1)
                return i;
            *dest++ = (ch>>6) | 0xC0;
            *dest++ = (ch & 0x3F) | 0x80;
        }
        else if (ch < 0x10000) {
            if (dest >= dest_end-2)
                return i;
            *dest++ = (ch>>12) | 0xE0;
            *dest++ = ((ch>>6) & 0x3F) | 0x80;
            *dest++ = (ch & 0x3F) | 0x80;
        }
        else if (ch < 0x110000) {
            if (dest >= dest_end-3)
                return i;
            *dest++ = (ch>>18) | 0xF0;
            *dest++ = ((ch>>12) & 0x3F) | 0x80;
            *dest++ = ((ch>>6) & 0x3F) | 0x80;
            *dest++ = (ch & 0x3F) | 0x80;
        }
        i++;
    }
    if (dest < dest_end)
        *dest = '\0';
    return i;
}

int u8_wc_toutf8(char *dest, u_int32_t ch)
{
    if (ch < 0x80) {
        dest[0] = (char)ch;
        return 1;
    }
    if (ch < 0x800) {
        dest[0] = (ch>>6) | 0xC0;
        dest[1] = (ch & 0x3F) | 0x80;
        return 2;
    }
    if (ch < 0x10000) {
        dest[0] = (ch>>12) | 0xE0;
        dest[1] = ((ch>>6) & 0x3F) | 0x80;
        dest[2] = (ch & 0x3F) | 0x80;
        return 3;
    }
    if (ch < 0x110000) {
        dest[0] = (ch>>18) | 0xF0;
        dest[1] = ((ch>>12) & 0x3F) | 0x80;
        dest[2] = ((ch>>6) & 0x3F) | 0x80;
        dest[3] = (ch & 0x3F) | 0x80;
        return 4;
    }
    return 0;
}

/* charnum => byte offset */
int u8_offset(char *str, int charnum)
{
    int offs=0;

    while (charnum > 0 && str[offs]) {
        (void)(isutf(str[++offs]) || isutf(str[++offs]) ||
               isutf(str[++offs]) || ++offs);
        charnum--;
    }
    return offs;
}

/* byte offset => charnum */
int u8_charnum(char *s, int offset)
{
    int charnum = 0, offs=0;

    while (offs < offset && s[offs]) {
        (void)(isutf(s[++offs]) || isutf(s[++offs]) ||
               isutf(s[++offs]) || ++offs);
        charnum++;
    }
    return charnum;
}

/* number of characters */
int u8_strlen(char *s)
{
    int count = 0;
    int i = 0;

    while (u8_nextchar(s, &i) != 0)
        count++;

    return count;
}

/* reads the next utf-8 sequence out of a string, updating an index */
u_int32_t u8_nextchar(char *s, int *i)
{
    u_int32_t ch = 0;
    int sz = 0;

    do {
        ch <<= 6;
        ch += (unsigned char)s[(*i)++];
        sz++;
    } while (s[*i] && !isutf(s[*i]));
    ch -= offsetsFromUTF8[sz-1];

    return ch;
}

void u8_inc(char *s, int *i)
{
    (void)(isutf(s[++(*i)]) || isutf(s[++(*i)]) ||
           isutf(s[++(*i)]) || ++(*i));
}

void u8_dec(char *s, int *i)
{
    (void)(isutf(s[--(*i)]) || isutf(s[--(*i)]) ||
           isutf(s[--(*i)]) || --(*i));
}

int octal_digit(char c)
{
    return (c >= '0' && c <= '7');
}

int hex_digit(char c)
{
    return ((c >= '0' && c <= '9') ||
            (c >= 'A' && c <= 'F') ||
            (c >= 'a' && c <= 'f'));
}

/* assumes that src points to the character after a backslash
   returns number of input characters processed */
int u8_read_escape_sequence(char *str, u_int32_t *dest)
{
    u_int32_t ch;
    char digs[9]="\0\0\0\0\0\0\0\0";
    int dno=0, i=1;

    ch = (u_int32_t)str[0];    /* take literal character */
    if (str[0] == 'n')
        ch = L'\n';
    else if (str[0] == 't')
        ch = L'\t';
    else if (str[0] == 'r')
        ch = L'\r';
    else if (str[0] == 'b')
        ch = L'\b';
    else if (str[0] == 'f')
        ch = L'\f';
    else if (str[0] == 'v')
        ch = L'\v';
    else if (str[0] == 'a')
        ch = L'\a';
    else if (octal_digit(str[0])) {
        i = 0;
        do {
            digs[dno++] = str[i++];
        } while (octal_digit(str[i]) && dno < 3);
        ch = strtol(digs, NULL, 8);
    }
    else if (str[0] == 'x') {
        while (hex_digit(str[i]) && dno < 2) {
            digs[dno++] = str[i++];
        }
        if (dno > 0)
            ch = strtol(digs, NULL, 16);
    }
    else if (str[0] == 'u') {
        while (hex_digit(str[i]) && dno < 4) {
            digs[dno++] = str[i++];
        }
        if (dno > 0)
            ch = strtol(digs, NULL, 16);
    }
    else if (str[0] == 'U') {
        while (hex_digit(str[i]) && dno < 8) {
            digs[dno++] = str[i++];
        }
        if (dno > 0)
            ch = strtol(digs, NULL, 16);
    }
    *dest = ch;

    return i;
}

/* convert a string with literal \uxxxx or \Uxxxxxxxx characters to UTF-8
   example: u8_unescape(mybuf, 256, "hello\\u220e")
   note the double backslash is needed if called on a C string literal */
int u8_unescape(char *buf, int sz, char *src)
{
    int c=0, amt;
    u_int32_t ch;
    char temp[4];

    while (*src && c < sz) {
        if (*src == '\\') {
            src++;
            amt = u8_read_escape_sequence(src, &ch);
        }
        else {
            ch = (u_int32_t)*src;
            amt = 1;
        }
        src += amt;
        amt = u8_wc_toutf8(temp, ch);
        if (amt > sz-c)
            break;
        memcpy(&buf[c], temp, amt);
        c += amt;
    }
    if (c < sz)
        buf[c] = '\0';
    return c;
}

int u8_escape_wchar(char *buf, int sz, u_int32_t ch)
{
    if (ch == L'\n')
        return snprintf(buf, sz, "\\n");
    else if (ch == L'\t')
        return snprintf(buf, sz, "\\t");
    else if (ch == L'\r')
        return snprintf(buf, sz, "\\r");
    else if (ch == L'\b')
        return snprintf(buf, sz, "\\b");
    else if (ch == L'\f')
        return snprintf(buf, sz, "\\f");
    else if (ch == L'\v')
        return snprintf(buf, sz, "\\v");
    else if (ch == L'\a')
        return snprintf(buf, sz, "\\a");
    else if (ch == L'\\')
        return snprintf(buf, sz, "\\\\");
    else if (ch < 32 || ch == 0x7f)
        return snprintf(buf, sz, "\\x%hhX", (unsigned char)ch);
    else if (ch > 0xFFFF)
        return snprintf(buf, sz, "\\U%.8X", (u_int32_t)ch);
    else if (ch >= 0x80 && ch <= 0xFFFF)
        return snprintf(buf, sz, "\\u%.4hX", (unsigned short)ch);

    return snprintf(buf, sz, "%c", (char)ch);
}

int u8_escape(char *buf, int sz, char *src, int escape_quotes)
{
    int c=0, i=0, amt;

    while (src[i] && c < sz) {
        if (escape_quotes && src[i] == '"') {
            amt = snprintf(buf, sz - c, "\\\"");
            i++;
        }
        else {
            amt = u8_escape_wchar(buf, sz - c, u8_nextchar(src, &i));
        }
        c += amt;
        buf += amt;
    }
    if (c < sz)
        *buf = '\0';
    return c;
}

char *u8_strchr(char *s, u_int32_t ch, int *charn)
{
    int i = 0, lasti=0;
    u_int32_t c;

    *charn = 0;
    while (s[i]) {
        c = u8_nextchar(s, &i);
        if (c == ch) {
            return &s[lasti];
        }
        lasti = i;
        (*charn)++;
    }
    return NULL;
}

char *u8_memchr(char *s, u_int32_t ch, size_t sz, int *charn)
{
    int i = 0, lasti=0;
    u_int32_t c;
    int csz;

    *charn = 0;
    while (i < sz) {
        c = csz = 0;
        do {
            c <<= 6;
            c += (unsigned char)s[i++];
            csz++;
        } while (i < sz && !isutf(s[i]));
        c -= offsetsFromUTF8[csz-1];

        if (c == ch) {
            return &s[lasti];
        }
        lasti = i;
        (*charn)++;
    }
    return NULL;
}

int u8_is_locale_utf8(char *locale)
{
    /* this code based on libutf8 */
    const char* cp = locale;

    for (; *cp != '\0' && *cp != '@' && *cp != '+' && *cp != ','; cp++) {
        if (*cp == '.') {
            const char* encoding = ++cp;
            for (; *cp != '\0' && *cp != '@' && *cp != '+' && *cp != ','; cp++)
                ;
            if ((cp-encoding == 5 && !strncmp(encoding, "UTF-8", 5))
                || (cp-encoding == 4 && !strncmp(encoding, "utf8", 4)))
                return 1; /* it's UTF-8 */
            break;
        }
    }
    return 0;
}

int u8_vprintf(char *fmt, va_list ap)
{
    int cnt, sz=0;
    char *buf;
    u_int32_t *wcs;

    sz = 512;
    buf = (char*)alloca(sz);
 try_print:
    cnt = vsnprintf(buf, sz, fmt, ap);
    if (cnt >= sz) {
        buf = (char*)alloca(cnt - sz + 1);
        sz = cnt + 1;
        goto try_print;
    }
    wcs = (u_int32_t*)alloca((cnt+1) * sizeof(u_int32_t));
    cnt = u8_toucs(wcs, cnt+1, buf, cnt);
    printf("%ls", (wchar_t*)wcs);
    return cnt;
}

int u8_printf(char *fmt, ...)
{
    int cnt;
    va_list args;

    va_start(args, fmt);

    cnt = u8_vprintf(fmt, args);

    va_end(args);
    return cnt;
}


 namespace UtiFramework {

 long int SubtractSecounds = 0;
 bool istimeinitialized = false;
#ifdef _WIN32

void initTime()
 {
istimeinitialized = true;
 }

 double getCurrentTime()
 {
   utiassert(istimeinitialized == true);
//#ifndef __MINGW32__
    __int64 ende, freq;
   QueryPerformanceCounter((LARGE_INTEGER*)&ende);
   QueryPerformanceFrequency((LARGE_INTEGER*)&freq);

   double time = (double)ende;
   time /= freq;
   return time;
   //#else
   //return (double)SDL_GetTicks() / 1000.0;
   //#endif
 }

#ifndef CSIDL_APPDATA
    #define CSIDL_APPDATA         0x001a
#endif

#ifndef CSIDL_LOCAL_APPDATA
    #define CSIDL_LOCAL_APPDATA   0x001c
#endif

#ifndef CSIDL_COMMON_APPDATA
    #define CSIDL_COMMON_APPDATA  0x0023
#endif

#ifndef CSIDL_PROGRAM_FILES
    #define CSIDL_PROGRAM_FILES   0x0026
#endif

#ifndef CSIDL_PERSONAL
    #define CSIDL_PERSONAL        0x0005
#endif

#ifndef SHGFP_TYPE_CURRENT
    #define SHGFP_TYPE_CURRENT 0
#endif

#ifndef SHGFP_TYPE_DEFAULT
    #define SHGFP_TYPE_DEFAULT 1
#endif
/*
struct ShellFunctions
{
    ShellFunctions()
    {
        pSHGetFolderPath = NULL;
        pSHGetSpecialFolderPath = NULL;
        initialized = false;
    }

    SHGetFolderPath_t pSHGetFolderPath;
    SHGetSpecialFolderPath_t pSHGetSpecialFolderPath;

    bool initialized;
};

// in spite of using a static variable, this is MT-safe as in the worst case it
// results in initializing the function pointer several times -- but this is
// harmless
ShellFunctions gs_shellFuncs;

// ----------------------------------------------------------------------------
// private functions
// ----------------------------------------------------------------------------

void resolveShellFunctions()
{
#if wxUSE_DYNLIB_CLASS

    // start with the newest functions, fall back to the oldest ones

    // first check for SHGetFolderPath (shell32.dll 5.0)
    std::string shellDllName(wxT("shell32"));


    wxDynamicLibrary dllShellFunctions( shellDllName );
    if ( !dllShellFunctions.IsLoaded() )
    {
        wxLogTrace(TRACE_MASK, wxT("Failed to load %s.dll"), shellDllName.c_str() );
    }

    // don't give errors if the functions are unavailable, we're ready to deal
    // with this
    wxLogNull noLog;

#if wxUSE_UNICODE
    #ifdef __WXWINCE__
        static const wchar_t UNICODE_SUFFIX = L''; // WinCE SH functions don't seem to have 'W'
    #else
        static const wchar_t UNICODE_SUFFIX = L'W';
    #endif
#else // !Unicode
    static const char UNICODE_SUFFIX = 'A';
#endif // Unicode/!Unicode

    wxString funcname(wxT("SHGetFolderPath"));
    gs_shellFuncs.pSHGetFolderPath =
        (SHGetFolderPath_t)dllShellFunctions.GetSymbol(funcname + UNICODE_SUFFIX);

    // then for SHGetSpecialFolderPath (shell32.dll 4.71)
    if ( !gs_shellFuncs.pSHGetFolderPath )
    {
        funcname = wxT("SHGetSpecialFolderPath");
        gs_shellFuncs.pSHGetSpecialFolderPath = (SHGetSpecialFolderPath_t)
            dllShellFunctions.GetSymbol(funcname + UNICODE_SUFFIX);
    }

    // finally we fall back on SHGetSpecialFolderLocation (shell32.dll 4.0),
    // but we don't need to test for it -- it is available even under Win95

    // shell32.dll is going to be unloaded, but it still remains in memory
    // because we also link to it statically, so it's ok

    gs_shellFuncs.initialized = true;
#endif
}
*/

CUtiString doGetDirectory(int csidl)
{
     CUtiString dir;
    HRESULT hr = E_FAIL;

Array<wchar_t> path(MAX_PATH);

        hr = SHGetFolderPathW
             (
                NULL,               // parent window, not used
                csidl,
                NULL,               // access token (current user)
                SHGFP_TYPE_CURRENT, // current path, not just default value
                path.getCArray()
             );

        if ( hr == E_FAIL || hr == S_FALSE)
        {

            hr = SHGetFolderPathW
                 (
                    NULL,
                    csidl,
                    NULL,
                    SHGFP_TYPE_DEFAULT,
                    path.getCArray()
                 );
        }
    assert(hr != E_FAIL);
    dir = path.getCArray();
    return dir;
}

inline CUtiString getFullModuleName(HMODULE hmod)
{
    CUtiString fullname;
    Array<wchar_t> path(MAX_PATH);
    if ( !::GetModuleFileName
            (
                hmod,
                path.getCArray(),
                MAX_PATH
            ) )
    {

    } else {
         fullname = path.getCArray();


    }

    return fullname;
}

inline CUtiString getFullModuleName()
{
    return getFullModuleName((HMODULE)NULL);
}

 CUtiString getAppDir()
{
    CUtiString appDir;

        appDir =getFullModuleName();
        appDir.ExtractFilePath();


    return appDir;

}
CUtiString getDataDir()
{
    assert(false);
   return getAppDir();
}
CUtiString getUserConfigDir()
{
return doGetDirectory(CSIDL_APPDATA);

}
CUtiString getDocumentsDir()
{
return doGetDirectory(CSIDL_PERSONAL);

}

bool LaunchDefaultBrowser(const CUtiString& url)
{
    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE);

    SHELLEXECUTEINFOW sei;
    ZeroMemory(&sei, sizeof(sei));
    sei.cbSize = sizeof(sei);
    sei.lpFile = url.c_str();
    sei.lpVerb = L"open";
    sei.nShow = SW_SHOWNORMAL;
    sei.fMask = SEE_MASK_FLAG_NO_UI; // we give error message ourselves

    if ( ::ShellExecuteExW(&sei) ) {
        return true;
    } else {
        int error = GetLastError();
        std::wcout << "Loading Error: " << error << std::endl;
    }

    return false;
}

#elif __APPLE__
 void initTime()
 {

    SubtractSecounds = mach_absolute_time();
    istimeinitialized = true;

 }

 double getCurrentTime()
 {
    utiassert(istimeinitialized == true);
    long time = mach_absolute_time();
    time -= SubtractSecounds;
    return (double)time/1000000000.0;
 }

 /*
  * wxString wxCFStringRef::AsStringWithNormalizationFormC( CFStringRef ref, wxFontEncoding encoding )
{
    if ( !ref )
        return wxEmptyString ;

    CFMutableStringRef cfMutableString = CFStringCreateMutableCopy(NULL, 0, ref);
    CFStringNormalize(cfMutableString,kCFStringNormalizationFormC);
    wxString str = wxCFStringRef::AsString(cfMutableString,encoding);
    CFRelease(cfMutableString);
    return str;
}

wxString wxCFStringRef::AsString( CFStringRef ref, wxFontEncoding WXUNUSED_IN_UNICODE(encoding) )
{
    if ( !ref )
        return wxEmptyString ;

    Size cflen = CFStringGetLength( ref )  ;

    CFStringEncoding cfencoding;
    wxString result;
#if wxUSE_UNICODE
  #if wxUSE_UNICODE_WCHAR
    cfencoding = kCFStringEncodingUTF32Native;
  #elif wxUSE_UNICODE_UTF8
    cfencoding = kCFStringEncodingUTF8;
  #else
    #error "unsupported unicode representation"
  #endif
#else
    cfencoding = wxMacGetSystemEncFromFontEnc( encoding );
#endif

    CFIndex cStrLen ;
    CFStringGetBytes( ref , CFRangeMake(0, cflen) , cfencoding ,
        '?' , false , NULL , 0 , &cStrLen ) ;
    char* buf = new char[cStrLen];
    CFStringGetBytes( ref , CFRangeMake(0, cflen) , cfencoding,
        '?' , false , (unsigned char*) buf , cStrLen , &cStrLen) ;

#if wxUSE_UNICODE
  #if wxUSE_UNICODE_WCHAR
    result = wxString( (const wchar_t*) buf , cStrLen/4);
  #elif wxUSE_UNICODE_UTF8
    result = wxString::FromUTF8( buf, cStrLen );
  #else
    #error "unsupported unicode representation"
  #endif
#else
    result = wxString(buf, cStrLen) ;
#endif

    delete[] buf ;
    wxMacConvertNewlines10To13( &result);
    return result ;
}
*/

CUtiString osxStringToUti(CFStringRef strpath)
{
if (strpath == NULL) {
    return EMPTYSTRING;
}
   const char* buffer = CFStringGetCStringPtr(strpath, kCFStringEncodingMacRoman);
   if (buffer != NULL) {
       return converttowide(buffer);
   }
   int length = CFStringGetLength(strpath);
   length += 10;
   char* tempbuffer = new char[length];

   Boolean success = CFStringGetCString(strpath, tempbuffer, length, kCFStringEncodingMacRoman);
   CUtiString res;
   res = EMPTYSTRING;
   if (success) {
       res = converttowide(tempbuffer);
   }

   delete [] tempbuffer;

   return res;

}

CFStringRef osxCreateString(const CUtiString& text)
{
    std::string str = converttomulti(text);
    return CFStringCreateWithCString(NULL, str.c_str(), kCFStringEncodingMacRoman);
}

CUtiString UtiBundleRelativeURLToPath(CFURLRef relativeURL)
{
    CFURLRef absoluteURL = CFURLCopyAbsoluteURL(relativeURL);
    //wxCHECK_MSG(absoluteURL, wxEmptyString, wxT("Failed to resolve relative URL to absolute URL"));
    CFStringRef cfStrPath = CFURLCopyFileSystemPath(absoluteURL,kCFURLPOSIXPathStyle);
    CFRelease(absoluteURL);
    CUtiString str = osxStringToUti(cfStrPath);
    CFRelease(cfStrPath);
    return str;
}

CUtiString getFromFunc(CFURLRef (*func)(CFBundleRef))
{
//wxCHECK_MSG(m_bundle, wxEmptyString,
 //               wxT("wxStandardPaths for CoreFoundation only works with bundled apps"));
    CFBundleRef bundle = CFBundleGetMainBundle();
    CFURLRef relativeURL = (*func)(bundle);
    CFRelease(bundle);
  //  wxCHECK_MSG(relativeURL, wxEmptyString, wxT("Couldn't get URL"));
    CUtiString ret(UtiBundleRelativeURLToPath(relativeURL));
    CFRelease(relativeURL);
    return ret;
}


 CUtiString getAppDir()
{
assert(false);
return EMPTYSTRING;

}
CUtiString getDataDir()
{
    assert(false);
   return getFromFunc(CFBundleCopySharedSupportURL);
}

CUtiString getUserHome( const CUtiString &user )
{


    struct passwd* who = NULL;
    if ( user.size() == 0 )
    {
        char *ptr = NULL;

        if ((ptr = getenv("HOME")) != NULL)
        {
            return converttowide(ptr);
        }

        if ((ptr = getenv("USER")) != NULL ||
             (ptr = getenv("LOGNAME")) != NULL)
        {
            who = getpwnam(ptr);
        }

        // make sure the user exists!
        if ( !who )
        {
            who = getpwuid(getuid());
        }
    }
    else
    {
        std::string str = converttomulti(user);
      who = getpwnam (str.c_str());
    }

    if (who) {
        return converttowide(who->pw_dir);

    } else {
        return UTISTR("~/");
    }

    //return wxSafeConvertMB2WX(who ? who->pw_dir : 0);
}

CUtiString getHomeDir( )
{
    CUtiString home;
    home = getUserHome(EMPTYSTRING);

    if ( home.size() == 0) {
        home = UTISTR("/");
    }

    return home;
}

CUtiString getUserConfigDir()
{
#if defined( __WXMAC__ ) && wxOSX_USE_CARBON
    return wxMacFindFolderNoSeparator((short)kUserDomain, kPreferencesFolderType, kCreateFolder);
#else
    return  getHomeDir() + UTISTR("/Library/Preferences");
#endif

}
CUtiString getDocumentsDir()
{
#if defined( __WXMAC__ ) && wxOSX_USE_CARBON
    return wxMacFindFolderNoSeparator
        (
        kUserDomain,
        kDocumentsFolderType,
        kCreateFolder
        );
#else
    return getHomeDir() + UTISTR("/Documents");
#endif

}



bool LaunchDefaultBrowser(const CUtiString& url)
{
    /*CFStringRef url1 = osxCreateString(url);

     CFURLRef  curl = CFURLCreateWithString( kCFAllocatorDefault,
                              url1, NULL );
    OSStatus err = LSOpenCFURLRef( curl , NULL );

    CFRelease(curl);
    CFRelease(url1);

    if (err == noErr)
    {
        return true;
    }
    else
    {

        return false;
    }*/
    return true;
}

#else
 timex clockstate;
 void initTime()
 {
     if (istimeinitialized)return;
     assert(istimeinitialized == false);
      memset(&clockstate, 0, sizeof(clockstate));
      ntp_adjtime(&clockstate);
    ntptimeval time;
     memset(&time, 0, sizeof(time));

    ntp_gettime(&time);
    SubtractSecounds = time.time.tv_sec;
    istimeinitialized = true;

 }

 double getCurrentTime()
 {
    utiassert(istimeinitialized == true);
    ntptimeval time;
    memset(&time, 0, sizeof(time));
    int r = ntp_gettime(&time);
    time.time.tv_sec -= SubtractSecounds;
    double res = double(time.time.tv_sec);
    if ((clockstate.status & STA_NANO) != 0) {
       res += double(time.time.tv_usec)/1000000000.0;
    } else {
       res += double(time.time.tv_usec)/1000000.0;
    }
    return res;
 }

CUtiString getAppDir()
{
assert(false);
return EMPTYSTRING;

}

CUtiString getUserHome( const CUtiString &user )
{


    struct passwd* who = NULL;
    if ( user.size() == 0 )
    {
        char *ptr = NULL;

        if ((ptr = getenv("HOME")) != NULL)
        {
            return converttowide(ptr);
        }

        if ((ptr = getenv("USER")) != NULL ||
             (ptr = getenv("LOGNAME")) != NULL)
        {
            who = getpwnam(ptr);
        }

        // make sure the user exists!
        if ( !who )
        {
            who = getpwuid(getuid());
        }
    }
    else
    {
        std::string str = converttomulti(user);
      who = getpwnam (str.c_str());
    }

    if (who) {
        return converttowide(who->pw_dir);

    } else {
        return UTISTR("~/");
    }

    //return wxSafeConvertMB2WX(who ? who->pw_dir : 0);
}

CUtiString getHomeDir( )
{
    CUtiString home;
    home = getUserHome(EMPTYSTRING);

    if ( home.size() == 0) {
        home = UTISTR("/");
    }

    return home;
}


CUtiString getDataDir()
{
    assert(false);
return EMPTYSTRING;//  AppendAppInfo(GetInstallPrefix() + UTISTR("/sys$share"));
}
CUtiString getUserConfigDir()
{
return getHomeDir();

}
CUtiString getDocumentsDir()
{


        CUtiString homeDir = getHomeDir();
        return homeDir;
        CUtiString configPath;
        if (getenv("XDG_CONFIG_HOME"))
            configPath = converttowide(getenv("XDG_CONFIG_HOME"));
        else
            configPath = homeDir + UTISTR("/.config");
        CUtiString dirsFile = configPath + UTISTR("/user-dirs.dirs");
        if (getFileSize(dirsFile) != -1)
        {
            CStringList textFile;
            textFile.loadFromFile(dirsFile);

            if (textFile.size() != 0)
            {

                for (int i = 0; i < textFile.size(); i++)
                {
                    CUtiString line(textFile.getLine(i));
                    int pos = line.Pos(UTISTR("XDG_DOCUMENTS_DIR"));
                    if (pos != -1)
                    {
                        int p1 = line.Pos(UTISTR("="));
                        CUtiString value = line(p1+1, line.size()-p1);

                        value.ReplaceString(UTISTR("$HOME"), homeDir);
                        value.Trim();
                        if (!(value.size() == 0) && getFileSize(value) != -1)
                            return value;
                        else
                            break;
                    }
                }
            }
        }


    return homeDir;

}

bool LaunchDefaultBrowser(const CUtiString& url)
{

    CUtiString path, xdg_open;

    std::string str;
    str = "xdg-open ";
    str += converttomulti(url);
    FILE* f = popen(str.c_str(), "r");

    pclose(f);

    //wxExecute("xdg-open" + " " + url);


    return true;
}

 #endif
const CUtiString converttowide(const wchar_t*c)
{
    CUtiString res;
    res = c;
    return res;


}

std::string intToString(int i)
{
    std::stringstream ss;
    std::string s;
    ss << i;
    s = ss.str();

    return s;
}


int parseLine(char* line){
        int i = strlen(line);
        while (*line < '0' || *line > '9') line++;
        line[i-3] = '\0';
        i = atoi(line);
        return i;
    }


void getSystemInformation(SystemInformation& system)
{


   // malloc_stats();
#ifdef WIN32
    MEMORYSTATUSEX memInfo;
        memInfo.dwLength = sizeof(MEMORYSTATUSEX);
        GlobalMemoryStatusEx(&memInfo);
        DWORDLONG totalVirtualMem = memInfo.ullTotalPageFile;
         DWORDLONG virtualMemUsed = memInfo.ullTotalPageFile - memInfo.ullAvailPageFile;
          DWORDLONG totalPhysMem = memInfo.ullTotalPhys;
          DWORDLONG physMemUsed = memInfo.ullTotalPhys - memInfo.ullAvailPhys;
        system.m_virtualmemsize = totalVirtualMem;

        system.m_virtualmemused = virtualMemUsed;
        system.m_physicalmemsize = totalPhysMem;
        system.m_physicalmemused = physMemUsed;




        PROCESS_MEMORY_COUNTERS_EX pmc;
        pmc.cb = sizeof(PROCESS_MEMORY_COUNTERS_EX);
            GetProcessMemoryInfo(GetCurrentProcess(), (PROCESS_MEMORY_COUNTERS*)&pmc, sizeof(pmc));
            SIZE_T virtualMemUsedByMe = pmc.PrivateUsage;
             SIZE_T physMemUsedByMe = pmc.WorkingSetSize;

            system.m_virtualapplicationusage = virtualMemUsedByMe;
            system.m_physicalapplicationusage = physMemUsedByMe;

            system.m_heapsize = virtualMemUsed;

            system.m_allocatedmem = physMemUsedByMe;



   /* system.m_virtualapplicationusage = 3000;
    system.m_physicalapplicationusage = 3000;

    system.m_heapsize = 2000;

    system.m_allocatedmem = 1000;*/
#elif __APPLE__
   /* UTI_INT64 m_virtualmemsize;
    UTI_INT64 m_virtualmemused;
    UTI_INT64 m_physicalmemsize;
    UTI_INT64 m_physicalmemused;
    UTI_INT64 m_virtualapplicationusage;
    UTI_INT64 m_physicalapplicationusage;
    UTI_INT64 m_heapsize;
    UTI_INT64 m_allocatedmem;
    UTI_INT64 m_maxmemory;*/
    UTI_INT64 onegb = (UTI_INT64)1024*(UTI_INT64)1024*(UTI_INT64)1024;
    system.m_virtualmemsize = (UTI_INT64)8*onegb;
    system.m_virtualmemused = (UTI_INT64)1*onegb;
    system.m_physicalmemsize = (UTI_INT64)8*onegb;
    system.m_physicalmemused = (UTI_INT64)1*onegb;
    system.m_virtualapplicationusage = (UTI_INT64)1*onegb;
    system.m_physicalapplicationusage = (UTI_INT64)1*onegb;
    system.m_heapsize = (UTI_INT64)8*onegb;
    system.m_allocatedmem = (UTI_INT64)1*onegb;
    system.m_maxmemory = (UTI_INT64)8*onegb;

#else
    struct mallinfo info;

    info = mallinfo();
    system.m_heapsize = info.fordblks;
    system.m_heapsize += info.uordblks;
    system.m_allocatedmem = info.uordblks;
    struct sysinfo memInfo;


        sysinfo (&memInfo);
        long long totalVirtualMem = memInfo.totalram;

        totalVirtualMem += memInfo.totalswap;
        totalVirtualMem *= memInfo.mem_unit;

        long long virtualMemUsed = memInfo.totalram - memInfo.freeram;
           virtualMemUsed += memInfo.totalswap - memInfo.freeswap;
           virtualMemUsed *= memInfo.mem_unit;

        long long totalPhysMem = memInfo.totalram;
        totalPhysMem *= memInfo.mem_unit;

        long long physMemUsed = memInfo.totalram - memInfo.freeram;
           physMemUsed *= memInfo.mem_unit;

           system.m_virtualmemsize = totalVirtualMem;

           system.m_virtualmemused = virtualMemUsed;
           system.m_physicalmemsize = totalPhysMem;
           system.m_physicalmemused = physMemUsed;


           FILE* file = fopen("/proc/self/status", "r");
                   //int result = -1;
                   char line[128];


                   int found = 0;
                   while (fgets(line, 128, file) != NULL){
                       if (strncmp(line, "VmSize:", 7) == 0){
                           system.m_virtualapplicationusage = parseLine(line);
                           system.m_virtualapplicationusage*= 1024;
                           found++;
                       } else
                       if (strncmp(line, "VmRSS:", 6) == 0){
                               system.m_physicalapplicationusage = parseLine(line);
                               system.m_physicalapplicationusage*= 1024;
                               found++;
                        }
                       if (found == 2)
                       {
                          break;
                       }
                   }
                   fclose(file);


#endif
                   if (sizeof(void*) == 4) {
                       system.m_maxmemory = umax((UTI_INT64)1024*(UTI_INT64)1024*(UTI_INT64)1200, umin((UTI_INT64)1024*(UTI_INT64)1024*(UTI_INT64)1300, system.m_physicalmemsize-(UTI_INT64)700*(UTI_INT64)1024*1024));
                   } else {
                       if ((system.m_physicalmemsize/1024/1024) < 4000) {
                           system.m_maxmemory =  system.m_physicalmemsize-(UTI_INT64)700*(UTI_INT64)1024*(UTI_INT64)1024;
                       } else {
                          system.m_maxmemory =  system.m_physicalmemsize-(UTI_INT64)1000*(UTI_INT64)1024*(UTI_INT64)1024;
                       }
                   }
                  // system.m_maxmemory = 800*1024*1024;
}

const CUtiString converttowideOld(const char*c)
{
    size_t len = strlen(c);
    wchar_t tmp[1];
    mbstate_t state;
    memset(&state, 0, sizeof(state));
    size_t nbytes;
    CUtiString result;
    while((nbytes = mbrtowc(tmp, c, len, &state)) > 0) {
        if (nbytes >= (size_t) -2) {
           nbytes = 1;
           tmp[0] = *c;
        };
        if (tmp[0] == 0) break;
        result += tmp[0];
        len -= nbytes;
        c += nbytes;

    }
    return result;
}

const CUtiString convertutf8towide(const char*c)
{

    size_t len =   strlen(c);
    size_t clen = len+2;
    Array<unsigned int> widereturn(clen);
    Array<wchar_t> widereturnchar(clen);

    int retcount = u8_toucs(widereturn.getCArray(), clen, const_cast<char*>(c), len);
    assert(retcount < 64);
    for (int i = 0; i <= retcount; i++) {
        widereturnchar[i] = widereturn[i];
    }

     CUtiString result;
     result = widereturnchar.getCArray();


   return result;

}


const CUtiString converttowide(const char*c)
{
    #ifdef WIN32
    int lenA = lstrlenA(c);
    int lenW;
    BSTR unicodestr;
    lenW = ::MultiByteToWideChar(CP_ACP, 0, c, lenA, 0,0);
    if (lenW > 0) {
        unicodestr = ::SysAllocStringLen(0, lenW);
        ::MultiByteToWideChar(CP_ACP, 0, c, lenA, unicodestr, lenW);
         CUtiString result;
         result = unicodestr;
        ::SysFreeString(unicodestr);
         return result;
    } else {
        return EMPTYSTRING;
    }
#else
    //input is not utf8 instead some platform dependend stuff!!
    size_t len =   strlen(c);
    Array<wchar_t> widestr(len+1);

   //size_t len =  mbstowcs(NULL, c, 0);// strlen(c);
   wchar_t tmp[1];
   mbstate_t state;
   memset(&state, 0, sizeof(state));
   size_t nbytes;
   int currentreturnpos = 0;
   while((nbytes = mbrtowc(tmp, c, len, &state)) > 0) {
       if (nbytes >= (size_t) -2) {
          nbytes = 1;
          tmp[0] = *c;
       };
       if (tmp[0] == 0) break;
       widestr[currentreturnpos] = tmp[0];
       currentreturnpos++;
       //result += tmp[0];
       len -= nbytes;
       c += nbytes;

   }
   widestr[currentreturnpos] = 0;
   CUtiString result;
   result = widestr.array;
   return result;
#endif
}

const std::string converttomulti(const CUtiString &c)
{
    return converttomulti(c.c_str());
    };

const std::string converttomulti(const wchar_t * c)
{
#ifdef WIN32
   char* ansistr;
   BSTR unicodestr = ::SysAllocString(c);
   int lenW = ::SysStringLen(unicodestr);
   int lenA = ::WideCharToMultiByte(CP_ACP, 0, unicodestr, lenW, 0, 0, NULL, NULL);
   if (lenA > 0) {
       ansistr = new char[lenA+1];
       ::WideCharToMultiByte(CP_ACP, 0, unicodestr, lenW, ansistr, lenA, NULL, NULL);
       ansistr[lenA] = 0;
       std::string  res(ansistr);
       delete [] ansistr;
       ::SysFreeString(unicodestr);
       return res;
   }else {

       ::SysFreeString(unicodestr);
       return"";
   }
#else
   mbstate_t state;
   memset(&state, 0, sizeof(state));
   int length = wcslen(c);
   Array<wchar_t> c_bfr(const_cast<wchar_t*>(c), length+1);
   int buffersize = length*2+3;
   //int currentsize = 0;
   Array<char> wp(buffersize);
   //char* wp = new char[buffersize];
   //char* start = wp;
   int position = 0;
   int resposition = 0;
   while (c_bfr[position] != L'\0') {
      size_t nbytes;
      char tempwp[8];
      nbytes = wcrtomb(tempwp, c_bfr[position], &state);
      if (nbytes == (size_t)-1) {
         //return "";
          position++;
          continue;
      }
      for (size_t i = 0; i < nbytes; i++) {
	 wp[resposition] = tempwp[i];
	 resposition++;
      };
     // wp += nbytes;
     // currentsize += nbytes;
      if (resposition >= buffersize) {
         std::cerr << "converttomulti: Fehler Buffer ist zu klein für den String" << std::endl;
std::cout << "converttomulti: Fehler Buffer ist zu klein für den String" << std::endl;
         return "";

      }

      position++;
   };
   wp[resposition] = 0;
   std::string result = wp.getCArray();

   return result;
#endif
}

#ifdef _WIN32

int getFileSize(CUtiString path)
{
	WIN32_FIND_DATA data;
	HANDLE h = FindFirstFile(path.c_str(), &data);

	if (h != INVALID_HANDLE_VALUE) {
		f_close1(h);
		return data.nFileSizeLow;


	}
	f_close1(h);

        return -1;

}

void ChangeDir(CUtiString str)
{

   int k = _wchdir(str.c_str());
}



const CUtiString getCurrentDir()
{

   wchar_t*c =  _tgetcwd(NULL, 0);
   CUtiString s =c;
   return s;
}


bool FindFirst(CUtiString path, Dir_FileInfo *fi)
{
	WIN32_FIND_DATA data;
	path += L"/*";
	HANDLE h = FindFirstFile(path.c_str(), &data);
	fi->Dir = NULL;
    fi->entity = NULL;
	if (h != INVALID_HANDLE_VALUE) {
		fi->Dir = h;
		fi->name = data.cFileName;
		fi->size = data.nFileSizeLow;
		fi->dir = (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0;
		return true;

	}
	return false;
};

bool FindNext(Dir_FileInfo*fi)
{
   HANDLE h = fi->Dir;
   WIN32_FIND_DATA data;
   if (!FindNextFile(h, &data)) return false;
   fi->name = data.cFileName;
   fi->size = data.nFileSizeLow;
   fi->dir = (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0;
   return true;

};

void FindClose(Dir_FileInfo*fi)
{
	f_close(fi);

};

void utisleep(int ms)
{
  Sleep(ms);
}

LPVOID UtiLoadLibrary(U_CHAR* name)
{
   return LoadLibrary(name);
}

void UtiFreeLibrary(LPVOID module)
{
   FreeLibrary((HMODULE)module);
}


#ifdef  WIN32
typedef BOOL (WINAPI *LPFN_SETPROCESSDPIAWARE)(void);
#endif

void setDPIAware()
{
#if defined(WIN32)
    LPFN_SETPROCESSDPIAWARE SetProcessDPIAware;

    SetProcessDPIAware = (LPFN_SETPROCESSDPIAWARE) GetProcAddress(GetModuleHandle(_T("user32")), "SetProcessDPIAware");
    if (NULL != SetProcessDPIAware) {
        SetProcessDPIAware();
}
#else

#endif

}

LPVOID UtiGetProcAddress(LPVOID module, char* name)
{

   return (LPVOID)GetProcAddress((HMODULE)module, name);
}
bool deleteFile(const CUtiString& path)
{
    std::string k = converttomulti(path.c_str());
    int status;
    status = remove(k.c_str());

    return (status == 0);
}

bool renameFile(const CUtiString& oldname, const CUtiString& newname)
{
    std::string oldk = converttomulti(oldname.c_str());
    std::string newk = converttomulti(newname.c_str());

    int status = rename(oldk.c_str(), newk.c_str());
    return (status == 0);
}

std::string exec(const char* cmd) {
    char buffer[128];
    std::string result = "";
    FILE* pipe = _popen(cmd, "r");
    if (!pipe) throw std::runtime_error("popen() failed!");
    try {
        while (!feof(pipe)) {
            if (fgets(buffer, 128, pipe) != NULL)
                result += buffer;
        }
    } catch (...) {
        _pclose(pipe);
        throw;
    }
    _pclose(pipe);
    return result;
}
#else

std::string exec(const char* cmd) {
    char buffer[128];
    std::string result = "";
    FILE* pipe = popen(cmd, "r");
    if (!pipe) return "";//throw std::runtime_error("popen() failed!");
    try {
        while (!feof(pipe)) {
            if (fgets(buffer, 128, pipe) != NULL)
                result += buffer;
        }
    } catch (...) {
        pclose(pipe);
        throw;
    }
    pclose(pipe);
    return result;
}

const CUtiString getCurrentDir()
{

   char*c =  getcwd(NULL, 0);
   CUtiString s = converttowide(c);
   return s;
}

void ChangeDir(CUtiString str)
{
   std::string k = converttomulti(str.c_str());
   chdir(k.c_str());
}

bool FindFirst(CUtiString path, Dir_FileInfo *fi)
{
   fi->Dir = NULL;
   fi->entity = NULL;
   DIR *dp;
   dirent *ep;
   dirent direntity;
   std::string k = converttomulti(path.c_str());
   dp = opendir (k.c_str());
    if (dp != NULL)
    {
            readdir_r(dp, &direntity, &ep);
	    if (!ep) {
	       closedir(dp);
	       return false;

	    };
        fi->dir = (ep->d_type & DT_DIR) != 0;
	    fi->Dir = dp;
	    fi->entity = ep;
	    fi->name = converttowide(ep->d_name);
	    fi->size = getFileSize(fi->name);
	    return true;
   } else {
      return false;
   }
};

int getFileSize(const CUtiString path)
{
        //wcout << "getFileSize: " << path.getString() << "\n";
        struct stat file;
    std::string k = converttomulti(path.c_str());
       // wcout << k <<endl;
        if(!stat(k.c_str(), &file))
        {
           return file.st_size;
        } else {
    //  cout<< k << endl;
	};

        return -1;
}

bool deleteFile(const CUtiString& path)
{
    std::string k = converttomulti(path.c_str());
    int status;
    status = remove(k.c_str());

    return (status == 0);
}

bool renameFile(const CUtiString& oldname, const CUtiString& newname)
{
    std::string oldk = converttomulti(oldname.c_str());
    std::string newk = converttomulti(newname.c_str());

    int status = rename(oldk.c_str(), newk.c_str());
    return (status == 0);
}

double getFileDate(CUtiString path, TFileDateType type)
{
   struct stat file;
   std::string k = converttomulti(path.c_str());
       // wcout << k <<endl;
   if(!stat(k.c_str(), &file))
   {
      if (type == dtAccess) {
         return file.st_atime;
      } else if (type == dtModification) {
         return file.st_mtime;
      } else {
         return file.st_ctime;
      };
   }
   return 0;
};



bool FindNext(Dir_FileInfo*fi)
{
   DIR *dp= (DIR*)fi->Dir;
   dirent *ep;
   dirent direntity;
   readdir_r(dp, &direntity, &ep);
   if(!ep)return false;

   fi->Dir = dp;
   fi->entity = ep;
   fi->name = converttowide(ep->d_name);
   fi->size = getFileSize(fi->name);
   fi->dir = (ep->d_type & DT_DIR) != 0;
   return true;

};

void FindClose(Dir_FileInfo*fi)
{
   DIR *dp= (DIR*)fi->Dir;
   if (dp) {
      closedir(dp);
   };
};



void utisleep(int ms)
{
//sleep(0);
timespec time;
time.tv_sec = ms / 1000;
time.tv_nsec = (ms%1000)*1000000;
  int res = nanosleep(&time, NULL);
  //utiassert(res == 0);
}

LPVOID UtiLoadLibrary(wchar_t* name)
{

   std::string s = converttomulti(name);
   //s = "lib"+s;
   //s += ".so";
   if (s == "/home/Staud/Programme/spacedata/ecool/game/libecool.0") {
    s = "/home/Staud/Programme/ecool/debug/src/.libs/libecool.0";

   }
   LPVOID m = dlopen(s.c_str(), RTLD_NOW);
  // LPVOID m = NULL;
   if (!m) {
      std::wcout << "Die Bibliothek " << name << " wurde nicht gefunden." << std::endl;

   }
   return m;
}

void UtiFreeLibrary(LPVOID module)
{
  // dlclose(module);
}

LPVOID UtiGetProcAddress(LPVOID module, char* name)
{
  LPVOID m = dlsym(module, name);
  //LPVOID m = NULL;
   if (!m) {
      std::wcout << "Die Funktion " << name << " wurde in der Bibliothek nicht gefunden" << std::endl;

   }
   return m;
}

#endif

};

#ifdef _WIN32

void f_close1(HANDLE h)
{
FindClose(h);
}
void f_close(UtiFramework::Dir_FileInfo*fi)
{

   HANDLE h = fi->Dir;
   FindClose(h);
};

#endif
