/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __ADVARRAY__
#define __ADVARRAY__

template <class T> class ArraySE
{
   protected:
      bool m_ownsdata;
   public:
      T* array;
      int array_start;
      int array_end;
      void swap(ArraySE<T>& a)
      {

        bool temp_stackvar = m_ownsdata;

        T* temp_array = array;
        int temp_array_start = array_start;
        int temp_array_end = array_end;
	m_ownsdata = a.m_ownsdata;
	array = a.array;
	array_start = a.array_start;
	array_end = a.array_end;

	a.m_ownsdata = temp_stackvar;
	a.array = temp_array;
	a.array_start = temp_array_start;
	a.array_end = temp_array_end;

      }
      bool getOwnData() const
      {
         return m_ownsdata;
      }
      inline int size() const
      {
          utiassert(array_start <= array_end);
         return array_end-array_start;
      }
      inline int start() const
      { utiassert(array_start <= array_end);
         return array_start;
      }
      inline int end() const
      { utiassert(array_start <= array_end);
          return array_end;
      }
	  T* getCArray()
	  {
          return array;
	  };
	  inline void reserveMemory()
	  { utiassert(array_start <= array_end);

	  if (array_end-array_start == 0) {
	   array = NULL;
	 } else {

         array = new T[array_end-array_start];
	// dynamic = true;
	 };

	  }
      inline ArraySE(int size)
      {
         m_ownsdata = true;
         array_start = 0;
         array_end = size;
         reserveMemory();
      }
      inline ArraySE(int start, int end)
      {
         m_ownsdata = true;
         array_start = start;
         array_end = end;
         reserveMemory();
      }
      inline ArraySE(T* ar, int size, bool ownsdata=false)
      {

         m_ownsdata = ownsdata;
        array_start = 0;
         array_end = size;
         array = ar;
      }
      inline ArraySE(T* ar, int start, int end, bool ownsdata=false)
      {

         m_ownsdata = ownsdata;
        array_start = start;
         array_end = end;
         array = ar;
      }

      inline ArraySE()
      {
         array_start = 0;
         array_end = 0;
         array = NULL;
         m_ownsdata = true;
      };
      inline void removeData()
      {
           if (m_ownsdata && array)
            delete [] array;

      }
      ~ArraySE()
      {
        removeData();

      }
      void init(T* ar, int size, bool ownsdata=false)
      {
         removeData();
        array = NULL;
         m_ownsdata = ownsdata;
         array_start = 0;
         array_end = size;
         array = ar;
      }
      void init(T* ar, int start, int end, bool ownsdata=false)
      {
         removeData();
        array = NULL;
         m_ownsdata = ownsdata;
         array_start = start;
         array_end = end;
         array = ar;
      }
      void setSize(int size) {
         //utiassert(array == NULL || dynamic == true);
          CHECKEXISTANCE;
          if (array_end == size && array_start == 0) return;
       removeData();
       m_ownsdata = true;
       array_start = 0;
         array_end = size;
	   reserveMemory();
      };
      void setRange(int start, int end) {
         //utiassert(array == NULL || dynamic == true);
          CHECKEXISTANCE;
          if (array_end == end && array_start == start) return;
       removeData();
       m_ownsdata = true;
       array_start = start;
         array_end = end;
	   reserveMemory();
      };

      inline T &operator[](unsigned int p)
      {
         utiassert((int)p >= array_start && (int)p < array_end);
         utiassert(array != NULL);
         return array[p-array_start];

      }
      inline const T &operator[](unsigned int p) const
      {
         utiassert((int)p >= array_start && (int)p < array_end);
         utiassert(array != NULL);
         return array[p-array_start];

      }
      inline const T &get(unsigned int p) const
      {
         utiassert((int)p >= array_start && (int)p < array_end);
         utiassert(array != NULL);
         return array[p-array_start];

      }
      inline void set(unsigned int p, const T& v) const
      {
         utiassert((int)p >= array_start && (int)p < array_end);
         utiassert(array != NULL);
         array[p-array_start] = v;

      }
      void fill(const T& value)
      {
	 CHECKEXISTANCE;
          for (int i = 0; i < array_end-array_start; i++) array[i] = value;
       }
};
#endif
