/*#include "algebra.h"
#include <set>

namespace Algebra {

bool getAllIdealsAbovePrime(NumberField* field, Number alpha, Number prime, std::vector<Ideal>& primesoverp, std::vector<Number>& primespower, std::vector<Number> & normsofprimes)
{

    uti_refptr<NumberRing> Zalpha(NumberRing::createNumberRingFromGenerator(alpha));
assert(Zalpha->isOrderIn(field));

    Polynom<Number> f = Zalpha->getMinimalPolynomial();
    uti_refptr<RingOfPolynomials> normalpolyring = Zalpha->getRingOfPolynomials();

    int p = prime.tryToConvertToInt();

    uti_refptr<FinitField> finitfield(new FinitField(p, 1));
    uti_refptr<RingOfPolynomials> modpring(new RingOfPolynomials(finitfield.get()));
    Polynom<Number> finfinitfield = modpring->lift(f);
    std::vector < Polynom<Number> > gfinit;
    std::vector<Integer> e_power;
    factorPolynom(finfinitfield, gfinit, e_power);

    std::vector < Polynom<Number> > g;
    std::vector < Polynom<Number> > q;
    std::vector < Polynom<Number> > r;
    std::vector < bool > inv;

    bool allinvertible = false;
    for (int tk = 0; tk < gfinit.size(); tk++) {
        Polynom<Number> gt = normalpolyring->lift(gfinit.at(tk));
        g.push_back(gt);
        Polynom<Number> rt;
        Polynom<Number> qt;
        f.division(gt, qt, rt);
        r.push_back(rt);
        q.push_back(qt);
        //moddiv_polynom(f, gt, rt, qt);
        bool invertible = true;
        if (e_power.at(tk) > 1) {
            bool ok = true;
            for (int ti = 0; ti < rt.getSize(); ti++) {
                Integer coeff = rt(ti);
                Integer mod;
                Integer res;
                uti_moddiv(coeff, p*p, mod, res);
                if (mod != 0) {
                    ok = false;
                }
            }
            if (ok) {
                invertible = false;
                allinvertible = false;
            }
        }
        inv.push_back(invertible);
        std::vector<Number> integralgenerators;
        integralgenerators.push_back(Number(p));
        integralgenerators.push_back(qt.eval(alpha));
        primesoverp.push_back(normalpolyring->createIdealFromGenerators(integralgenerators));
        normsofprimes.push_back(Number(intpow(p, gt.getDegree())));
        primespower.push_back(Number(e_power.at(tk)));
    }
    if (allinvertible) {

    }
    else {
        primesoverp.clear();
        return false;

    }
    return true;
}

bool Ideal::factor(std::vector<Ideal> m_ideal, std::vector<Number> &powers, std::vector<Number>& norms) const
{
std::vector<Number> primes;
getRationalPrimesOfGcdOfNm_Si(primes);
   Ideal currentideal = *this;
   for (int i = 0; i < primes.size(); i++) {
       std::vector<Ideal> primesoverp;
       std::vector<Number> normsofprimes;
       std::vector<Number> primespower;
       if (!getAllIdealsAbovePrime(m_data->m_owner.get(), welchesalpha, primes.at(i), primesoverp, primespower, normsofprimes))
       {
           return false;
       }

       for (int j = 0; j < primesoverp.size(); j++) {
           if (primesoverp.at(j).doesDivide(currentideal)) {
               m_ideal.push_back(primesoverp.at(j));
               norms.push_back(normsofprimes.at(j));
               powers.push_back(primespower.at(j));
               currentideal = currentideal / primesoverp.at(j);
           }
       }
   }
   return true;
}

bool isPrime(Integer value)
{
    Integer half = value/2+1;
    for (Integer i = 2; i <= half; i++) {
        if (i != value && (value % i == 0)) {
            return false;
        }
    }
    return true;
}

void getPrimesTillN(Integer n, std::vector<Integer>& values)
{
    for (Integer i = 2; i <= n; i++) {
        if (isPrime(i)) {
            values.push_back(i);
        }
    }
}

bool Ideal::isPrime()
{
    assert(true); // Wie läuft das prime und norm von generator prime
    //return isPrime(m_data->m_generators.size());
    return false;
}

bool Ideal::contains(Number value)
{

    assert(false);
    //Gröbner basis?
}

Number Ideal::getGcdOfNm_Si() const
{
     assert(m_data->m_generators.size() != 0);
     Number t = normANT(m_data->m_generators.at(0));

     for (size_t i = 1; i < m_data->m_generators.size();i++) {
         t = ggt(t, normANT(data->m_generators.at(i)));
     }

    return t;
}
void Ideal::getRationalPrimesOfGcdOfNm_Si(std::vector<Number>& primes) const
{

    Number n = getGcdOfNm_Si();
    //std::vector<Number> primes;
    std::vector<Number> powers;
    factorIntoRationalPrimes(n, primes, powers);
}

int Ideal::generatorCount() const
{
   return m_data->m_generators.size();
}

Number Ideal::getGenerator(int i) const
{
     return m_data->m_generators.at(i);
}

bool Ideal::doesDivide(Ideal otherideal)
{
   for (int i = 0; i < otherideal.m_data->m_generators.size(); i++) {
        Number si = otherideal.m_data->m_generators.at(i);
        if (contains(si)) {
            return false;
        }
    }
    return true;
}


Number ggt(const Number& a, const Number&b)
{
    if (b == Number(0)) {
        return a;
    }
    return ggT(b, a % b);
}

	uti_refptr<NumberRing> NumberRing::createNumberRingFromGenerator(Number number)
	{
		std::vector<Number> num;
		num.push_back(number);
		return createNumberRingFromGenerators(num);
	}


    NumberData::NumberData()
    {

    }

    void factorIntoRationalPrimes(Number num, std::vector<Number>& factors, std::vector < Number>& powers)
    {

    }

    void factorPolynom(Polynom<Number> & poly, std::vector< Polynom<Number> > & g, std::vector<Integer> & e_power)
    {

    }

    Number reduceValueWithMinimalPolynom(const Number& number, Polynom<Number>& minpoly)
    {
        assert(false);

    }

    UMat<Number> M_alpha(Number alpha, const std::vector<Number>& basis)
    {

        //Ist das Minimalpolynom immer eindeutig?
       Polynom<Number> minpoly =  alpha.getContainer()->getMinimalPolynom();
       //Polynom<Number> minpoly = alpha.getMinimalPolynomial();
       //int degree = minpoly.getDegree();
       int s = basis.size();
       UMat<Number> mat(0, s, s);

       for (int baseindex=0; baseindex < s; baseindex++) {
           Number b = basis.at(baseindex);
           b = b*alpha;

           reduceValueWithMinimalPolynom(b, minpoly);

           valueToBasis(b, basis, mat, baseindex);

       }

       mat = mat.transpose();

       return mat;
    }

    Number traceANT(Number num)
    {
        std::vector<Number> basis;
        num.m_data->m_container->getIntegralBasis(basis);
        UMat<Number> m = M_alpha(num, basis);
        return trace(m);

    }

    Number normANT(Number num)
    {
        std::vector<Number> basis;
        num.m_data->m_container->getIntegralBasis(basis);
        UMat<Number> m = M_alpha(num, basis);
        return determinant(m);

    }


    Number normIdeal(Ideal ideal)
    {
        Ring* r = ideal.getOwner();
        NumberRing* numberring = check_cast<NumberRing*>(r);
        assert(numberring->m_isringofintegersin.get() != NULL);
        NumberField* K = numberring->m_isringofintegersin.get();

        if (ideal.generatorCount() ==1) {
            std::vector<Number> integralbasis;
            numberring->getIntegralBasis(integralbasis);
            Number res = fabs(normANT(ideal.getGenerator(0)));
            return res;
        }

            std::vector<Ideal> factors;
            std::vector<Number> norms;
            //ideals.push_back();
            if (ideal.factor(factors, norms)) {
            Number res(1);
            for (int i = 0; i < factors.size(); i++) {
                res *= normIdeal(factors.at(i));
            }
            return res;
            }
            else {

            }



    }

    UMat<Number> tracePairing(std::vector<Number>& basis)
    {
        int d = basis.size();
        UMat<Number> pairing(d,d);

        for (int i = 0; i < d; i++) {
            for (int j = 0; j < d; j++) {
                Number t = traceANT(basis.at(i)*basis.at(j));
                pairing.set(i,j, t);
            }
        }
        return pairing;
    }

    Number discriminantOfBasis(std::vector<Number>& basis)
    {

        UMat<Number> tp;
        tp = tracePairing(basis);
        Number res = determinant(tp);
        return res;
    }


	Number NumberField::getIntegralElement() const
	{
		return m_integralelement;
	}


    Number Ring::getNorm_of_k_minus_alpha(Number k) const
    {
        return m_minimalpolynomial.eval(k);
    }


     void Ring::getIntegralBasis(std::vector<Number>& integralbasis) const
    {

    }

    void NumberField::getIntegralBasis(std::vector<Number>& integralbasis) const
    {

    }
    void NumberRing::getIntegralBasis(std::vector<Number>& integralbasis) const
    {

    }

	Number NumberField::getDiscriminantOfRingOfIntegers() const
	{
		if (isPowerBasis()) {
			Number n = getDiscriminantOfPolygon(m_minimalpolynomial);
			return n;

		}

		std::vector<Number> integralbasis;
		std::vector<Polynom<Number> > embeddings;

		getIntegralBasis(integralbasis);
		getEmbeddings(embeddings);
		int n = getNumberFieldDegree();
		assert(integralbasis.size() == n);
		assert(embeddings.size() == n);
		UMat<Number> matrix(n, n);

	
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				matrix.set(i, j, embeddings.at(i).eval(integralbasis.at(j)));
			}
		}
		//CULUDecomposition<Number> decompose(matrix);
		Number det = determinant(matrix);
		det = det*det;
		return det;
	}


	Number NumberRing::getDiscriminant()
	{
		std::vector<Number> integralbasis;
		getIntegralBasis(integralbasis);
		//Alternative via minimal polynom und formel (aber nur bei Power Basis)
		Number n = discriminantOfBasis(integralbasis);
		return n;
	}



    Polynom<Number> NumberRing::getMinimalPolynomial()
    {

        if (m_isringofintegersin.get()) {
            return m_isringofintegersin->getMinimalPolynomial();
        }
        assert(false);
        Polynom<Number> res;
        return res;
    }

    uti_refptr<RingOfPolynomials> NumberRing::getRingOfPolynomials() const
    {
        uti_refptr<RingOfPolynomials> poly(new RingOfPolynomials(const_cast<NumberRing*>(this)));

        return poly;
    }

    int NumberField::getNumberFieldDegree() const
    {
        return m_degree;

    }
    void NumberField::getEmbeddingsData(int& real, int & complex) const
    {
        std::vector<Number> conjugates;
        getConjugates(conjugates);
        int rcount=0;
        int ccount = 0;
        for (int i = 0; i < conjugates.size(); i++) {
            if (conjugates.at(i).isComplex()) {
                ccount++;
            } else {
                rcount++;
            }
        }
        assert((ccount %2) == 0);

        real = rcount;
        complex = ccount / 2;
    }

    double NumberField::getMinkowskiConstant() const
    {
        int r, s;
        int d = getNumberFieldDegree();
        getEmbeddingsData(r, s);
        double myk = pow(4/M_PI, double(s))*double(factorial(d))/pow(double(d), double(d))*sqrt(std::fabs(double(getDiscriminantOfRingOfIntegers())));
        return myk;
    }

    void NumberField::getGenerators_of_Ideal_Class_Group(std::vector<Ideal>& generators) const
    {
        //this is a not general, the ideal class is defined for every dedekind ring, the minkowski constant only exists for ring of integers

        double minkowski = getMinkowskiConstant();
        int maxprime = int(minkowski);
        std::vector<Integer> primenumbers;
        getPrimesTillN(maxprime, primenumbers);
        std::vector<Ideal> ideals;

        uti_refptr<Ring> ringofintegers = determineRingOfIntegers();

        Ideal idealring = ringofintegers->convertToIdeal(this);

        generator.push_back(idealring);
        if (primenumbers.size() == 1) {
            //trivial group, only one element but which?

            return;
        }

        struct SPotencialGenerator
        {
            Ideal m_ideal;
            Integer m_ei;
            Integer m_norm;
        };

        std::vector<SPotencialGenerator> potencialgenerators;

        for (int i = 0; i < primenumbers.size(); i++) {
            assert(isPrime(primenumbers.at(i)));
            Ideal newideal = ringofintegers->createIdealFromGenerators(Number(primenumbers.at(i)));
            std::vector<Ideal> factors;
            std::vector<Number> norms;
            std::vector<Number> degree;
            if (newideal.isIrreducible())
            {
                continue;
            }
            if (!getAllIdealsAbovePrime(m_data->m_owner.get(), welchesalpha, primenumbers.at(i), factors, degree, norms))
            {
                TODO_different_alpha_if_it_fails
                continue;
            }
            //newideal.factor(newideal, degree, norms);
            for (int idealindex=0; idealindex <factors.size(); idealindex++) {
                Ideal factorideal = factors.at(idealindex);

                if (newideal.isPrincipal(norms.at(idealindex))) {
                    SPotencialGenerator potencialgen;
                    potencialgen.m_ei = degree.at(idealindex).tryToConvertToInt();
                    potencialgen.m_norm = norms.at(idealindex);
                    potencialgen.m_ideal = factorideal;
                    potencialgenerators.push_back(potencialgen);

                 }
            }


        }
    }

    NumberField* Ideal::getContainedNumberField()
    {
        if (dynamic_cast<NumberField*>(m_data->m_owner.get()) != NULL) {
            return check_cast<NumberField*>(m_data->m_owner.get());
        } else if (dynamic_cast<NumberRing*>(m_data->m_owner.get()) != NULL){
            return check_cast<NumberRing*>(m_data->m_owner.get())->m_isringofintegersin.get();

        }
        return NULL;
    }

    bool Ideal::isPrincipal(Number mynorm) const
    {
        //Ideal is principal if there is an element a \in I such that |N(a)| = N(I)
        assert(mynorm == getNorm());

        //It must be a norm of
        NumberField* f = getContainedNumberField();
        assert(f != NULL);

        Integer intnorm = mynorm.tryToConvertToInt();
        int testvalue = 0;
        while (true)
        {
            Integer positivtest = f->getNorm_of_k_minus_alpha(Number(testvalue)).tryToConvertToInt();
            Integer negativtest = f->getNorm_of_k_minus_alpha(Number(-testvalue)).tryToConvertToInt();
            if (positivtest == intnorm)return true;
            if (negativtest == intnorm) return true;
            if (abs(positivtest) > abs(intnorm)*10) break; //Only approximation, better would be to test if it does to infinity (the polynom)

            if (abs(negativtest) > abs(intnorm)*10) break;
            testvalue++;
        }
        assert(false); // not all cases
        return false;
    }

    Number Ideal::getNorm() const
    {

        assert(false);
        Number res;
        return res;
    }



    void NumberField::getGenerators_of_Unit_Group(Number &firstgroup, std::vector<Number> &generators) const
    {
        int real;
        int complex;
        getEmbeddingsData(real, complex);

        //Roots of unity


        //Additional generators

        int additionalcount = real+complex-1;

        std::vector<Number> potentialgenerators;

        for (int i = -100; i < 100; i++) {
            int norm = getNorm_of_k_minus_alpha(Number(k)).tryToConvertToInt();
            if (norm == 1 || norm == -1) {
                Number gen;
                gen = Number(i)-m_integralelement;
                potentialgenerators.push_back(gen);
            }
        }
        //Also generate Ideals which have two generators and divide them

        //TODO: Check if the generators are equivalent

        //Do we have all generators
    }

    Ideal Ring::createIdealFromGenerators(std::vector<Number>& basis) const
    {

        Ideal id;
        id.m_data = new IdealData();
        id.m_data->m_owner = this;
        for (int i = 0; i < basis.size(); i++) {
            Number num = basis.at(i);
            assert(contains(num));

        id.m_data->m_generators.push_back(num);
        }
        assert(contains(Ideal));
        return id;
    }
    Ideal Ring::createIdealFromGenerators(Number number) const
    {
        std::vector<Number> basis;
        basis.push_back(number);
                createIdealFromGenerators(basis)
    }

	void createNumberFieldBase(const std::vector<Number>& generators, std::vector<Number>& simplebase)
	{
		std::vector<Number> powersofgenerators;
		for (int i = 0; i < generators.size(); i++) {
			Number base = generators.at(i);
			Number n = base;
			while (!n.isRational()){
				powersofgenerators.push_back(n);
				n *= base;
			}
		
		}
		std::set<Number> alreadyadded;
		simplebase.clear();
		int pcount = powersofgenerators.size();
		assert(powersofgenerators.size() < 24);
		int maxsteps = 1 << pcount;
		Number one(1.0);
		for (int i = 0; i < maxsteps; i++) {
			Number currentnumber = one;
			for (int j = 0; j < pcount; j++) {
				int mask = 1 << j;
				if ((i& mask) != 0) {
					currentnumber *= powersofgenerators.at(j);
				}

			}
			if (alreadyadded.find(currentnumber) == alreadyadded.end()) {
				simplebase.push_back(currentnumber);
			}
		}
	}

	UMat<Number> getKernel(const UMat<Number>& basis)
	{
		assert(false);
	}

	void valueToBasis(Number value, const std::vector<Number> &simplebase, UMat<Number>integralmatrix, int line)
	{
		//Decompose complex numbers
		assert(false);
	}

	bool isIntegralAndGetMinimalPolynomial(Number integralelement, const std::vector<Number> &simplebase, int d, Polynom<Number>& res)
	{
		assert(simplebase.size() == d);
		Number integralcurrent;
		integralcurrent = Number(1);
		UMat<Number>integralmatrix(d,d);

		for (int line = 0; line < d; line++) {
			valueToBasis(integralcurrent, simplebase, integralmatrix, line);
		}

		if (determinant(integralmatrix) == Number(0)) {
			return false;
		}

		UMat<Number> kernel = getKernel(integralmatrix);
		assert(kernel.sizey() != 0);
		assert(kernel.sizex() == d);
		res = Polynom<Number>(d);

		for (int i = 0; i < d; i++) {
			res.set(i, kernel.get(0, i));
		}

	}

	uti_refptr<NumberField> NumberField::createNumberFieldFromGenerators(const std::vector<Number>& numbers)
	{
		uti_refptr<NumberField> numberfield(new NumberField());

		int gencount = numbers.size();
		for (int i = 0; i < gencount; i++) {
			assert(numbers.at(i).isRational() == false);
		numberfield->m_originalgenerators.push_back(numbers.at(i));

		}
		std::vector<Number> simplebase;
		createNumberFieldBase(numbers, simplebase);


		numberfield->m_degree = simplebase.size();

		Array<int> integralcoefficients;
		integralcoefficients.setSize(numbers.size());
		Number integral1(0);
		for (int i = 0; i < gencount; i++) {
			integral1 += numbers.at(i);

		}
		numberfield->m_integralelement = integral1;
		while (!isIntegralAndGetMinimalPolynomial(numberfield->m_integralelement, simplebase, numberfield->m_degree, numberfield->m_minimalpolynomial)) {
		
			Number ires(0);

			for (int i = 0; i < gencount; i++) {
				ires += numbers.at(i)*Number(urandom(10) - 5);

			}
			numberfield->m_integralelement = ires;
		}

		return numberfield;
	}

	uti_refptr<Ring> NumberField::determineRingOfIntegers() const
	{
		uti_refptr<Ring> r(new Ring);
		Number alpha = getIntegralElement();

		std::vector<Number> allgenerators;
		std::vector<Number >localgenerators;

		allgenerators.push_back(alpha);

		Number disc_Ok = getDiscriminantOfRingOfIntegers();
		uti_refptr<NumberRing> ZalphaTemp(NumberRing::createNumberRingFromGenerator(alpha));

		Number n = ZalphaTemp->getDiscriminant();
		std::vector<Number> primes;
		std::vector<Number> powers;
		factorIntoRationalPrimes(n, primes, powers);
		Number currentalpha = alpha;
		for (int primeindex = 0; primeindex < primes.size(); primeindex++) {
			Number p_number = primes.at(primeindex);
			Integer p = p_number.tryToConvertToInt();
			
			localgenerators.clear();
			localgenerators.push_back(alpha);
			int localgenindex = 0;
			while (localgenindex < localgenerators.size()) {
				currentalpha = localgenerators.at(localgenindex);
				localgenindex++;

				uti_refptr<NumberRing> Zalpha(NumberRing::createNumberRingFromGenerator(currentalpha));

				Polynom<Number> f = Zalpha->getMinimalPolynomial();
				uti_refptr<RingOfPolynomials> normalpolyring = Zalpha->getRingOfPolynomials();

				uti_refptr<FinitField> finitfield(new FinitField(p, 1));
				uti_refptr<RingOfPolynomials> modpring(new RingOfPolynomials(finitfield.get()));
				Polynom<Number> finfinitfield = modpring->lift(f);
				std::vector < Polynom<Number> > gfinit;
				std::vector<Integer> e_power;
				factorPolynom(finfinitfield, gfinit, e_power);

				std::vector < Polynom<Number> > g;
				std::vector < Polynom<Number> > q;
				std::vector < Polynom<Number> > r;
				std::vector < bool > inv;

				bool allinvertible = false;
				for (int p = 0; p < gfinit.size(); p++) {
					Polynom<Number> gt = normalpolyring->lift(gfinit.at(p));
					g.push_back(gt);
					Polynom<Number> rt;
					Polynom<Number> qt;
					f.division(gt, qt, rt);

                    r.push_back(rt);
                    q.push_back(qt);
					//moddiv_polynom(f, gt, rt, qt);
					bool invertible = true;
					if (e_power.at(p) > 1) {
						bool ok = true;
						for (int ti = 0; ti < rt.getSize(); ti++) {
							Integer coeff = rt(ti);
							Integer mod;
							Integer res;
							uti_moddiv(coeff, p*p, mod, res);
							if (mod != 0) {
								ok = false;
							}
						}
						if (ok) {
							invertible = false;
							allinvertible = false;
						}
					}
					inv.push_back(invertible);
				}
				if (allinvertible) {
					//prime does not divide the index [OK: Z[alpha]];
				}
				else {
					for (int p = 0; p < gfinit.size(); p++) {
						if (inv.at(p)) continue;
						Number betai = q.at(p).eval(alpha);
						betai = betai / p_number;
						allgenerators.push_back(betai);
						localgenerators.push_back(betai);

						//betai \in O_K\Z[alpha]
					}
				}
			}
		}
        uti_refptr<NumberRing> resring(NumberRing::createNumberRingFromGenerators(allgenerators));
        resring->m_isringofintegersin = const_cast<NumberField*>(this);
        return uti_refptr<Ring>(resring.get());
	}
    Number fabs(const Number& number)
    {
        Number res = number.getContainer()->abs(number);
        return res;
    }

}*/
