/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ANALYSIS_H
#define ANALYSIS_H
//#define DGL
#ifdef DGL

namespace DGL
{

struct Real
{
   int operator+(const Real&x) const{

   }

   int operator+(int v1) const{

   }
   int operator*(int v1) const{

   }
   int operator<=(int v1) const{

   }
   int operator<=(Real x) const{

   }
};

struct RealPositiv :public Real
{

};

struct NaturalNumber
{

};

struct IntegerNumber
{

};

template<class Input, class Output> struct function
{
    int operator()() {

};
    template<class T1> int operator()(T1 param1) {

};
    template<class T1, class T2> int operator()(T1 param1, T2 param2) {

};

    template <typename T> operator T () {};
};

template<class Var1, class Var2> struct times
{

};

struct TSet
{
   typedef int Element;
};

template<class BaseSet> struct TMetric
{
    //d(x,y) >= 0
    //d(x,y)=0 <=> x = y
    //d(x,y) = d(y,x)
    //d(x,z) <= d(x,y) + d(y,z)
    typedef BaseSet Set;
    function< times< BaseSet, BaseSet>, RealPositiv > m_function;

};

struct TMetricSpace //nur interface nach außen
{
    typedef TSet BaseSet;
    TMetric<BaseSet> metric;

};

template<class BaseSet> struct TNorm
{
    //||x|| = 0 <=> x = 0 (Definitheit)
    //||lambda*x|| = |lambda|*||x||
    //||x+y||<=||x||+||y||

    typedef BaseSet Set;
    function< BaseSet, RealPositiv > m_function;

};

struct TNormedSpace // : public TMetricSpace
{
    typedef TSet BaseSet;
    TNorm<BaseSet> norm;

    TMetricSpace toMetric()
    {
        return TMetricSpace();
    }
};

template<class T> void forall(T var)
{

}


template<class T> void exists(T var)
{

}

void itFollows()
{

}

template<class T> void itHolds(T logic)
{

}

template<class Type, int factor> struct pow {

};

RealPositiv def_lipschitz_continuity(TMetricSpace inputmetric, TMetricSpace outputmetric, function<TMetricSpace::BaseSet, TMetricSpace::BaseSet> f)
{
    typename TMetricSpace::BaseSet::Element x1, x2;
    forall(x1);
    forall(x2);
    RealPositiv L;
    exists(L);
    itHolds(outputmetric.metric.m_function(f(x1), f(x2)) <= L*inputmetric.metric.m_function(x1, x2));
}

template<class Variable, class Set> int isIn(Variable V, Set S)
{

}

template<class Variable1, class Variable2> int makeTupel(Variable1 V1, Variable2 V2)
{

}

template<class Var1, class Var2> int realInterval(Var1 t1, Var2 t2)
{

}

template<class InputSet, class Cond1> int restrictSet(InputSet s, Cond1 c1)
{

}

template<class InputSet, class Cond1, class Cond2> int restrictSet(InputSet s, Cond1 c1, Cond2 c2)
{

}

//Use it to test the structure of a set
template<class Set1, class Set2> int unifySet(Set1 s1, Set2 s2)
{

}

int _1()
{

}

int _2()
{

}

int _3()
{

}

void def_continuesOn(TMetricSpace space, function< Input, Output > f, TSet R)
{
    assert(space.BaseSet.contains(R));
    R::Element x0, x;
    RealPositiv epsilon, delta;
    forall(x0);
    forall(epsilon);
    exists(delta);

    forall(x, space.metric.m_function(x, x0) < delta);

    itHolds(space.metric.m_function(f(x0), f(x)) < epsilon);

}

struct TSequence
{
    //(x_n) n \n \mathbf{N}
   template<class T> int operator()(T n){

   }
};

int def_cauchy_sequence(TMetricSpace space, TSequence x)
{
    RealPositiv epsilon;
    forall(epsilon);
    NaturalNumber N;
    exists(N);
    NaturalNumber n,m;
    forall(n, n >= N);
    exists(m, m >= N);

    itHolds(space.metric.m_function(x(n), x(m)) < epsilon);
}

int def_limit_to(TMetricSpace space, TSequence x, typename TMetricSpace::BaseSet::Element limit)
{
    RealPositiv epsilon;
    forall(epsilon);
    NaturalNumber N;
    exists(N);
    NaturalNumber n;
    forall(n, n >= N);
    itHolds(space.metric.m_function(x(n), limit) < epsilon);
}

int def_has_limit(TMetricSpace space, TSequence x, )
{
    TMetricSpace::BaseSet::Element mylimit;
    exists(mylimit);
    def_limit_to(space, x, mylimit);
}

int def_completeMetricSpace(TMetricSpace space)
{
    TSequence f;
    def_cauchy_sequence(space, f);
    forall(f);
    itHolds(def_has_limit(space, f));
}

int def_banach_raum(TNormedSpace space)
{
   itHolds(def_completeMetricSpace(space.toMetric()));

}

int theorem_picardLindelof(TNormedSpace space, function< times<Real, TNormedSpace::BaseSet >, TNormedSpace::BaseSet > f, TSet R)
{
    def_continousOn(TRealMetricSpacetimes<Real, TNormedSpace::BaseSet >(), f, R);

    Real t0,t,a;
    TNormedSpace::BaseSet::Element y0,y,b;
    unifySet(R, restrictSet(makeTupel(t,y),isIn(t, realInterval(t0,t0+a)), space.norm.m_function(y-y0) <= b));

    Real time;
    forall(time);
    def_lipschitz_continuity(space.toMetric(), space.toMetric(),  f(time, _1()));

    itFollows();

    M = norm_l_infinity(f);
    alpha = min(a, b/M);

    existsSolutionOn(realInterval(t0, t0+alpha));
}

}

#endif

#endif // ANALYSIS_H
