#ifndef __INTEGRATION__
#define __INTEGRATION__

#include "matrices.h"

const double GAUSS_LIMIT=0.01f;

template<class T, class Func> T gaussQuadratur(const T& a, const T& b,const Func& f, int n, const T& limit=T(GAUSS_LIMIT))
{
  T sum(0);
  UMat<T> xvalue=((T(2)*UMat<T>::steps(T(1),T(1),n)-T(1))/T((2*n))*T(M_PI));
  UMat<T> weight(T(M_PI)/T(n), 1,n);
  weight = weight*sqrt(T(1)- pow(xvalue, T(2)));
  UMat<T> yvalues = f(xvalue)*weight;
  return sum(yvalues);
}


#endif
