#define _USE_MATH_DEFINES
#include "interpolations.h"

void uti_interpolation_dummy_symbol()
{

}


void createBlurArray(Array<float>& blur, float sigma, int &center)
{
    //float sigma = m_strength;
    if (sigma < 0.01) {
        int k = 0;
        center = k;
        blur.setSize(2*k+1);
        blur[0] = 1.0f;
        return;

    }

    int k = umax(1,(int)(sigma*1.5f));
    center = k;
    blur.setSize(2*k+1);
    float mul = 1.0f/(sqrt(2*M_PI)*sigma);
    float expmul = -1.0f / (2*sigma*sigma);
    for (int i = 0; i <= k; i++) {
        float value = mul*expf(expmul*(float)(i*i));
        blur[k-i] = value;
        blur[k+i] = value;
    }
    float sum = 0.0f;
    for (int i = 0; i < blur.size(); i++) {
        sum += blur[i];

    }
    sum = 1.0f/sum;
    for (int i = 0; i < blur.size(); i++) {
        blur[i]= blur[i]*sum;

    }
}

void createBlurStepArray(Array<float>& blur, float sigma,int k, int &center)
{
    //float sigma = m_strength;
    if (sigma < 0.01) {
        center = k;
        blur.setSize(2*k+1);
        blur[0] = 1.0f;
        return;

    }
    center = k;
    blur.setSize(2*k+1);
    float mul = 1.0f/(sqrt(2*M_PI)*sigma);
    float expmul = -1.0f / (2*sigma*sigma);
    for (int i = 0; i <= k; i++) {
        float value = mul*expf(expmul*(float)(i*i));
        blur[k-i] = value;
        blur[k+i] = value;
    }
    float sum = 0.0f;
    for (int i = 0; i < blur.size(); i++) {
        sum += blur[i];

    }
    sum = 1.0f/sum;
    for (int i = 0; i < blur.size(); i++) {
        blur[i]= blur[i]*sum;

    }
}
