/***************************************************************************
 *   Copyright (C) 2007 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __MATHINTEGER__
#define __MATHINTEGER__

template<class T, int digits, unsigned long maxsize> struct CBigInteger
{
  protected:
     T m_number[digits];
  public:
     CBigInteger()
     {
        for (int i = 0; i < digits; i++) {
            m_number[i] = 0;
        }
     }
     CBigInteger(bool f)
     {

     }
     CBigInteger(long value)
     {
        *this = value;
     }

     inline CBigInteger& operator=(long l)
     {
         for (int i = 0; i < digits; i++) {
            m_number[i] = l % maxsize;
            l = l / maxsize;
        }

         return this;
     }

     inline CBigInteger operator+(const CBigInteger& other) const
     {
         CBigInteger result(true);
         T uebertrag = 0;
         for (int i = 0; i < digits; i++) {
             T newnumber = m_number[i]+other.m_number[i]+uebertrag;
             if (newnumber > maxsize) {
                newnumber -= maxsize;
                uebertrag = 0;
             } else {
                 uebertrag = 0;
             }
             result.number[i] = newnumber;
        }
        return result;

     }

};


#endif
