#include "structures.h"

UtiPredicateLogic::UtiPredicateLogic()
{
  m_type = ltNone;
}

bool UtiPredicateLogic::canUnify(UtiPredicateLogic logic)
{
   return false;
}

bool UtiPredicateLogic::unify(UtiPredicateLogic logic)
{
   return false;
}

void UtiPredicateLogic::mustUnify(UtiPredicateLogic logic)
{

}

STRUCTURENAME UtiPredicateLogic::getName()
{
  utiassert(m_type == ltPredicate);
  return ((UtiPredicateIntern*)m_object.get())->m_name;
}

UtiPredicateLogic UtiPredicateLogic::getPredicate(int i)
{
  utiassert(m_type == ltPredicate);
   UtiPredicateLogic l = ((UtiPredicateIntern*)m_object.get())->m_children[i];
   while (l.isBoundVar()) {
     l = ((UtiVariableIntern*)l.m_object.get())->m_target;
   };
   return l;
}

TLogicType UtiPredicateLogic::getType()
{
return m_type;
}

bool UtiPredicateLogic::isBool()
{
return m_type == ltBool;
}

bool UtiPredicateLogic::isBoundVar()
{
 return m_type == ltVariable && ((UtiVariableIntern*)m_object.get())->m_target.getType() != ltNone;
}


bool UtiPredicateLogic::isUnBoundVar()
{
return m_type == ltVariable && ((UtiVariableIntern*)m_object.get())->m_target.getType() == ltNone;
}

bool UtiPredicateLogic::isFloat()
{
  return m_type == ltFloat;
  
}


bool UtiPredicateLogic::isInt()
{
return m_type == ltInt;
}

bool UtiPredicateLogic::isPredicate()
{
return m_type == ltPredicate;
}

bool UtiPredicateLogic::isReferenceUtiOB()
{
return m_type == ltReferenceUtiOB;
}

bool UtiPredicateLogic::isString()
{
   return m_type ==ltString;
}



UtiPredicateLogic ulint(int value)
{
 UtiPredicateLogic l;
 l.m_type = ltInt;
 UtiIntIntern* i = new UtiIntIntern();
 i->m_value = value;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulfloat(double value)
{
 UtiPredicateLogic l;
 l.m_type = ltFloat;
 UtiFloatIntern* i = new UtiFloatIntern();
 i->m_value = value;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulstring(const CUtiString& str)
{
  UtiPredicateLogic l;
 l.m_type = ltString;
 UtiStringIntern* i = new UtiStringIntern();
 i->m_value = str;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulbool(bool b)
{
 UtiPredicateLogic l;
 l.m_type = ltBool;
 UtiBoolIntern* i = new UtiBoolIntern();
 i->m_value = b;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulvar()
{
 UtiPredicateLogic l;
 l.m_type = ltVariable;
 UtiVariableIntern* i = new UtiVariableIntern();

 l.m_object = i;
 return l;
}
UtiPredicateLogic ulrefobj(ReferenceUtiOB* obj)
{
  UtiPredicateLogic l;
 l.m_type = ltReferenceUtiOB;


 l.m_object =obj;
 return l;
}
UtiPredicateLogic ulpredicate(int name)
{
  UtiPredicateLogic l;
 l.m_type = ltPredicate;
 UtiPredicateIntern* i = new UtiPredicateIntern();
 i->m_name = name;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulpredicate(int name, UtiPredicateLogic param1)
{
  UtiPredicateLogic l;
 l.m_type = ltPredicate;
 UtiPredicateIntern* i = new UtiPredicateIntern();
 i->m_name = name;
 i->m_children.setSize(1);
 i->m_children[0] = param1;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulpredicate(int name, UtiPredicateLogic param1, UtiPredicateLogic param2)
{
  UtiPredicateLogic l;
 l.m_type = ltPredicate;
 UtiPredicateIntern* i = new UtiPredicateIntern();
 i->m_name = name;
 i->m_children.setSize(2);
 i->m_children[0] = param1;
 i->m_children[1] = param2;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulpredicate(int name, UtiPredicateLogic param1, UtiPredicateLogic param2, UtiPredicateLogic param3)
{
  UtiPredicateLogic l;
 l.m_type = ltPredicate;
 UtiPredicateIntern* i = new UtiPredicateIntern();
 i->m_name = name;
 i->m_children.setSize(3);
 i->m_children[0] = param1;
 i->m_children[1] = param2;
 i->m_children[2] = param3;
 l.m_object = i;
 return l;
}
UtiPredicateLogic ulpredicate(int name, UtiPredicateLogic param1, UtiPredicateLogic param2, UtiPredicateLogic param3, UtiPredicateLogic param4)
{
  UtiPredicateLogic l;
 l.m_type = ltPredicate;
 UtiPredicateIntern* i = new UtiPredicateIntern();
 i->m_name = name;
 i->m_children.setSize(4);
 i->m_children[0] = param1;
 i->m_children[1] = param2;
 i->m_children[2] = param3;
 i->m_children[3] = param3;
 l.m_object = i;
 return l;
}








