% Libaries

% Stack
stack_empty([]).
stack_pop(Element, [Element|Es],Es).
stack_push(Element, Es, [Element|Es]).
stack_top(Element, [Element|Es]).

% Assoziative Map

map_empty(nil).
map_contains(K, t(X,Y,L, R)) :- %write(map_contains(K, t(X,Y,L, R))), nl,
   map_lookup(K, t(X,Y,L,R), V).

map_update(Key, Value, Map0, Map) :- %write(map_update(Key, Value, Map0, Map)), nl,
   (map_contains(Key, Map0),!,%write(map_remove(Key, Map0, MapA, OldValue)), nl,
    map_remove(Key, Map0, MapA, OldValue),%write(map_insert(Key, Value, MapA, Map)), nl,
    map_insert(Key, Value, MapA, Map)
    ; %write(map_insert(Key, Value, Map0, Map)), nl,
    map_insert(Key, Value, Map0, Map)
    ).

map_lookup(K, t(X,Y,L,R), V) :- %write(map_lookup(K, t(X,Y,L,R), V)), nl,
   nonvar(X), nonvar(Y),
   (K == X, !,  V = Y
   ; K @< X, !, map_lookup(K, L, V)
   ; map_lookup(K, R, V),!
   ).

map_remove(K, t(X,Y,L0,R), t(X,Y,L,R), V) :- K @< X, !, map_remove(K,L0,L,V).
map_remove(K, t(X,Y,L,R0), t(X,Y,L,R), V) :- K @> X, !, map_remove(K,R0,R,V).
map_remove(K, t(X,V,L,R), T, V) :- K == X,
   (L == nil, !, T = R
   ; R == nil, !, T = L
   ; rm_max(L,L1,K1,V1), T = t(K1,V1,L1,R), !
   ).
rm_max(t(K,V,L,nil), L, K, V) :- !.
rm_max(t(X,Y,L,R0), t(X,Y,L,R), K, V) :- rm_max(R0,R,K,V).

map_insert(K, V, nil, t(K,V,nil,nil)) :- !.
map_insert(K, V, t(X,Y,L0,R), t(X,Y,L,R)) :- K @< X, !, map_insert(K,V,L0,L).
map_insert(K, V, t(X,Y,L,R0), t(X,Y,L,R)) :- K @> X, !, map_insert(K,V,R0,R).


map_insertlist([element(Key, Value)|R], InputMap, OutputMap) :-
   map_insert(Key, Value, InputMap, Out),
   map_insertlist(R, Out, OutputMap).


map_insertlist([], InputMap, InputMap).

map_iterate(t(X,Y,L,R), K, V) :-
    map_iterate(L,K,V) ;
    (X=K, Y=V) ;
    map_iterate(R,K,V).

map_size(nil, 0):- !.
map_size(t(_,_,L,R), N) :-
   map_size(L,NL),
   map_size(R,NR),
   N is NL+NR+1, !.

% start


:- dynamic(/('asm_declparam', 2)).
:- dynamic(/('asm_setvariable', 3)).
:- dynamic(/('asm_init', 2)).
:- dynamic(/('asm_add', 4)).
:- dynamic(/('asm_sub', 4)).
:- dynamic(/('asm_mul', 4)).
:- dynamic(/('asm_div', 4)).
:- dynamic(/('asm_less', 4)).
:- dynamic(/('asm_greater', 4)).
:- dynamic(/('asm_equal', 4)).
:- dynamic(/('asm_eless', 4)).
:- dynamic(/('asm_egreater', 4)).
:- dynamic(/('asm_logicalor', 4)).
:- dynamic(/('asm_logicaland', 4)).
:- dynamic(/('asm_copyobject', 3)).
:- dynamic(/('asm_conditionaljump', 3)).
:- dynamic(/('asm_pddleffect', 2)).
:- dynamic(/('asm_jump', 2)).
:- dynamic(/('asm_wait', 2)).
:- dynamic(/('asm_end', 1)).
:- dynamic(/('asm_beginBlock', 1)).
:- dynamic(/('asm_endBlock', 1)).
:- dynamic(/('asm_procedure_start', 2)).
:- dynamic(/('asm_return', 2)).
:- dynamic(/('asm_exists', 3)).
:- dynamic(/('asm_emptyfluent', 3)).
:- dynamic(/('asm_procedure_call', 4)).
:- dynamic(/('asm_tofloat', 3)).
:- dynamic(/('asm_assert', 2)).
:- dynamic(/('asm_pddleffect', 2)).
:- dynamic(/('asm_pddlnoteffect', 2)).
:- dynamic(/('asm_noop', 1)).
:- dynamic(/('asm_newline', 1)).


%asm_declparam(0,p1).
%asm_setvariable(1,var1, 5).
%asm_add(2, vvarf(p1), vvarf(p1), vvarf(var1)).
%asm_less(3, vvarf(b1), vvarf(p1), vconst(10)).
%asm_conditionaljump(4, 7, b1).
%asm_pddleffect(5, [tFuelData, high]).
%asm_jump(6,8).
%asm_pddleffect(7,[tFuelData, low]).
%asm_end(8).
%asm_beginBlock(9).
%asm_endBlock(10).
%asm_procedure_start(11, listParamVariables).
%asm_return(12, listReturnValues).
%asm_procedure_call(13, 14,listParamValues, listReturnTargetVariables).
%asm_tofloat(14, R, T).
%asm_less(15, vvarf(b1), vvarf(p1), vvarf(p2)).
%variablen immer gross!

%Environment
%var content: vint(5), vbool(5), vfloat(5), vstring("blabla"), vvarf(name), vvari(name), vvarb(name)
%wir brauchen stack, local and global variables+ return value->konnen wir das anders machen
%env(framestack, currentframe globalvars(map), additionaldata)
%frame(oldpc, listparamvalues, listreturntargetvariables, variablemap)

createVar(env(Framestack, CurrentFrame, G, A), env(Framestack, NewFrame, G, A), Name, Value) :-
    map_insert(Name, Value, CurrentFrame, NewFrame).

setNewPLState(env(Framestack, CurrentFrame, G, plstate(OldState)), NewState, env(Framestack, CurrentFrame, G, plstate(NewState))).
getPLState(env(Framestack, CurrentFrame, G, plstate(OldState)), OldState).

set(env(Framestack, CurrentFrame, G, A), env(Framestack, NewFrame, G, A), Name, Value) :- % write(set(env(Framestack, CurrentFrame, G, A), env(Framestack, NewFrame, G, A), Name, Value)), nl,
    map_update(Name, Value, CurrentFrame, NewFrame).
get(env(Framestack, CurrentFrame, G, A), Name, Value) :-
    ( map_lookup(Name, CurrentFrame, Value), !;map_lookup(Name, G, Value)).
%pushStack(Env, NewEnv). % doch verwenden fur beginblock, spezielles Stackelement fur Prozedure, sodass variablen suche korrekt verlauft
%popStack(Env, NewEnv).
% Todo: setze parameterwerte
pushFrame(env(Framestack, CurrentFrame, G, A), env(NewFramestack, NewFrame, G, A), OldPC, ListParamValues, ListReturnTargetVariables)
  :- stack_push(frame(OldPC, ListParamValues, ListReturnTargetVariables, CurrentFrame), Framestack, NewFramestack),
     map_empty(NewFrame).
   %  paramsToVariables(ListParamValues, NewFrameA, NewFrame).

paramsToVariables([], NewFrameA, NewFrameA).
paramsToVariables([param(Name, Value)|R], OldFrame, NewFrame)
   :- map_insert(Name, Value, OldFrame, NewFrameA),
      paramsToVariables(R, NewFrameA, NewFrame).

% doch verwenden fur beginblock, spezielles Stackelement fur Prozedure, sodass variablen suche korrekt verlauft
popFrame(env(Framestack, CurrentFrame, G, A), ListReturnVars, env(NewFramestack, NewFrame, G, A), OldPC) :-
    stack_pop(frame(OldPC, LPV, ListReturnVars, NewFrame), Framestack, NewFramestack).
   % copyVarListToFrame(ListReturnTargetVariables, ListReturnVars, CurrentFrame, NewFrameA, NewFrame).

%copyVarListToFrame(TargetVars, SourceVar, FunctionFrame, OldFrame, NewFrame).
copyVarListToFrame([], [], _, OldFrame, NewFrame).
copyVarListToFrame([TargetVar|TR], [SourceVar|SR], FF, OldFrame, NewFrame) :-
   map_lookup(SourceVar, FF, Value),
   map_update(TargetVar, Value, OldFrame, NewFrameA),
   copyVarListToFrame(TR, SR, FF, NewFrameA, NewFrame).

%currentParamVars(Env, ListParamValues).
%currentReturnData(Env, ListReturnVars, OldPC).
freeIPDDLVar(Name).
freeFPDDLVar(Name).
freeBPDDLVar(Name).
resolveVarsList([Name|TR], Env, [Name|SR]) :-
   resolveVars(TR, Env, SR).
resolveVars([], Env, []).
resolveVars([VarName|TR], Env, [Value|SR]) :-
   get(Env, VarName, Value),
   resolveVars(TR, Env, SR).
%outputPDDLNum(List).
%outputPDDLBool(List).
%outputEffect(List).
%pathBegin(BoolVariable, ResultCode).
%pathElse(ResultCode).

:- foreign(/(outputPDDLNum, 2), pl_foreign_outputPDDLNum, pddllib).
:- foreign(/(outputPDDLBool, 2), pl_foreign_outputPDDLBool, pddllib).
:- foreign(/(outputPDDLExists,2), pl_foreign_outputPDDLExists, pddllib).
:- foreign(/(outputPDDLAssert,2), pl_foreign_outputPDDLAssert, pddllib).
:- foreign(/(outputEffect, 2), pl_foreign_outputEffect, pddllib).
:- foreign(/(outputNotEffect, 2), pl_foreign_outputNotEffect, pddllib).
:- foreign(/(pathWait, 1), pl_foreign_pathWait, pddllib).
:- foreign(/(pathBegin, 2), pl_foreign_pathBegin, pddllib).
:- foreign(/(pathElse, 1), pl_foreign_pathElse, pddllib).
:- foreign(/(pathEnd, 1), pl_foreign_pathEnd, pddllib).
:- foreign(/(createPDDLEmptyFluent,2), pl_foreign_createPDDLEmptyFluent, pddllib).

%performoperation(Result, Var1, Op, Var2)

%procedure call: wir haben parameter, die von vorherigen Stackraum hochtransportiert werden
%asm_procedure_call(PC,ListParamValues, ListReturnTargetVariables)
%asm_procedure_start(PC, ListParamVariables)
%asm_return(PC, ListReturnValues)
%wir mussen also in einem procedure frame speichern:
% - OldPC+1,
% - ListParamValues, ListReturnTargetVariables
% - flag, dass es frame ist

assignVars(Env, [Var|RestVar], [Value|RestValue], NewEnv)
    :- createVar(Env, Env2, Var, Value),
       assignVars(Env2, RestVar, RestValue, NewEnv).
assignVars(Env, [], [], Env) :- true.

updateVars(Env, [Var|RestVar], [Value|RestValue], NewEnv)
    :- set(Env, Env2, Var, Value),
       updateVars(Env2, RestVar, RestValue, NewEnv).
updateVars(Env, [], [], Env) :- true.


%executecode(PC, Env) :- asm_beginBlock(PC), pushStack(Env, NewEnv), executecode(PC+1, NewEnv).
%executecode(PC, Env) :- asm_endBlock(PC), popStack(Env, NewEnv), executecode(PC+1, NewEnv).

startprogram :- executecode(0, 0).

executecode(PC, Env) :- asm_init(PC, GlobalVars), write('Command: '),  write(asm_init(PC, GlobalVars)), write(Env), nl,
                        map_empty(G1), map_insertlist(GlobalVars, G1, GlobalVarsMap),
                        stack_empty(Framestack),
                        map_empty(CurrentFrame),
                        PC1 is PC+1, write('Next Command: '), write(PC1),nl,
                        executecode(PC1, env(Framestack, CurrentFrame, GlobalVarsMap, plstate(start))).

%executecode(PC, Env) :- asm_procedure_start(PC, ParamVariables),
                        %currentParamVars(Env, ListParamValues),
                        %assignVars(Env, ParamVariables, ListParamValues, NewEnv),
%                        PC1 is PC+1,
%                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_return(PC, ListReturnVars), write(asm_return(PC, ListReturnVars)),write(Env),nl,
                        %currentReturnData(Env, ListReturnValues, OldPC),% write(varToValues(Env, ListReturnVars, ListReturnValues)), nl,
                        varToValues(Env, ListReturnVars, ListReturnValues),%write(popFrame(Env,ListReturnTargetVars,  Env2, OldPC)), nl,
                        popFrame(Env,ListReturnTargetVars,  Env2, OldPC),%write( updateVars(Env2, ListReturnTargetVars, ListReturnValues, NewEnv)), nl,
                        updateVars(Env2, ListReturnTargetVars, ListReturnValues, NewEnv),%write(NewEnv), nl,
                        PC1 is OldPC+1,%write(PC1), nl,
                        executecode(PC1, NewEnv)
                        .

varToValues(Env, [Var|RestVar], [Value|RestValue])
    :- %write(varToValues(Env, [Var|RestVar], [Value|RestValue])),nl,
       get(Env, Var, Value),
       varToValues(Env, RestVar, RestValue).
varToValues(Env, [], []) :- true.


executecode(PC, Env) :- asm_procedure_call(PC, NewPC, ListParamVars, ListReturnTargetVariables), write(asm_procedure_call(PC, NewPC, ListParamVars, ListReturnTargetVariables)),write(Env),nl,
                        varToValues(Env, ListParamVars, ListParamValues),% write(varToValues(Env, ListParamVars, ListParamValues)),nl,
                        pushFrame(Env, Env2, PC, ListParamValues, ListReturnTargetVariables),%write(pushFrame(Env, Env2, PC, ListParamValues,ListReturnTargetVariables)),nl,
                        asm_procedure_start(NewPC, ParamVariables), write(asm_procedure_start(NewPC, ParamVariables)),write(Env2),nl,
                        assignVars(Env2, ParamVariables, ListParamValues, NewEnv),
                        PC1 is NewPC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_end(PC), write(asm_end(PC)),write(Env),nl, write('-------------Next Path'),nl,  fail.

executecode(PC, Env) :- asm_declparam(PC, VarName),  write(asm_declparam(PC, VarName)),write(Env),nl,
                        createVar(Env, NewEnv, VarName, vvara(VarName)),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).
executecode(PC, Env) :- asm_setvariable(PC, VarName, Value), write(asm_setvariable(PC, VarName, Value)),write(Env),nl,
                        set(Env, NewEnv, VarName, Value),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_noop(PC), write(asm_noop(PC)),write(Env),nl,
                        PC1 is PC+1,
                        executecode(PC1, Env).


executecode(PC, Env) :- asm_newline(PC), write(asm_newline(PC)),write(Env),nl,
                        PC1 is PC+1,
                        executecode(PC1, Env).

executecode(PC, Env) :- asm_copyobject(PC, TargetVar, SourceVar), write(asm_copyobject(PC, TargetVar, SourceVar)),write(Env),nl,
                        get(Env, SourceVar, Value),
                        set(Env, NewEnv, TargetVar, Value),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_emptyfluent(PC, VarName, Type), write(asm_emptyfluent(PC, VarName)),write(Env),nl,
                        createPDDLEmptyFluent(Value, Type),
                        set(Env, NewEnv, VarName, Value),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_exists(PC, VarName, List), write(asm_exists(PC, VarName, List)),write(Env),nl,
                        resolveVarsList(List, Env, ListValue),
                        write(ListValue), nl,
                        outputPDDLExists(ListValue, Value),
                        set(Env, NewEnv, VarName, Value),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_assert(PC, VarName), write(asm_assert(PC, VarName)),write(Env),nl,
                        get(Env, VarName, Value), write(Value), nl,
                        getPLState(Env, PLState),
                        outputPDDLAssert(Value, PLState),
                        PC1 is PC+1,
                        executecode(PC1, Env).

executecode(PC, Env) :- asm_jump(PC, NewPC), write(asm_jump(PC, NewPC)),write(Env),nl,
                        executecode(NewPC, Env).

%todo, falls bool entscheiden

executecode(PC, Env) :- asm_conditionaljump(PC, BoolVariable, NewPC), write(asm_conditionaljump(PC, BoolVariable, NewPC)),write(Env),nl,
                        get(Env, BoolVariable, vbool(Value)),
                        PC1 is PC+1,
                        write(jumpvalue(Value)), nl,
                        (Value = 1,!,
                        executecode(NewPC, Env);
                        Value = 0, executecode(PC1, Env)).

executecode(PC, Env) :- asm_conditionaljump(PC, BoolVariable, NewPC), write(asm_conditionaljump(PC, BoolVariable, NewPC)),write(Env),nl,
                        get(Env, BoolVariable, vvarb(Value)),
                        PC1 is PC+1,
                        pathBegin(Value, Variable),(
                        executecode(NewPC, Env);
                        pathElse(Variable),
                        executecode(PC1, Env);
                        pathEnd(Variable), fail).

executecode(PC, Env) :- asm_wait(PC, Variable), write(asm_wait(PC, Variable)),write(Env),nl,
                        setNewPLState(Env, end, Env2),
                        pathWait(Variable),
                        PC1 is PC+1,
                        executecode(PC1, Env2).

executecode(PC, Env) :- asm_pddleffect(PC, List), write(asm_pddleffect(PC, List)),write(Env),nl,

                        resolveVarsList(List, Env, ListValue),
                        write(ListValue), nl,
                        getPLState(Env, PLState),
                        outputEffect(ListValue, PLState),
                        PC1 is PC+1,
                        executecode(PC1, Env).

executecode(PC, Env) :- asm_pddlnoteffect(PC, List), write(asm_pddlnoteffect(PC, List)),write(Env),nl,

                        resolveVarsList(List, Env, ListValue),
                        write(ListValue), nl,
                        getPLState(Env, PLState),
                        outputNotEffect(ListValue, PLState),
                        PC1 is PC+1,
                        executecode(PC1, Env).

executecode(PC, Env) :- asm_tofloat(PC, R, Param1), write(asm_tofloat(PC, R,Param1)),write(Env),nl,
                        get(Env, Param1, Value1),
                        outputPDDLNum([tofloat,  Value1], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).



% asm_add


executecode(PC, Env) :- asm_add(PC, R, Param1, Param2),write(asm_add(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([add,  Value1, Value2], Res), % returns Res, necessary if they are the same
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_sub(PC, R, Param1, Param2),write(asm_sub(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([sub,  Value1, Value2], Res), % returns Res, necessary if they are the same
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_mul(PC, R, Param1, Param2),write(asm_mul(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([mul,  Value1, Value2], Res), % returns Res, necessary if they are the same
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_div(PC, R, Param1, Param2),write(asm_div(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([div,  Value1, Value2], Res), % returns Res, necessary if they are the same
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_less(PC, R, Param1, Param2),write(asm_less(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([less, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_greater(PC, R, Param1, Param2),write(asm_greater(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([greater, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_equal(PC, R, Param1, Param2),write(asm_equal(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([equal, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_eless(PC, R, Param1, Param2),write(asm_eless(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([eless, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_egreater(PC, R, Param1, Param2),write(asm_egreater(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([egreater, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).

executecode(PC, Env) :- asm_logicalor(PC, R, Param1, Param2),write(asm_logicalor(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([logicalor, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).


executecode(PC, Env) :- asm_logicaland(PC, R, Param1, Param2),write(asm_logicaland(PC, R, Param1, Param2)),write(Env),nl,
                        get(Env, Param1, Value1),
                        get(Env, Param2, Value2),
                        outputPDDLNum([logicaland, Value1, Value2], Res),
                        set(Env, NewEnv, R, Res),
                        PC1 is PC+1,
                        write(newenv(NewEnv)),nl,
                        executecode(PC1, NewEnv).
