/***************************************************************************
 *   Copyright (C) 2018 by Staud                                           *
 *   michael.staud@uni-ulm.de                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PDDLLIB_H
#define PDDLLIB_H



#include "frogprolog.h"
#include "prologenvironment.h"
#include "Uti3DCore.h"
#include "UtiString.h"
#include "utilisp.h"

class CRPDDLCompiledAction;

extern CRPDDLCompiledAction* m_compileaction;

enum TRuntimeVariableType {rvtIntegerValue, rctFloatValue, rctBoolValue, rctStringValue, rctAtomValue, rvtIntegerPDDL, rvtFloatPDDL, rvtBoolPDDL, rvtAtomPDDL};

struct SRuntimeVariable
{
    TRuntimeVariableType m_type;
   CUtiIDString m_atom_value;
   double m_float_value;
   int m_integer_value;
   bool m_bool_value;
   inline SRuntimeVariable()
   {
       m_type = rctAtomValue;
       m_float_value = 0;
       m_integer_value = 0;
       m_bool_value = false;
   }
   inline bool operator==(const SRuntimeVariable& var) const
   {
       return m_type == var.m_type && m_float_value == var.m_float_value && m_integer_value == var.m_integer_value && m_bool_value == var.m_bool_value && m_atom_value == var.m_atom_value;
   }
   CUtiString print();
   CUtiString printPDDL(std::set<CUtiIDString> &usedvars);
};

namespace PrologSystem {
SRuntimeVariable fromProlog(FP_term term);
FP_term toProlog(const SRuntimeVariable& var);
Lisp::LObject toLisp(const SRuntimeVariable& var);

bool pl_foreign_outputPDDLNum(FP_term a, FP_term value);
bool pl_foreign_outputPDDLBool (FP_term a, FP_term value);
bool pl_foreign_createPDDLEmptyFluent (FP_term value, FP_term type);
bool pl_foreign_outputPDDLExists (FP_term a, FP_term value);
bool pl_foreign_outputPDDLAssert (FP_term a, FP_term state);
bool pl_foreign_outputEffect (FP_term a, FP_term state);
bool pl_foreign_outputNotEffect (FP_term a, FP_term state);
//bool pl_foreign_outputPrecondition (FP_term a);
//bool pl_foreign_outputNotPrecondition (FP_term a);
bool pl_foreign_pathBegin (FP_term a, FP_term b);
bool pl_foreign_pathElse (FP_term a);
bool pl_foreign_pathEnd (FP_term a);
bool pl_foreign_pathWait(FP_term a);
}
#endif // PDDLLIB_H
